Caffeine
========

**CoArray Fortran Framework of Efficient Interfaces to Network Environments**

Caffeine is a parallel runtime library that aims to support Fortran compilers
with a programming-model-agnostic application interface to various
communication libraries.  Current work is on supporting the Parallel Runtime
Interface for Fortran ([PRIF](#citing-prif-please-use-the-following-publication)) with the [GASNet-EX] exascale-ready networking
middleware.  The Caffeine team anticipates collaborating on separate alternative
PRIF implementations using other communication substrates such as the Message
Passing Interface ([MPI]).

![Caffeine system stack diagram](https://github.com/BerkeleyLab/caffeine/wiki/img/caffeine-stack.gif)

Statement of need
-----------------

The Fortran programming language standard added features supporting
single-program, multiple-data (SPMD) parallel programming and loop
parallelism beginning with Fortran 2008.  In Fortran, SPMD programming
involves the creation of a fixed number of images (instances) of a
program that execute asynchronously in shared or distributed memory, except
where a program uses specific synchronization mechanisms.  Fortran's
coarray feature provides distributed data structures that offer a subscripted,
multidimensional array notation defining a partitioned global address space
(PGAS). One image can use a coindexed notation to perform one-sided access
of coarray data associated with another image.

Fortran 2018 greatly expanded this feature set to include concepts such as
teams (groupings) of images, events (counting semaphores), collective
subroutines and failed-image detection (fault tolerance). Fortran 2023 provided
additional, minor multi-image extensions, including notified remote data access.

Several popular Fortran compilers, including [LLVM Flang](https://flang.llvm.org/docs/FortranStandardsSupport.html)
and [LFortran](https://github.com/lfortran/lfortran), currently
lack complete support for multi-image parallel execution. These features are a mandatory
part of Fortran, and thus are an important part of reaching full compliance with
the 2008, 2018, or 2023 revisions of the Fortran standard.
The latest LLVM Flang 22 release adds experimental support for a 
[meaningful subset](https://flang.llvm.org/docs/FortranStandardsSupport.html#fortran-2018)
of multi-image Fortran features using PRIF and Caffeine. 
For more details, see [LLVM-HPC2025 paper](#Additional-Publications) below.

Caffeine provides a portable, high-performance and open-source parallel
runtime library that compilers can target in code generation as part of
their solution to support Fortran's multi-image parallel features.

Prerequisites & Dependencies
-------------
### Build prerequisites
The `install.sh` script uses the following packages:
* Fortran and C compilers
    * We regularly test with: LLVM Flang versions 19:22 and GNU Fortran versions 13:15
* [Fortran package manager] `fpm`
* [pkg-config]
* [realpath]
* [make]
* [git]
* [curl]

The script will invoke these if present in a user's `PATH`.
If not present, the script will ask permission to use [Homebrew] to install the relevant package
or, in some cases, ask the user to install the package.

### Build dependencies

Caffeine also depends on the following packages that will be automatically installed as part
of the build process.

* [GASNet-EX] exascale networking middleware
* [assert](https://go.lbl.gov/assert)
* [julienne](https://go.lbl.gov/julienne)

Caffeine leverages the following non-parallel features of Fortran to simplify the writing of a portable, compact runtime-library that supports Fortran's parallel features:

| Feature                                   | Introduced in |
|-------------------------------------------|---------------|
| The `iso_c_binding` module                | Fortran 2003  |
| The `contiguous` attribute                | Fortran 2008  |
| Submodule support [1]                     | Fortran 2008  |
| The `ISO_Fortran_binding.h` C header file | Fortran 2018  |
| Assumed-type dummy arguments: `type(*)`   | Fortran 2018  |
| Assumed-rank dummy arguments: `array(..)` | Fortran 2018  |


[1] This feature simplifies development but is not essential to the package

Download, build, and run an example
-----------------------------------
Here is an outline of the basic commands used to build Caffeine and run an example:

```
git clone https://github.com/BerkeleyLab/caffeine.git
cd caffeine
env FC=<Fortran-compiler> CC=<C-compiler> CXX=<C++-compiler> ./install.sh <options>
env CAF_IMAGES=8 ./run-fpm.sh run --example hello
```

If `$FC` or `$CC` are unset, then `install.sh` will look for LLVM-based compilers in
the `PATH`, and failing that, offer to install such compilers using Homebrew.

The selected compilers MUST be "compatible": for the best experience you are
HIGHLY recommended to specify the language frontends provided by a single version
of a given compiler suite installation. The C++ compiler is optional for
single-node deployments (and can be disabled using command-line option `--without-cxx`), 
but C++ is required for some network backends.

*Note for macOS/Homebrew users*: Homebrew may be used to install
[LLVM flang](https://formulae.brew.sh/formula/flang) for use with Caffeine, however
by default Homebrew will not replace the incompatible Apple-provided `clang` in your `PATH`.
Such users are recommended to use Homebrew's matching LLVM C/C++ compilers
(usually installed in `/opt/homebrew/opt/llvm/bin`)
to ensure that a matching set of LLVM compilers are used. 

The `install.sh` recognizes a number of command-line options and environment variables to
customize behavior for your system. See the output of `./install.sh --help` for full documentation,
including options for how to build for a distributed-memory platform.


Example Usage
-------------
The Caffeine parallel runtime is intended as an embedded compilation target
library, to provide multi-image parallel runtime support to a Fortran compiler.
As such, real usage of Caffeine is specific to the host Fortran compiler, and
one should consult compiler-provided documentation regarding the use of Caffeine
to back multi-image features.

However we provide an [example hello world program](example/hello.F90), 
written in Fortran, simulating the PRIF calls that a theoretical
source-to-source Fortran compiler might generate for a simple program written
using Fortran's multi-image features to print a message from each image.

Run tests
---------

After installation, one can optionally issue the following command to run
Caffeine's correctness unit tests to exercise the PRIF subroutines:

```
./run-fpm.sh test
```

Note that some unit tests are conditionally skipped based on platform and configuration details.

Recognized Environment Variables
--------------------------------

The following environment variables control the execution of the `fpm`-driven Caffeine unit test suite:

* `CAF_IMAGES`: integer that indicates the number of images to run
* `SUBJOB_PREFIX`: command prefix to use for recursive `fpm` invocations in the test suite. 
   Set `SUBJOB_PREFIX=skip` to disable such invocations (recommended for distributed-memory systems).

The following environment variables control the behavior of the Caffeine library:

* `CAF_HEAP_SIZE=128MB`: set the size of the shared-memory heap used for coarray storage, defaults to 128 MiB
* `CAF_COMP_FRAC=0.10`: set the fraction of the shared-memory heap reserved for non-symmetric allocation, defaults to 10%

Caffeine is built atop the [GASNet-EX] exascale networking middleware, which has its own
set of environment variable knobs to control network-level behavior. 
Here are *a few* of the most useful GASNet knobs:

* `GASNET_VERBOSEENV=1`: enable console output of all the envvar settings affecting GASNet operation
* `GASNET_SPAWN_VERBOSE=1`: enable verbose console output of parallel job-spawning steps
* `GASNET_BACKTRACE=1`: enable automatic backtrace upon fatal errors
* `GASNET_SSH_SERVERS="host1 host2"`: space-deliminted list of hostnames for distributed-memory job launch using the ssh-spawner

See [GASNet documentation](https://gasnet.lbl.gov/dist-ex/README) for full details on all settings.

PRIF Implementation Status
--------------------------

### Caffeine is an implementation of the [Parallel Runtime Interface for Fortran (PRIF)](#citing-prif-please-use-the-following-publication)

<img src="https://github.com/BerkeleyLab/prif-pubs/raw/main/img/PRIF-logo.gif" width="45%" align=top> <img src="https://github.com/BerkeleyLab/caffeine/wiki/img/prif-stack.gif" width="45%">

For details on the PRIF features that are implemented, please see the [Implementation Status doc](docs/implementation-status.md).

Publications
------------

### Citing Caffeine? Please use the following publication:

Damian Rouson, Dan Bonachea.   
"[**Caffeine: CoArray Fortran Framework of Efficient Interfaces to Network Environments**](https://github.com/BerkeleyLab/caffeine/wiki/pubs/Caffeine_for_LLVM-2022.pdf)",     
Proceedings of the [Eighth Annual Workshop on the LLVM Compiler Infrastructure in HPC (LLVM-HPC2022)](https://web.archive.org/web/20230605003029/https://llvm-hpc-2022-workshop.github.io/), November 2022.    
Paper: <https://doi.org/10.25344/S4459B>     
[Talk Slides](https://github.com/BerkeleyLab/caffeine/wiki/pubs/Caffeine_for_LLVM-2022-Slides.pdf)

### Citing PRIF? Please use the following publication:

Dan Bonachea, Katherine Rasmussen, Brad Richardson, Damian Rouson.    
"[**Parallel Runtime Interface for Fortran (PRIF): A Multi-Image Solution for LLVM Flang**](https://github.com/BerkeleyLab/caffeine/wiki/pubs/LLVM-HPC24_PRIF.pdf)",     
Proceedings of the [Tenth Annual Workshop on the LLVM Compiler Infrastructure in HPC (LLVM-HPC2024)](https://web.archive.org/web/20241006163246/https://llvm-hpc-2024-workshop.github.io/), November 2024.    
Paper: <https://doi.org/10.25344/S4N017>    
[Talk Slides](https://github.com/BerkeleyLab/caffeine/wiki/pubs/LLVM-HPC24_PRIF_Slides.pdf)

### PRIF Specification:

PRIF Committee.    
"[**Parallel Runtime Interface for Fortran (PRIF) Specification, Revision 0.7**](https://github.com/BerkeleyLab/caffeine/wiki/pubs/PRIF_0.7.pdf)",     
Lawrence Berkeley National Laboratory Technical Report (LBNL-2001721), Dec 2025.    
<https://doi.org/10.25344/S46S3W>

### Additional Publications:

Dan Bonachea, Katherine Rasmussen, Damian Rouson, Jean-Didier Pailleux, Etienne Renault, Brad Richardson.    
"[**Lowering and Runtime Support for Fortran's Multi-Image Parallel Features using LLVM Flang, PRIF, and Caffeine**](https://github.com/BerkeleyLab/caffeine/wiki/pubs/LLVM-HPC25_FlangPRIFCaffeine.pdf)",    
Proceedings of the [Eleventh Annual Workshop on the LLVM Compiler Infrastructure in HPC (LLVM-HPC2025)](https://llvm-in-hpc-workshop.github.io/LLVM-HPC-2025-Workshop.github.io/), November 2025.    
Paper: <https://doi.org/10.25344/S4G883>    
[Talk Slides](https://github.com/BerkeleyLab/caffeine/wiki/pubs/LLVM-HPC25_FlangPRIFCaffeine_Slides.pdf)

Funding
-------
The Computer Languages and Systems Software ([CLaSS]) Group at [Berkeley Lab] has developed Caffeine 
on funding from the Exascale Computing Project ([ECP](https://www.exascaleproject.org)) 
and the Stewardship for Programming Systems and Tools ([S4PST](https://s4pst.org)) project,
part of the Consortium for the Advancement of Scientific Software ([CASS](https://cass.community/)).

Support and Licensing
---------------------
See [CONTRIBUTING.md](CONTRIBUTING.md) for guidelines on reporting defects, feature requests and contributing to Caffeine.

See [LICENSE.txt](LICENSE.txt) for usage terms and conditions.

[GASNet-EX]: https://gasnet.lbl.gov
[CLaSS]: https://go.lbl.gov/class
[Berkeley Lab]: https://lbl.gov
[MPI]: https://www.mpi-forum.org
[Homebrew]: https://brew.sh
[Fortran package manager]: https://github.com/fortran-lang/fpm
[pkg-config]: https://www.freedesktop.org/wiki/Software/pkg-config/
[realpath]: https://man7.org/linux/man-pages/man3/realpath.3.html
[make]: https://www.gnu.org/software/make/
[git]: https://git-scm.com
[curl]: https://curl.se

README-maintainers.md
========


Conventions for Git and Pull Requests
-------------

This repository follows the [fork-and-pull](https://docs.github.com/en/pull-requests/collaborating-with-pull-requests/getting-started/about-collaborative-development-models#fork-and-pull-model) model of development.
If you would like to contribute some changes, please
[fork](https://docs.github.com/en/pull-requests/collaborating-with-pull-requests/working-with-forks) this repository,
push your proposed edits to a feature branch in your fork, and then
[open a pull request](https://docs.github.com/en/pull-requests/collaborating-with-pull-requests/proposing-changes-to-your-work-with-pull-requests) against this repo when the changes are ready for review.


This repository aims to maintain a strictly linear git history. In order to achieve this, please
observe the following workflow:

* After your PR has been approved, your feature branch will be rebased onto `origin/main` before merge.
* In general you should try to avoid rebasing a non-draft PR with pending approvals until the
  last step before merge, because it complicates iterative review.
* Only after your feature branch is up-to-date with `origin/main` may it then be merged
  into `main` with a merge commit.

Additional git policies for the primary Caffeine repository:

* Never force push to `main`
* All code changes and non-trivial documentation changes require a pull request
* No stray branches, except for rare cases of long-lived parallel development

Conventions for code and commits in Caffeine
-------------
[TODO: Improve wording of below bullets]
* All Fortran filenames must have a `*.F90` suffix
* Procedures with `prif_` prefix are public facing procedures
* Procedures with `caf_` prefix are private procedures,
  internal to Caffeine, which are implemented in C
* Procedures with neither of the above two prefixes are private procedures,
  internal to Caffeine, which are implemented in Fortran
* C functions and global variables lacking a `caf_` prefix must be `static`
* Identifiers named `image` and `rank` refer to processes. Any identifier named `image` represents
  the process as 1-based number (Fortran-style), while `rank` represents the process as 0-based
  number (C-style) (i.e. rank == image - 1)
* When writing or making changes to BIND(C) interfaces, be vigilant when checking that the types
  and attributes of the arguments and return values are equivalent across the Fortran and
  C declarations
* Avoid committing whitespace-only changes to source lines distant from meaningful PR changes. In
  particular disable source editor features that automatically reformat entire files.
* If you absolutely must make whitespace-only changes to otherwise unmodified lines
  (for example, rewrapping the lines in documentation), please isolate those changes
  in a separate commit with a commit message explaining the lack of meaningful change.
* Similarly if you need to move blocks of lines unchanged between distant locations or rename files,
  please also isolate those changes in a separate commit with a commit message 
  explaining the lack of meaningful change.
* Tab characters should NEVER appear in source code

Conventions for test code
-------------------------
* All significant features should have non-trivial correctness tests in `test/`
* Every PRIF procedure must be invoked by at least one test
* Correctness tests should aim to achieve complete code coverage of internal paths,
  and exercise any important corner-cases.
* Test functions should return a Julienne `test_diagnosis_t` named `diag`
  - If a complete diagnosis can be computed using a single Fortran expression `expr`,
    then the statement `diag = expr` should appear near the end of the procedure.
  - Otherwise, the statement `diag = .true.` must appear as the first executable
    statement in the procedure, and the `ALSO/ALSO2` macros defined by 
    [test-utils.F90](../test/test-utils.F90) should be invoked to build an incremental diagnosis.

README-release.md
========

Release Procedure for Caffeine
-------------
1. Nominate a Release Manager with primary responsibility for ensuring each step in this
   procedure is followed
2. Ensure there are no open issues marked with `release-blocker` label
3. Validate correctness testing has been performed across all supported systems and supported
   versions of external dependencies
4. Complete release related chores in repository files
    1. Update all instances of the copyright year embedded in: [LICENSE.txt](../LICENSE.txt),
       [manifest/fpm.toml.template](../manifest/fpm.toml.template)
    2. Update all instances of the release package version number embedded in:
       [manifest/fpm.toml.template](../manifest/fpm.toml.template), [install.sh](../install.sh)
    3. Update the author list embedded in: [manifest/fpm.toml.template](../manifest/fpm.toml.template)
    4. Review top-level [README.md](../README.md) and other user-facing documentation for any
       necessary changes
    5. Update [docs/implementation-status.md](../docs/implementation-status.md) with current status
    6. If the PRIF specification revision is changing, search and update all instances of the old revision,
       including `CAF_PRIF_VERSION_{MAJOR,MINOR}` in [language-support.F90](../include/language-support.F90)
    7. Temporarily hardcode version of gasnet installer in [install.sh](../install.sh) as the
       last commit in the release. Set GASNET_VERSION flag to the latest gasnet release
5. Produce the ChangeLog
    1. Create draft release on GitHub
    2. Review/edit the automated ChangeLog
    3. Add/update list of supported features/platforms
    4. Add/update list of high-level changes since last release
    5. Add/update list of known defects/limitations
    6. Spell-check and proofread
6. Tag a release candidate. For example `git tag #.#.#-rc1`, then `git push origin #.#.#-rc1`
7. Compel several people to manually validate the release candidate on systems of interest
   and with compilers and compiler versions listed in README
    1. When possible, test both on shared and distributed memory systems.
    2. When testing on Perlmutter, use the following steps:
        1. Build source and tests on the login node using the desired compiler
        2. Get a dedicated node: `salloc -t 10 -N 2 -n 8 -q interactive -A PROJECT_ID -C cpu`
        3. Launch the parallel job to run the tests: `env SUBJOB_PREFIX=skip GASNET_SPAWN_VERBOSE=1 GASNET_SUPERNODE_MAXSIZE=2 CAF_IMAGES=8 build/run-fpm.sh test --verbose`
8. Create annotated tag (only after release candidate has been checked by team members)
    For example `git tag -a #.#.# -m "release version #.#.#"`, then `git push origin #.#.#`
9. Publish the release
10. Post release chores
    1. Git revert the commit that hardcoded the gasnet version or manually edit
    2. Update patch number of the version number embedded in:
       [manifest/fpm.toml.template](../manifest/fpm.toml.template), [install.sh](../install.sh)
       Update to an odd number to indicate that the `main` branch is currently a snapshot of something
       that is beyond the offical release
    3. Update the release procedure with any new steps or changes

Test Support
------------
The programs in this directory intentionally terminate to support the `stop` and `error stop` 
unit tests, which use Fortran's `execute_command_line` to run the programs in this directory 
and to check for the expected non-zero stop codes.  Running the tests in this manner enables 
the tests to continue executing after the child process launched by `execute_command_line` 
terminates.

! Copyright (c), The Regents of the University of California
! Terms of use are as specified in LICENSE.txt

#include "assert_macros.h"
    
submodule(prif:prif_private_s) events_s
  ! DO NOT ADD USE STATEMENTS HERE
  ! All use statements belong in prif_private_s.F90
  implicit none

contains

  module procedure prif_event_post
    integer(c_intptr_t) :: remote_base

    call_assert(coarray_handle_check(coarray_handle))
    call_assert(offset >= 0)

    call base_pointer(coarray_handle, image_num, remote_base)
    call prif_event_post_indirect( &
        image_num = image_num, &
        event_var_ptr = remote_base + offset, &
        stat = stat, errmsg = errmsg, errmsg_alloc = errmsg_alloc)
  end procedure

  module procedure prif_event_post_indirect
    call_assert_describe(image_num > 0 .and. image_num <= initial_team%num_images, "image_num not within valid range")

    call caf_event_post(image_num, event_var_ptr, &
           segment_boundary=1, release_fence=1)

    if (present(stat)) stat = 0
  end procedure

  module procedure prif_event_wait
    integer(c_int64_t) :: threshold

    if (present(until_count)) then
      threshold = MAX(until_count, 1)
    else
      threshold = 1
    endif
    call caf_event_wait(event_var_ptr, threshold, &
           segment_boundary=1, acquire_fence=1)

    if (present(stat)) stat = 0
  end procedure

  module procedure prif_event_query
    call caf_event_query(event_var_ptr, count) 

    if (present(stat)) stat = 0
  end procedure

  module procedure prif_notify_wait
    integer(c_int64_t) :: threshold

    if (present(until_count)) then
      threshold = MAX(until_count, 1)
    else
      threshold = 1
    endif
    call caf_event_wait(notify_var_ptr, threshold, &
           segment_boundary=0, acquire_fence=1)

    if (present(stat)) stat = 0
  end procedure

end submodule events_s

! Copyright (c), The Regents of the University of California
! Terms of use are as specified in LICENSE.txt
submodule(prif:prif_private_s) program_startup_s
  ! DO NOT ADD USE STATEMENTS HERE
  ! All use statements belong in prif_private_s.F90
  implicit none
contains

  module procedure prif_init
    use ieee_arithmetic, only: ieee_inexact, ieee_set_flag
    logical, save :: prif_init_called_previously = .false.

    if (prif_init_called_previously) then
       stat = PRIF_STAT_ALREADY_INIT
    else
       call caf_caffeinate( &
          total_heap_size, &
          initial_team%heap_mspace, &
          initial_team%heap_start, &
          initial_team%heap_size, &
          non_symmetric_heap_mspace, &
          initial_team%gex_team)
       call assert_init()
       current_team%info => initial_team
       initial_team%parent_team => initial_team
       initial_team%team_number = -1
       initial_team%this_image = caf_this_image(initial_team%gex_team)
       initial_team%num_images = caf_num_images(initial_team%gex_team)
       non_symmetric_heap_size = total_heap_size - initial_team%heap_size

       call sync_init()

       ! issue #259: Ensure we clear any IEEE FP exceptions potentially
       ! signalled from within the C-based initialization code above
       call ieee_set_flag(ieee_inexact, .false.)

       prif_init_called_previously = .true.
       stat = 0
    end if
  end procedure

#if ASSERT_PARALLEL_CALLBACKS
    subroutine assert_init()
      implicit none
      assert_this_image => assert_callback_this_image
      assert_error_stop => assert_callback_error_stop
    end subroutine
    pure function assert_callback_this_image() result(this_image_id)
      implicit none
      integer :: this_image_id
    
      this_image_id = initial_team%this_image
    end function
    
    pure subroutine assert_callback_error_stop(stop_code_char)
      implicit none
      character(len=*), intent(in) :: stop_code_char
      character(len=:), allocatable, target :: tmp
      tmp = stop_code_char
    
      call caf_fatal_error(tmp)
    end subroutine
#else 
    subroutine assert_init()  
    end subroutine     
#endif

end submodule program_startup_s

! Copyright (c), The Regents of the University of California
! Terms of use are as specified in LICENSE.txt

#include "language-support.F90"

submodule(prif:prif_private_s) teams_s
  ! DO NOT ADD USE STATEMENTS HERE
  ! All use statements belong in prif_private_s.F90
  implicit none
contains

  module procedure prif_change_team
    team%info%heap_start = current_team%info%child_heap_info%offset + current_team%info%heap_start
    team%info%heap_size = current_team%info%child_heap_info%size
    if (caf_this_image(team%info%gex_team) == 1) then ! need to setup the heap for the team
      call caf_establish_mspace( &
          team%info%heap_mspace, &
          as_c_ptr(team%info%heap_start), &
          current_team%info%child_heap_info%size)
    end if
    current_team = team
    if (caf_have_child_teams()) then ! need to establish heap for child teams
      call caf_establish_child_heap
    end if
    call prif_sync_all ! child team sync required by F23 11.1.5.2

    if (present(stat)) stat = 0
  end procedure

  module procedure prif_end_team
    type(prif_coarray_handle), allocatable :: teams_coarrays(:)
    integer :: num_coarrays_in_team, i
    type(prif_coarray_descriptor), pointer :: tmp_data

    ! deallocate the teams coarrays
    ! Currently we work to batch together all the deallocations into a single call
    ! to prif_deallocate_coarray(), in the hope it can amortize some costs
    num_coarrays_in_team = 0
    tmp_data => current_team%info%coarrays
    do while (associated(tmp_data))
      num_coarrays_in_team = num_coarrays_in_team + 1
      call c_f_pointer(tmp_data%next_handle, tmp_data)
    end do
    if (num_coarrays_in_team > 0) then
      allocate(teams_coarrays(num_coarrays_in_team))
      tmp_data => current_team%info%coarrays
      do i = 1, num_coarrays_in_team
        teams_coarrays(i)%info => tmp_data
        call c_f_pointer(tmp_data%next_handle, tmp_data)
      end do
#if CAF_PRIF_VERSION <= 6
      call prif_deallocate_coarray &
#else
      call prif_deallocate_coarrays &
#endif
                (teams_coarrays, stat, errmsg, errmsg_alloc)
      nullify(current_team%info%coarrays)
    else
      ! child team sync required by F23 11.1.5.2,
      ! because we skipped the prif_deallocate_coarray call above that includes same
      call prif_sync_all
    end if

    ! set the current team back to the parent team
    current_team%info => current_team%info%parent_team

    if (present(stat)) stat = 0
  end procedure

  module procedure prif_form_team
    call prif_sync_memory

    ! indicates this is the first time we're creating a child team
    if (.not.caf_have_child_teams()) then
      allocate(current_team%info%child_heap_info)
      call caf_establish_child_heap
    end if

    block
      integer(c_int) :: new_index_
      if (present(new_index)) then
        new_index_ = new_index
      else
        new_index_ = 1
      end if

! DOB: The two allocates in this procedure do not have a corresponding deallocate, 
! because Fortran lacks a destroy team operation. We consider this to represent
! a defect in the Fortran design of teams.
! As such, team-specific state such as these data structures and the corresponding 
! team-related data structures in GASNet can never be reclaimed.
      allocate(team%info)
      team%info%parent_team => current_team%info
      call caf_form_team(current_team%info%gex_team, team%info%gex_team, team_number, new_index_)
      team%info%team_number = team_number
      team%info%this_image = caf_this_image(team%info%gex_team)
      team%info%num_images = caf_num_images(team%info%gex_team)
    end block

    if (present(stat)) stat = 0
  end procedure

  module procedure prif_get_team
    if (.not. present(level)) then
      team = current_team
    else if (level == PRIF_CURRENT_TEAM) then
      team = current_team
    else if (level == PRIF_PARENT_TEAM) then
      team = prif_team_type(current_team%info%parent_team)
    else if (level == PRIF_INITIAL_TEAM) then
      team = prif_team_type(initial_team)
    else
      call prif_error_stop(.false._c_bool, stop_code_char="prif_get_team: invalid level")
    endif
  end procedure

  module procedure prif_team_number
    if (present(team)) then
      team_number = team%info%team_number
    else
      team_number = current_team%info%team_number
    endif
  end procedure

end submodule

module prif_sync_images_test_m
    use iso_c_binding, only: c_int
    use prif, only : prif_sync_images, prif_this_image_no_coarray, prif_num_images, prif_sync_all
    use julienne_m, only: test_description_t, test_diagnosis_t, test_result_t, test_t, usher

    implicit none
    private
    public :: prif_sync_images_test_t

    type, extends(test_t) :: prif_sync_images_test_t
    contains
      procedure, nopass, non_overridable :: subject
      procedure, nopass, non_overridable :: results
    end type
 
    integer, parameter :: lim = 10

contains

    pure function subject() result(test_subject)
      character(len=:), allocatable :: test_subject
      test_subject = "prif_sync_images"
    end function

    function results() result(test_results)
        type(test_result_t), allocatable :: test_results(:)
        type(prif_sync_images_test_t) prif_sync_images_test

        allocate(test_results, source = prif_sync_images_test%run([ &
           test_description_t("synchronizing an image with itself", usher(check_serial)), &
           test_description_t("synchronizing with a neighbor", usher(check_neighbor)), &
           test_description_t("synchronizing every image with one image", usher(check_hot)) &
        ]))
    end function

    function check_serial() result(diag)
        type(test_diagnosis_t) :: diag
        integer(c_int) :: me
        integer i

        call prif_this_image_no_coarray(this_image=me)
        call prif_sync_all
       
        ! synchronize with myself an image-dependent number of times:
        do i=1, lim*me
          call prif_sync_images([me])
        end do

        call prif_sync_all
        diag = .true.
    end function


    function check_neighbor() result(diag)
        type(test_diagnosis_t) :: diag
        integer(c_int) me, num_imgs
        integer i

        call prif_this_image_no_coarray(this_image=me)
        call prif_num_images(num_images=num_imgs)
        call prif_sync_all
       
        ! test based on F23 11.7.4 note 3
        do i=1, lim
          if (me > 1)        call prif_sync_images([me-1])
          if (me < num_imgs) call prif_sync_images([me+1])
        end do

        call prif_sync_all
        diag = .true.
    end function

    function check_hot() result(diag)
        type(test_diagnosis_t) :: diag
        integer(c_int) :: me, num_imgs
        integer :: i

        call prif_this_image_no_coarray(this_image=me)
        call prif_num_images(num_images=num_imgs)
        call prif_sync_all
       
        ! all images synchronize with 1
        if (me == 1) then
          block
            integer(c_int) :: everyone(num_imgs)
            everyone = [(i, i=1,num_imgs)]
            do i=1, lim
              ! SYNC IMAGES (*)
              call prif_sync_images()
            end do
            do i=1, lim
              call prif_sync_images(everyone)
            end do
          end block
        else
          do i=1, lim*2
            call prif_sync_images([1])
          end do
        endif

        call prif_sync_all
        diag = .true.
    end function

end module prif_sync_images_test_m

module prif_co_sum_test_m
    use iso_c_binding, only: c_int8_t, c_int16_t, c_int32_t, c_int64_t, c_float, c_double
    use prif, only : prif_co_sum, prif_num_images, prif_this_image_no_coarray
    use julienne_m, only: &
       operator(.all.) &
      ,operator(.also.) &
      ,operator(.approximates.) &
      ,operator(.equalsExpected.) &
      ,operator(.within.) &
      ,usher &
      ,test_description_t &
      ,test_diagnosis_t &
      ,test_result_t &
      ,test_t

    implicit none
    private
    public :: prif_co_sum_test_t

    type, extends(test_t) :: prif_co_sum_test_t
    contains
      procedure, nopass, non_overridable :: subject
      procedure, nopass, non_overridable :: results
    end type

contains

  pure function subject() result(test_subject)
    character(len=:), allocatable :: test_subject
    test_subject = "prif_co_sum"
  end function

  function results() result(test_results)
    type(test_result_t), allocatable :: test_results(:)
    type(prif_co_sum_test_t) prif_co_sum_test

      allocate(test_results, source = prif_co_sum_test%run([ &
         test_description_t("computing the element-wise sum of a 1D default integer array", usher(check_default_integer)) &
        ,test_description_t("computing the element-wise sum of a 1D 8-bit integer(c_int8_t) array", usher(check_8_bit_integer)) &
        ,test_description_t("computing the element-wise sum of a 1D 16-bit integer(c_int16_t) array", usher(check_16_bit_integer)) &
        ,test_description_t("computing the element-wise sum of integer(c_int32_t) scalars", usher(check_32_bit_integer)) &
        ,test_description_t("computing the element-wise sum of a 1D 64-bit integer(c_int64_t) array", usher(check_64_bit_integer)) &
        ,test_description_t("computing the element-wise sum of a 2D 32-bit real(c_float) array", usher(check_32_bit_real)) &
        ,test_description_t("computing the element-wise sum of a 1D 64-bit real(c_double) array", usher(check_64_bit_real)) &
        ,test_description_t("computing the element-wise sum of a 2D complex(c_float) array", usher(check_32_bit_complex)) &
        ,test_description_t("computing the element-wise sum of a 1D complex(c_double) array", usher(check_64_bit_complex)) &
      ]))
  end function

  function check_default_integer() result(diag)
      type(test_diagnosis_t) :: diag

      integer, parameter :: values(*,*) = reshape([1, -19, 5, 13, 11, 7, 17, 3], [2, 4])
      integer :: me, ni, i
      integer, dimension(size(values,1)) :: my_val, expected

      call prif_this_image_no_coarray(this_image=me)
      call prif_num_images(ni)

      my_val = values(:, mod(me-1, size(values,2))+1)
      call prif_co_sum(my_val)

      expected = sum(reshape([(values(:, mod(i-1,size(values,2))+1), i = 1, ni)], [size(values,1),ni]), dim=2)
      diag = .all. (my_val .equalsExpected. expected)
  end function

  function check_8_bit_integer() result(diag)
      type(test_diagnosis_t) :: diag

      integer(c_int8_t), parameter :: values(*,*) = reshape(int([1, -19, 5, 13, 11, 7, 17, 3],c_int8_t), [2, 4])
      integer :: me, ni, i
      integer(c_int8_t), dimension(size(values,1)) :: my_val, expected

      call prif_this_image_no_coarray(this_image=me)
      call prif_num_images(ni)

      my_val = values(:, mod(me-1, size(values,2))+1)
      call prif_co_sum(my_val)

      expected = sum(reshape([(values(:, mod(i-1,size(values,2))+1), i = 1, ni)], [size(values,1),ni]), dim=2)
      diag = .all. (int(my_val) .equalsExpected. int(expected))
  end function

  function check_16_bit_integer() result(diag)
      type(test_diagnosis_t) :: diag

      integer(c_int16_t), parameter :: values(*,*) = reshape(int([1, -19, 5, 13, 11, 7, 17, 3],c_int16_t), [2, 4])
      integer :: me, ni, i
      integer(c_int16_t), dimension(size(values,1)) :: my_val, expected

      call prif_this_image_no_coarray(this_image=me)
      call prif_num_images(ni)

      my_val = values(:, mod(me-1, size(values,2))+1)
      call prif_co_sum(my_val)

      expected = sum(reshape([(values(:, mod(i-1,size(values,2))+1), i = 1, ni)], [size(values,1),ni]), dim=2)
      diag = .all. (int(my_val) .equalsExpected. int(expected))
  end function

  function check_32_bit_integer() result(diag)
      type(test_diagnosis_t) :: diag

      integer(c_int32_t), parameter :: values(*) = [1, -19, 5, 13, 11, 7, 17, 3]
      integer :: me, ni, i
      integer(c_int32_t) :: my_val, expected

      call prif_this_image_no_coarray(this_image=me)
      call prif_num_images(ni)

      my_val = values(mod(me-1, size(values))+1)
      call prif_co_sum(my_val)

      expected = sum([(values(mod(i-1,size(values))+1), i = 1, ni)])
      diag = my_val .equalsExpected. expected
  end function

  function check_64_bit_integer() result(diag)
      type(test_diagnosis_t) :: diag

      integer(c_int64_t), parameter :: values(*,*) = reshape([1, -19, 5, 13, 11, 7, 17, 3], [2, 4])
      integer :: me, ni, i
      integer(c_int64_t), dimension(size(values,1)) :: my_val, expected

      call prif_this_image_no_coarray(this_image=me)
      call prif_num_images(ni)

      my_val = values(:, mod(me-1, size(values,2))+1)
      call prif_co_sum(my_val)

      expected = sum(reshape([(values(:, mod(i-1,size(values,2))+1), i = 1, ni)], [size(values,1),ni]), dim=2)
      diag = .all. (my_val .equalsExpected. expected)
  end function

  function check_32_bit_real() result(diag)
      type(test_diagnosis_t) :: diag

      real(c_float), parameter :: values(*,*,*) = reshape([1, 19, 5, 13, 11, 7, 17, 3], [2,2,2])
      real(c_float), parameter :: tolerance = 0_c_float
      integer :: me, ni, i
      real(c_float), dimension(size(values,1), size(values,2)) :: my_val, expected

      call prif_this_image_no_coarray(this_image=me)
      call prif_num_images(ni)

      my_val = values(:, :, mod(me-1, size(values,3))+1)
      call prif_co_sum(my_val)

      expected = sum(reshape([(values(:,:,mod(i-1,size(values,3))+1), i = 1, ni)], [size(values,1), size(values,2), ni]), dim=3)
      diag = .all. (my_val .approximates. expected .within. tolerance)
  end function

  function check_64_bit_real() result(diag)
      type(test_diagnosis_t) :: diag

      real(c_double), parameter :: values(*,*) = reshape([1, 19, 5, 13, 11, 7, 17, 3], [2, 4])
      real(c_double), parameter :: tolerance = 0_c_double
      integer :: me, ni, i
      real(c_double), dimension(size(values,1)) :: my_val, expected

      call prif_this_image_no_coarray(this_image=me)
      call prif_num_images(ni)

      my_val = values(:, mod(me-1, size(values,2))+1)
      call prif_co_sum(my_val)

      expected = sum(reshape([(values(:, mod(i-1,size(values,2))+1), i = 1, ni)], [size(values,1),ni]), dim=2)
      diag = .all. (my_val .approximates. expected .within. tolerance)
  end function

  function check_32_bit_complex() result(diag)
      type(test_diagnosis_t) :: diag

      complex(c_float), parameter :: values(*,*,*) = reshape( &
              [ cmplx(1., 53.), cmplx(3., 47.) &
              , cmplx(5., 43.), cmplx(7., 41.) &
              , cmplx(11., 37.), cmplx(13., 31.) &
              , cmplx(17., 29.), cmplx(19., 23.) &
              ], &
              [2,2,2])
      real(c_float), parameter :: tolerance = 0_c_float
      integer :: me, ni, i
      complex(c_float), dimension(size(values,1),size(values,2)) :: my_val, expected

      call prif_this_image_no_coarray(this_image=me)
      call prif_num_images(ni)

      my_val = values(:, :, mod(me-1, size(values,3))+1)
      call prif_co_sum(my_val)

      expected = sum(reshape([(values(:,:,mod(i-1,size(values,3))+1), i = 1, ni)], [size(values,1), size(values,2), ni]), dim=3)

      diag = &
        .all. (real(my_val) .approximates. real(expected) .within. tolerance) &
        .also. (.all. (aimag(my_val) .approximates. aimag(expected) .within. tolerance))
  end function

  function check_64_bit_complex() result(diag)
      type(test_diagnosis_t) :: diag

      complex(c_double), parameter :: values(*,*) = reshape( &
              [ cmplx(1., 53.), cmplx(3., 47.) &
              , cmplx(5., 43.), cmplx(7., 41.) &
              , cmplx(11., 37.), cmplx(13., 31.) &
              , cmplx(17., 29.), cmplx(19., 23.) &
              ], &
              [2,4])
      real(c_double), parameter :: tolerance = 0_c_double
      integer me, ni, i
      complex(c_double), dimension(size(values,1)) :: my_val, expected

      call prif_this_image_no_coarray(this_image=me)
      call prif_num_images(ni)

      my_val = values(:, mod(me-1, size(values,2))+1)
      call prif_co_sum(my_val)

      expected = sum(reshape([(values(:,mod(i-1,size(values,2))+1), i = 1, ni)], [size(values,1), ni]), dim=2)

      ! TODO: simplify once Julienne issue #137 is implemented
      diag = &
        .all. (real(my_val, c_double) .approximates. real(expected, c_double) .within. tolerance) &
        .also. (.all. (real(aimag(my_val), c_double) .approximates. real(aimag(expected), c_double) .within. tolerance))
  end function

end module prif_co_sum_test_m

#include "test-utils.F90"

module prif_threaded_test_m
# include "test-uses-alloc.F90"
    use iso_c_binding, only: c_funptr, c_funloc, c_f_procpointer
    use prif, only: &
            prif_notify_type, prif_notify_wait, prif_put_with_notify, &
            prif_this_image_no_coarray, prif_num_images, &
            prif_sync_all
    use julienne_m, only: test_description_t, test_diagnosis_t, test_result_t, test_t, usher 

    implicit none
    private
    public :: prif_threaded_test_t

    type, extends(test_t) :: prif_threaded_test_t
    contains
      procedure, nopass, non_overridable :: subject
      procedure, nopass, non_overridable :: results
    end type

    abstract interface
      pure subroutine pure_allocate_i(size_in_bytes, allocated_memory, stat, errmsg, errmsg_alloc)
        import c_size_t, c_int, c_ptr
        integer(c_size_t), intent(in) :: size_in_bytes
        type(c_ptr), intent(out) :: allocated_memory
        integer(c_int), intent(out), optional :: stat
        character(len=*), intent(inout), optional :: errmsg
        character(len=:), intent(inout), allocatable , optional :: errmsg_alloc
      end subroutine
    end interface

    abstract interface
      pure subroutine pure_deallocate_i(mem, stat, errmsg, errmsg_alloc)
        import c_int, c_ptr
        type(c_ptr), intent(in) :: mem
        integer(c_int), intent(out), optional :: stat
        character(len=*), intent(inout), optional :: errmsg
        character(len=:), intent(inout), allocatable , optional :: errmsg_alloc
      end subroutine
    end interface

    abstract interface
      pure subroutine pure_notify_wait_i(notify_var_ptr, until_count, stat, errmsg, errmsg_alloc)
        import c_int64_t, c_int, c_ptr
        type(c_ptr), intent(in) :: notify_var_ptr
        integer(c_int64_t), intent(in), optional :: until_count
        integer(c_int), intent(out), optional :: stat
        character(len=*), intent(inout), optional :: errmsg
        character(len=:), intent(inout), allocatable , optional :: errmsg_alloc
      end subroutine
    end interface

contains
   pure function subject()
     character(len=:), allocatable :: subject
     subject = "PRIF Thread-safe operations"
   end function

    function results() result(test_results)
        type(test_result_t), allocatable :: test_results(:)
        type(prif_threaded_test_t) prif_threaded_test

        allocate(test_results, source = prif_threaded_test%run([ &
           test_description_t("prif_allocate in do concurrent" &
#           if CAF_THREAD_SAFE
              ,usher(check_allocate) &
#           endif
           ) &
          ,test_description_t("prif_notify_wait in do concurrent" &
#           if CAF_THREAD_SAFE
              ,usher(check_notify) &
#           endif
           ) &
        ]))
    end function

    function check_allocate() result(diag)
        type(test_diagnosis_t) diag
        integer, parameter :: lim = 10000
        integer(c_size_t), parameter :: sz = 64
        integer :: i
        type(c_funptr) :: fp
        procedure(pure_allocate_i), pointer :: pure_allocate
        procedure(pure_deallocate_i), pointer :: pure_deallocate

        diag = .true.

        ! workaround the fact that PRIF routines are not pure,
        ! but a compiler client might still invoke them from within do concurrent
        fp = c_funloc(prif_allocate)
        call c_f_procpointer(fp, pure_allocate)
        fp = c_funloc(prif_deallocate)
        call c_f_procpointer(fp, pure_deallocate)

        do concurrent(i = 1:lim)
          block
            type(c_ptr) :: p
            call pure_allocate(sz, p)
            call pure_deallocate(p)
          end block
        end do
    end function

    function check_notify() result(diag)
        type(test_diagnosis_t) diag

        integer :: me
        type(prif_notify_type) :: dummy_notify
        integer(c_size_t) :: sizeof_notify, sizeof_int
        type(prif_coarray_handle) :: coarray_handle_evt
        type(prif_coarray_handle) :: coarray_handle_ctr
        type(c_ptr) :: allocated_memory
        type(prif_notify_type), pointer :: local_evt
        integer, pointer :: local_ctr
        type(c_funptr) :: fp
        procedure(pure_notify_wait_i), pointer :: pure_notify_wait

        fp = c_funloc(prif_notify_wait)
        call c_f_procpointer(fp, pure_notify_wait)

        diag = .true.
        sizeof_notify = int(storage_size(dummy_notify)/8, c_size_t)
        sizeof_int = c_sizeof(me)
        call prif_this_image_no_coarray(this_image=me)

        ! type(notify_type) :: evt[*]
        call prif_allocate_coarray( &
                [1_c_int64_t], [integer(c_int64_t)::], &
                sizeof_notify, &
                null_final_proc, &
                coarray_handle = coarray_handle_evt, &
                allocated_memory = allocated_memory)
        call c_f_pointer(allocated_memory, local_evt)
        local_evt = dummy_notify ! default initialize

        ! integer :: ctr[*]
        call prif_allocate_coarray( &
                [1_c_int64_t], [integer(c_int64_t)::], &
                sizeof_int, &
                null_final_proc, &
                coarray_handle = coarray_handle_ctr, &
                allocated_memory = allocated_memory)
        call c_f_pointer(allocated_memory, local_ctr)
        local_ctr = 0 ! initialize

        call prif_sync_all

        block
          integer, parameter :: lim = 10000
          integer, target :: i

          do i=1, lim
            ! every image writes to itself with notify
            ! ctr[me, notify=evt] = i
            call prif_put_with_notify( &
                image_num = me, &
                coarray_handle = coarray_handle_ctr, &
                offset = 0_c_size_t, &
                current_image_buffer = c_loc(i), &
                size_in_bytes = sizeof_int, &
                notify_coarray_handle = coarray_handle_evt, &
                notify_offset = 0_c_size_t)
          end do

          do concurrent(i = 1:lim)
            ! NOTIFY WAIT( evt, UNTIL_COUNT=1 )
            call pure_notify_wait(c_loc(local_evt), until_count=1_c_int64_t)
          end do

        end block

        call prif_deallocate_coarrays(([coarray_handle_ctr, coarray_handle_evt]))
    end function

end module

! Copyright (c), The Regents of the University of California
! Terms of use are as specified in LICENSE.txt

#include "assert_macros.h"

submodule(prif:prif_private_s) co_sum_s
  ! DO NOT ADD USE STATEMENTS HERE
  ! All use statements belong in prif_private_s.F90
  implicit none

contains

  module procedure prif_co_sum
    if (present(result_image)) then
      call_assert(result_image >= 1 .and. result_image <= current_team%info%num_images)
    endif
    call contiguous_co_sum(a, result_image, stat, errmsg, errmsg_alloc)
  end procedure

  subroutine contiguous_co_sum(a, result_image, stat, errmsg, errmsg_alloc)
    type(*), intent(inout), target, contiguous :: a(..)
    integer(c_int), intent(in), optional :: result_image
    integer(c_int), intent(out), optional :: stat
    character(len=*), intent(inout), optional :: errmsg
    character(len=:), intent(inout), allocatable, optional :: errmsg_alloc

    if (present(stat)) stat=0

    call caf_co_sum( &
        a, optional_value(result_image), int(product(shape(a)), c_size_t), current_team%info%gex_team)
  end subroutine

end submodule co_sum_s

module prif_image_queries_test_m
    use iso_c_binding, only: c_int
    use prif, only : prif_image_status, prif_stopped_images, prif_failed_images, PRIF_STAT_FAILED_IMAGE, PRIF_STAT_STOPPED_IMAGE
    use prif, only : prif_num_images
    use julienne_m, only: &
       operator(//) &
      ,operator(.all.) &
      ,operator(.also.) &
      ,operator(.isAtLeast.) &
      ,operator(.isAtMost.) &
      ,operator(.lessThan.) &
      ,operator(.expect.) &
      ,usher &
      ,test_description_t &
      ,test_diagnosis_t &
      ,test_result_t &
      ,test_t

    implicit none
    private
    public :: prif_image_queries_test_t

    type, extends(test_t) :: prif_image_queries_test_t 
    contains
      procedure, nopass, non_overridable :: subject
      procedure, nopass, non_overridable :: results
    end type

contains

  pure function subject() result(test_subject)
    character(len=:), allocatable :: test_subject
    test_subject = "PRIF Image Queries"
  end function

  function results() result(test_results)
    type(test_result_t), allocatable :: test_results(:)
    type(prif_image_queries_test_t) prif_image_queries_test

    allocate(test_results, source = prif_image_queries_test%run([ &
       test_description_t("providing valid prif_image_status()", usher(check_image_status)) &
      ,test_description_t("providing valid prif_stopped_images()", usher(check_stopped_images)) &
      ,test_description_t("providing valid prif_failed_images()", usher(check_failed_images)) &
    ]))
  end function

  function check_image_status() result(diag)
      type(test_diagnosis_t) :: diag
      integer(c_int) :: image_status
      
      call prif_image_status(1, image_status=image_status)
      ! TODO: replace with .any. once Julienne issue #138 is implemented
      diag = .expect. (any(image_status == [0, PRIF_STAT_FAILED_IMAGE, PRIF_STAT_STOPPED_IMAGE])) &
                        // "permitted image status"
  end function

  function valid_image_list(nums) result(diag)
      integer, allocatable, intent(in) :: nums(:)
      type(test_diagnosis_t) :: diag
      integer ni

      call prif_num_images(num_images=ni)
      diag = &
          allocated(nums) .also. &
         (size(nums) .isAtMost. ni) .also. &
         (.all. (nums .isAtLeast. 1)) .also. &
         (.all. (nums .isAtMost. ni)) .also. &
         (.all. (nums(1:size(nums)-1) .lessThan. nums(2:size(nums)))) // "valid stopped image"
  end function

  function check_stopped_images() result(diag)
      type(test_diagnosis_t) :: diag
      integer, allocatable :: nums(:)

      call prif_stopped_images(stopped_images=nums)
      diag = valid_image_list(nums)
  end function

  function check_failed_images() result(diag)
      type(test_diagnosis_t) :: diag
      integer, allocatable :: nums(:)

      call prif_failed_images(failed_images=nums)
      diag = valid_image_list(nums)
  end function

end module prif_image_queries_test_m

! Copyright (c), The Regents of the University of California
! Terms of use are as specified in LICENSE.txt

#include "assert_macros.h"
#include "language-support.F90"

submodule(prif:prif_private_s) allocation_s
  ! DO NOT ADD USE STATEMENTS HERE
  ! All use statements belong in prif_private_s.F90
  implicit none

contains

  module procedure prif_allocate_coarray
    ! TODO: determining the size of the handle and where the coarray begins
    !       becomes a bit more complicated if we don't allocate space for
    !       15 cobounds
    integer :: me
    type(c_ptr) :: whole_block
    integer(c_ptrdiff_t) :: block_offset
    integer(c_size_t) :: descriptor_size, total_size
    integer(c_int) :: corank
    type(prif_coarray_descriptor) :: unused
    type(prif_coarray_descriptor), pointer :: unused2(:)

    corank = size(lcobounds)
    call_assert(corank > 0)
    if (size(ucobounds) == corank) then
      call_assert(all(lcobounds <= ucobounds))
      call_assert(product(ucobounds - lcobounds + 1) >= current_team%info%num_images)
    else
      call_assert(size(ucobounds) == corank - 1)
      call_assert(all(lcobounds(1:corank-1) <= ucobounds))
    end if

    me = current_team%info%this_image
    if (caf_have_child_teams()) then
      ! Free the child team space to make sure we have space to allocate the coarray
      if (me == 1) then
        call caf_deallocate(current_team%info%heap_mspace, current_team%info%child_heap_info%allocated_memory)
      end if
    end if
    if (me == 1) then
      descriptor_size = c_sizeof(unused)
      total_size = descriptor_size + size_in_bytes
      whole_block = caf_allocate(current_team%info%heap_mspace, total_size)
      if (.not. c_associated(whole_block)) then
        block_offset = -1 ! out of memory
      else
        block_offset = as_int(whole_block) - current_team%info%heap_start
      end if
    else
      block_offset = 0
    end if
    call prif_sync_memory ! end the current segment
    ! Use a co_sum to aggregate broadcasing the information from image 1
    ! together with the team barrier spec-required by coarray allocation
    call prif_co_sum(block_offset)
    if (block_offset == -1) then ! out of memory - abort allocation attempt
      call report_error(PRIF_STAT_OUT_OF_MEMORY, out_of_memory_message(size_in_bytes, .true.), &
                        stat, errmsg, errmsg_alloc)
      if (caf_have_child_teams()) then ! unroll state change above before return
        call caf_establish_child_heap
      end if
      return
    end if
    if (me /= 1) whole_block = as_c_ptr(current_team%info%heap_start + block_offset)

    call c_f_pointer(whole_block, coarray_handle%info)
    call c_f_pointer(whole_block, unused2, [2])

    coarray_handle%info%coarray_data = c_loc(unused2(2))
    coarray_handle%info%corank = corank
    coarray_handle%info%coarray_size = size_in_bytes
    coarray_handle%info%final_func = final_func
    coarray_handle%info%lcobounds(1:corank) = lcobounds
    coarray_handle%info%ucobounds(1:corank-1) = ucobounds(1:corank-1)
    call compute_coshape_epp(lcobounds, ucobounds, coarray_handle%info%coshape_epp(1:corank))
#   if ASSERTIONS
      ! The following entries are dead, but initialize them to help detect defects
      coarray_handle%info%lcobounds(corank+1:15) = huge(0_c_int64_t)
      coarray_handle%info%ucobounds(corank:14) = -huge(0_c_int64_t)
      coarray_handle%info%coshape_epp(corank+1:15) = 0
#   endif
    coarray_handle%info%previous_handle = c_null_ptr
    coarray_handle%info%next_handle = c_null_ptr
    call add_to_team_list(coarray_handle)
    coarray_handle%info%reserved = c_null_ptr
    coarray_handle%info%p_context_data = c_loc(coarray_handle%info%reserved)

    allocated_memory = coarray_handle%info%coarray_data
    if (caf_have_child_teams()) then
      call caf_establish_child_heap
    end if

    call_assert(coarray_handle_check(coarray_handle))
  end procedure

  module procedure prif_allocate
    type(c_ptr) :: mem

    mem = caf_allocate(non_symmetric_heap_mspace, size_in_bytes)
    if (.not. c_associated(mem)) then
      call report_error(PRIF_STAT_OUT_OF_MEMORY, out_of_memory_message(size_in_bytes, .false.), &
                        stat, errmsg, errmsg_alloc)
    else
      allocated_memory = mem
    end if
  end procedure

  function out_of_memory_message(size_in_bytes, symmetric) result(message)
    integer(c_size_t), intent(in) :: size_in_bytes
    logical, intent(in) :: symmetric
    character(len=:), allocatable :: mem_type
    character(len=:), allocatable :: message

    message = "Fortran shared heap is out of memory"
    if (symmetric) then
      mem_type = "coarray"
    else
      message = message // " on image " // num_to_str(initial_team%this_image)
      mem_type = "non-coarray"
    end if
    message = message // new_line('') &
       // "  while allocating " // num_to_str(size_in_bytes, .true.) // " of additional " &
       // mem_type // " memory." // new_line('') &
       // new_line('') &
       // "  Shared heap size information:" // new_line('') &
       // "    Total shared heap:          " // pad(num_to_str(total_heap_size, .true.)) &
       // "    (CAF_HEAP_SIZE)" // new_line('') &
       // "    Total non-coarray heap:     " // pad(num_to_str(non_symmetric_heap_size, .true.)) &
       // "    (CAF_COMP_FRAC * CAF_HEAP_SIZE)" // new_line('') &
       // "    Current team coarray heap:  " // pad(num_to_str(current_team%info%heap_size, .true.)) // new_line('') &
       // new_line('') &
       // "  Consider setting the CAF_HEAP_SIZE environment variable to request a larger heap."
  contains
    function pad(str) result(s)
      character(len=*), intent(in) :: str
      character(len=:), allocatable :: s
      s = str
      s = repeat(' ',max(0, 10 - len(str))) // s
    end function
  end function

#if CAF_PRIF_VERSION <= 6
  module procedure prif_deallocate_coarray
#else
  module procedure prif_deallocate_coarray
    call prif_deallocate_coarrays([coarray_handle], stat, errmsg, errmsg_alloc)
  end procedure
  module procedure prif_deallocate_coarrays
#endif
    integer :: i, num_handles
    type(prif_coarray_handle), target :: coarray_handle
# if HAVE_FINAL_FUNC_SUPPORT
    abstract interface
      subroutine coarray_cleanup_i(handle, stat, errmsg) bind(C)
        import c_int, prif_coarray_handle
        implicit none
        type(prif_coarray_handle), pointer, intent(in) :: handle
        integer(c_int), intent(out) :: stat
        character(len=:), intent(out), allocatable :: errmsg
      end subroutine
    end interface
    procedure(coarray_cleanup_i), pointer :: coarray_cleanup
    integer(c_int) :: local_stat
    character(len=:), allocatable :: local_errmsg
#endif

    call prif_sync_all ! Need to ensure we don't deallocate anything till everyone gets here
    num_handles = size(coarray_handles)
    if (.not. all([(associated(coarray_handles(i)%info), i = 1, num_handles)])) then
      call report_error(CAF_STAT_INVALID_ARGUMENT, "Attempted to deallocate unallocated coarray", &
                        stat, errmsg, errmsg_alloc)
      return
    end if
    call_assert(all(coarray_handle_check(coarray_handles)))


    ! invoke finalizers from coarray_handles(:)%info%final_func
    do i = 1, num_handles
      coarray_handle = coarray_handles(i) ! Add target attribute
      if (c_associated(coarray_handle%info%final_func)) then
#     if HAVE_FINAL_FUNC_SUPPORT
        call c_f_procpointer(coarray_handle%info%final_func, coarray_cleanup)
        call coarray_cleanup(coarray_handle, local_stat, local_errmsg)
        call prif_co_max(local_stat) ! Need to be sure it didn't fail on any images
        if (local_stat /= 0) then
          if (.not. allocated(local_errmsg)) then ! provide a default errmsg
            local_errmsg = "coarray_cleanup finalization callback failed"
          end if
          call report_error(local_stat, local_errmsg, &
                            stat, errmsg, errmsg_alloc)
          return ! NOTE: We no longer have guarantees that coarrays are in consistent state
        end if
#     else
        ! TODO: issue a warning that we are ignoring the final_func?
#     endif
      end if
    end do

    do i = 1, num_handles
      call remove_from_team_list(coarray_handles(i))
      if (current_team%info%this_image == 1) &
        call caf_deallocate(current_team%info%heap_mspace, c_loc(coarray_handles(i)%info))
    end do
    if (present(stat)) stat = 0
    if (caf_have_child_teams()) then
      ! reclaim any free space possible for the child teams to use
      if (current_team%info%this_image == 1) then
        call caf_deallocate(current_team%info%heap_mspace, current_team%info%child_heap_info%allocated_memory)
      end if
      call caf_establish_child_heap
    end if
  end procedure

  module procedure prif_deallocate
    call caf_deallocate(non_symmetric_heap_mspace, mem)
    if (present(stat)) stat = 0
  end procedure

  subroutine add_to_team_list(coarray_handle)
    type(prif_coarray_handle), intent(in) :: coarray_handle

    call_assert(.not.c_associated(coarray_handle%info%previous_handle))
    call_assert(.not.c_associated(coarray_handle%info%next_handle))

    if (associated(current_team%info%coarrays)) then
      current_team%info%coarrays%previous_handle = c_loc(coarray_handle%info)
      coarray_handle%info%next_handle = c_loc(current_team%info%coarrays)
    end if
    current_team%info%coarrays => coarray_handle%info
  end subroutine

  subroutine remove_from_team_list(coarray_handle)
    type(prif_coarray_handle), intent(in) :: coarray_handle

    type(prif_coarray_descriptor), pointer :: tmp_data

    if (      .not.c_associated(coarray_handle%info%previous_handle) &
        .and. .not.c_associated(coarray_handle%info%next_handle)) then
      call_assert(associated(current_team%info%coarrays, coarray_handle%info))
      nullify(current_team%info%coarrays)
      return
    end if
    if (c_associated(coarray_handle%info%previous_handle)) then
      call c_f_pointer(coarray_handle%info%previous_handle, tmp_data)
      tmp_data%next_handle = coarray_handle%info%next_handle
    else
      call_assert(associated(current_team%info%coarrays, coarray_handle%info))
      call c_f_pointer(coarray_handle%info%next_handle, current_team%info%coarrays)
    end if
    if (c_associated(coarray_handle%info%next_handle)) then
      call c_f_pointer(coarray_handle%info%next_handle, tmp_data)
      tmp_data%previous_handle = coarray_handle%info%previous_handle
    end if
  end subroutine

end submodule allocation_s

#ifndef CAF_INCLUDED_TEST_UTILS
#define CAF_INCLUDED_TEST_UTILS

#ifndef CPP_STRINGIFY_SOURCE
# if defined(__GFORTRAN__) || defined(_CRAYFTN) || defined(NAGFOR) || defined(__LFORTRAN__)
#  define CPP_STRINGIFY_SOURCE(x) "x"
# else
#  define CPP_STRINGIFY_SOURCE(x) #x
# endif
#endif

#ifndef  CPP_LINE_STRING
# if defined(__GFORTRAN__)
    ! work-around Gfortran's defective preprocessor
#   define CPP_LINE_STRING string_t(__LINE__)
# else
#   define CPP_LINE_STRING_HELPER(n) CPP_STRINGIFY_SOURCE(n)
#   define CPP_LINE_STRING CPP_LINE_STRING_HELPER(__LINE__)
# endif
#endif

#define ALSO(exp) ALSO2(exp, "expression: (" // CPP_STRINGIFY_SOURCE(exp) // ")")
#define ALSO2(exp,desc) diag = diag .also. \
                      ( test_diagnosis_t(exp, NEW_LINE('')) // \
                        __FILE__ // ":" // CPP_LINE_STRING // ": FAILED: " // desc )

#endif

! Copyright (c), The Regents of the University of California
! Terms of use are as specified in LICENSE.txt

#include "assert_macros.h"

submodule(prif:prif_private_s) coarray_access_s
  ! DO NOT ADD USE STATEMENTS HERE
  ! All use statements belong in prif_private_s.F90
  implicit none

contains

  ! _______________________ Contiguous Put RMA ____________________________
  module procedure prif_put
    integer(c_intptr_t) :: remote_base

    call_assert(offset >= 0)

    call base_pointer(coarray_handle, image_num, remote_base)
    call prif_put_indirect( &
        image_num = image_num, &
        remote_ptr = remote_base + offset, &
        current_image_buffer = current_image_buffer, &
        size_in_bytes = size_in_bytes, &
        stat = stat, errmsg = errmsg, errmsg_alloc = errmsg_alloc)
  end procedure

  module procedure prif_put_indirect
    call_assert_describe(image_num > 0 .and. image_num <= initial_team%num_images, "image_num not within valid range")

    call caf_put( &
        image = image_num, &
        dest = remote_ptr, &
        src = current_image_buffer, &
        size = size_in_bytes)

    if (present(stat)) stat = 0
  end procedure

  module procedure prif_put_with_notify
    integer(c_intptr_t) :: remote_base
    integer(c_intptr_t) :: notify_remote_base

    call_assert(offset >= 0)
    call_assert(notify_offset >= 0)

    call base_pointer(coarray_handle, image_num, remote_base)
    call base_pointer(notify_coarray_handle, image_num, notify_remote_base)

    call prif_put_indirect_with_notify_indirect( &
        image_num = image_num, &
        remote_ptr = remote_base + offset, &
        current_image_buffer = current_image_buffer, &
        size_in_bytes = size_in_bytes, &
        notify_ptr = notify_remote_base + notify_offset, &
        stat = stat, errmsg = errmsg, errmsg_alloc = errmsg_alloc)
  end procedure

  module procedure prif_put_with_notify_indirect
    integer(c_intptr_t) :: remote_base

    call_assert(offset >= 0)

    call base_pointer(coarray_handle, image_num, remote_base)
    call prif_put_indirect_with_notify_indirect( &
        image_num = image_num, &
        remote_ptr = remote_base + offset, &
        current_image_buffer = current_image_buffer, &
        size_in_bytes = size_in_bytes, &
        notify_ptr = notify_ptr, &
        stat = stat, errmsg = errmsg, errmsg_alloc = errmsg_alloc)
  end procedure

  module procedure prif_put_indirect_with_notify
    integer(c_intptr_t) :: notify_remote_base

    call_assert(notify_offset >= 0)

    call base_pointer(notify_coarray_handle, image_num, notify_remote_base)
    call prif_put_indirect_with_notify_indirect( &
        image_num = image_num, &
        remote_ptr = remote_ptr, &
        current_image_buffer = current_image_buffer, &
        size_in_bytes = size_in_bytes, &
        notify_ptr = notify_remote_base + notify_offset, &
        stat = stat, errmsg = errmsg, errmsg_alloc = errmsg_alloc)
  end procedure

  module procedure prif_put_indirect_with_notify_indirect
    call_assert_describe(image_num > 0 .and. image_num <= initial_team%num_images, "image_num not within valid range")

    call caf_put( &
        image = image_num, &
        dest = remote_ptr, &
        src = current_image_buffer, &
        size = size_in_bytes)
    call caf_event_post(image_num, notify_ptr, &
           segment_boundary=0, release_fence=1)

    if (present(stat)) stat = 0
  end procedure

  ! _______________________ Contiguous Get RMA ____________________________
  module procedure prif_get
    integer(c_intptr_t) :: remote_base

    call_assert(offset >= 0)

    call base_pointer(coarray_handle, image_num, remote_base)
    call prif_get_indirect( &
        image_num = image_num, &
        remote_ptr = remote_base + offset, &
        current_image_buffer = current_image_buffer, &
        size_in_bytes = size_in_bytes, &
        stat = stat, &
        errmsg = errmsg, &
        errmsg_alloc = errmsg_alloc)
  end procedure

  module procedure prif_get_indirect
    call_assert_describe(image_num > 0 .and. image_num <= initial_team%num_images, "image_num not within valid range")

    call caf_get( &
        image = image_num, &
        dest = current_image_buffer, &
        src = remote_ptr, &
        size = size_in_bytes)

    if (present(stat)) stat = 0
  end procedure

  ! _______________________ Strided Get RMA ____________________________
  ! This helper ensures the metadata arrays are contiguous (RMA data may still be non-contiguous)
  subroutine get_strided_helper( &
        image_num, remote_ptr, remote_stride, current_image_buffer, current_image_stride, element_size, extent, &
        stat, errmsg, errmsg_alloc)
    implicit none
    integer(c_int), intent(in) :: image_num
    integer(c_intptr_t), intent(in) :: remote_ptr
    integer(c_ptrdiff_t), intent(in), target, contiguous :: remote_stride(:)
    type(c_ptr), intent(in) :: current_image_buffer
    integer(c_ptrdiff_t), intent(in), target, contiguous :: current_image_stride(:)
    integer(c_size_t), intent(in) :: element_size
    integer(c_size_t), intent(in), target, contiguous :: extent(:)
    integer(c_int), intent(out), optional :: stat
    character(len=*), intent(inout), optional :: errmsg
    character(len=:), intent(inout), allocatable, optional :: errmsg_alloc

    call_assert_describe(image_num > 0 .and. image_num <= initial_team%num_images, "image_num not within valid range")
    call_assert(size(remote_stride) == size(extent))
    call_assert(size(current_image_stride) == size(extent))

    call caf_get_strided( &
        dims = size(extent), &
        image_num = image_num, &
        remote_ptr = remote_ptr, &
        remote_stride = c_loc(remote_stride), &
        current_image_buffer = current_image_buffer, &
        current_image_stride = c_loc(current_image_stride), &
        element_size = element_size, &
        extent = c_loc(extent))

    if (present(stat)) stat = 0
  end subroutine

  module procedure prif_get_strided
    integer(c_intptr_t) :: remote_base

    call_assert(offset >= 0)

    call base_pointer(coarray_handle, image_num, remote_base)
    call prif_get_strided_indirect( &
        image_num = image_num, &
        remote_ptr = remote_base + offset, &
        remote_stride = remote_stride, &
        current_image_buffer = current_image_buffer, &
        current_image_stride = current_image_stride, &
        element_size = element_size, &
        extent = extent, &
        stat = stat, &
        errmsg = errmsg, &
        errmsg_alloc = errmsg_alloc)
  end procedure

  module procedure prif_get_strided_indirect
    call get_strided_helper( &
        image_num = image_num, &
        remote_ptr = remote_ptr, &
        remote_stride = remote_stride, &
        current_image_buffer = current_image_buffer, &
        current_image_stride = current_image_stride, &
        element_size = element_size, &
        extent = extent, &
        stat = stat, &
        errmsg = errmsg, &
        errmsg_alloc = errmsg_alloc)
  end procedure

  ! _______________________ Strided Put RMA ____________________________
  ! This helper ensures the metadata arrays are contiguous (RMA data may still be non-contiguous)
  subroutine put_strided_helper( &
        image_num, remote_ptr, remote_stride, current_image_buffer, current_image_stride, element_size, extent, &
        stat, errmsg, errmsg_alloc)
    implicit none
    integer(c_int), intent(in) :: image_num
    integer(c_intptr_t), intent(in) :: remote_ptr
    integer(c_ptrdiff_t), intent(in), target, contiguous :: remote_stride(:)
    type(c_ptr), intent(in) :: current_image_buffer
    integer(c_ptrdiff_t), intent(in), target, contiguous :: current_image_stride(:)
    integer(c_size_t), intent(in) :: element_size
    integer(c_size_t), intent(in), target, contiguous :: extent(:)
    integer(c_int), intent(out), optional :: stat
    character(len=*), intent(inout), optional :: errmsg
    character(len=:), intent(inout), allocatable, optional :: errmsg_alloc

    call_assert_describe(image_num > 0 .and. image_num <= initial_team%num_images, "image_num not within valid range")
    call_assert(size(remote_stride) == size(extent))
    call_assert(size(current_image_stride) == size(extent))

    call caf_put_strided( &
        dims = size(extent), &
        image_num = image_num, &
        remote_ptr = remote_ptr, &
        remote_stride = c_loc(remote_stride), &
        current_image_buffer = current_image_buffer, &
        current_image_stride = c_loc(current_image_stride), &
        element_size = element_size, &
        extent = c_loc(extent))

    if (present(stat)) stat = 0
  end subroutine

  module procedure prif_put_strided
    integer(c_intptr_t) :: remote_base

    call_assert(offset >= 0)

    call base_pointer(coarray_handle, image_num, remote_base)
    call prif_put_strided_indirect( &
        image_num = image_num, &
        remote_ptr = remote_base + offset, &
        remote_stride = remote_stride, &
        current_image_buffer = current_image_buffer, &
        current_image_stride = current_image_stride, &
        element_size = element_size, &
        extent = extent, &
        stat = stat, errmsg = errmsg, errmsg_alloc = errmsg_alloc)
  end procedure

  module procedure prif_put_strided_indirect
    call put_strided_helper( &
        image_num = image_num, &
        remote_ptr = remote_ptr, &
        remote_stride = remote_stride, &
        current_image_buffer = current_image_buffer, &
        current_image_stride = current_image_stride, &
        element_size = element_size, &
        extent = extent, &
        stat = stat, errmsg = errmsg, errmsg_alloc = errmsg_alloc)
  end procedure

  module procedure prif_put_strided_with_notify
    integer(c_intptr_t) :: remote_base
    integer(c_intptr_t) :: notify_remote_base

    call_assert(offset >= 0)
    call_assert(notify_offset >= 0)

    call base_pointer(coarray_handle, image_num, remote_base)
    call base_pointer(notify_coarray_handle, image_num, notify_remote_base)

    call prif_put_strided_indirect_with_notify_indirect( &
        image_num = image_num, &
        remote_ptr = remote_base + offset, &
        remote_stride = remote_stride, &
        current_image_buffer = current_image_buffer, &
        current_image_stride = current_image_stride, &
        element_size = element_size, &
        extent = extent, &
        notify_ptr = notify_remote_base + notify_offset, &
        stat = stat, errmsg = errmsg, errmsg_alloc = errmsg_alloc)
  end procedure

  module procedure prif_put_strided_with_notify_indirect
    integer(c_intptr_t) :: remote_base

    call_assert(offset >= 0)

    call base_pointer(coarray_handle, image_num, remote_base)

    call prif_put_strided_indirect_with_notify_indirect( &
        image_num = image_num, &
        remote_ptr = remote_base + offset, &
        remote_stride = remote_stride, &
        current_image_buffer = current_image_buffer, &
        current_image_stride = current_image_stride, &
        element_size = element_size, &
        extent = extent, &
        notify_ptr = notify_ptr, &
        stat = stat, errmsg = errmsg, errmsg_alloc = errmsg_alloc)
  end procedure

  module procedure prif_put_strided_indirect_with_notify
    integer(c_intptr_t) :: notify_remote_base

    call_assert(notify_offset >= 0)

    call base_pointer(notify_coarray_handle, image_num, notify_remote_base)

    call prif_put_strided_indirect_with_notify_indirect( &
        image_num = image_num, &
        remote_ptr = remote_ptr, &
        remote_stride = remote_stride, &
        current_image_buffer = current_image_buffer, &
        current_image_stride = current_image_stride, &
        element_size = element_size, &
        extent = extent, &
        notify_ptr = notify_remote_base + notify_offset, &
        stat = stat, errmsg = errmsg, errmsg_alloc = errmsg_alloc)
  end procedure

  module procedure prif_put_strided_indirect_with_notify_indirect
    call put_strided_helper( &
        image_num = image_num, &
        remote_ptr = remote_ptr, &
        remote_stride = remote_stride, &
        current_image_buffer = current_image_buffer, &
        current_image_stride = current_image_stride, &
        element_size = element_size, &
        extent = extent, &
        stat = stat, errmsg = errmsg, errmsg_alloc = errmsg_alloc)
    call caf_event_post(image_num, notify_ptr, &
           segment_boundary=0, release_fence=1)
  end procedure

end submodule coarray_access_s

#include "test-utils.F90"
#include "julienne-assert-macros.h"

module prif_co_reduce_test_m
  use iso_c_binding, only: c_ptr, c_funptr, c_size_t, c_f_pointer, c_f_procpointer, c_funloc, c_loc, c_null_ptr, c_associated
  use prif, only : prif_co_reduce, prif_num_images, prif_this_image_no_coarray, prif_operation_wrapper_interface
  use julienne_m, only : &
     call_julienne_assert_ &
    ,operator(.all.) &
    ,operator(.also.) &
    ,operator(.approximates.) &
    ,operator(.equalsExpected.) &
    ,operator(.within.) &
    ,operator(//) &
    ,usher &
    ,string_t &
    ,test_description_t &
    ,test_diagnosis_t &
    ,test_result_t &
    ,test_t
  implicit none

  private
  public :: prif_co_reduce_test_t

  type, extends(test_t) :: prif_co_reduce_test_t
  contains
    procedure, nopass, non_overridable :: subject
    procedure, nopass, non_overridable :: results
  end type

  type :: pair
    integer :: fst
    real :: snd
  end type

#if HAVE_PARAM_DERIVED
  type :: array(length)
    integer, len :: length = 2
    integer :: elements(length)
  end type

  type :: reduction_context_data
    type(c_funptr) :: user_op
    integer :: length
  end type
#endif

  integer, target :: dummy

contains

  pure function subject() result(test_subject)
    character(len=:), allocatable :: test_subject
    test_subject = "prif_co_reduce"
  end function

  function results() result(test_results)
    type(test_result_t), allocatable :: test_results(:)
    type(prif_co_reduce_test_t) prif_co_reduce_test

    allocate(test_results, source = prif_co_reduce_test%run([ &
       test_description_t("performing a logical .and. reduction", usher(check_logical)) &
      ,test_description_t("performing a derived type reduction", usher(check_derived_type_reduction)) &
#if HAVE_PARAM_DERIVED
      ,test_description_t("performing a parameterized derived type reduction", usher(check_type_parameter_reduction)) &
#endif
    ]))
  end function

  function check_logical() result(diag)
    type(test_diagnosis_t) :: diag
    logical :: val
    integer :: me
    procedure(prif_operation_wrapper_interface), pointer :: op
    diag = .true.
    op => and_wrapper

    val = .true.
    call prif_co_reduce(val, op, c_null_ptr)
    ALSO(val)

    call prif_this_image_no_coarray(this_image=me)
    if (me == 1) then
      val = .false.
    end if
    call prif_co_reduce(val, op, c_null_ptr)
    ALSO(.not. val)
  end function

  subroutine and_wrapper(arg1, arg2_and_out, count, cdata) bind(C)
    type(c_ptr), intent(in), value :: arg1, arg2_and_out
    integer(c_size_t), intent(in), value :: count
    type(c_ptr), intent(in), value :: cdata

    logical, pointer :: lhs(:), rhs_and_result(:)
    integer(c_size_t) :: i

    if (count == 0) return
    ! this expression is buggy as of Julienne 3.6.0 (julienne#166)
    !call_julienne_assert(cdata .equalsExpected. c_null_ptr)
    call_julienne_assert(.not. c_associated(cdata))
    call c_f_pointer(arg1, lhs, [count])
    call c_f_pointer(arg2_and_out, rhs_and_result, [count])
    do i = 1, count
      rhs_and_result(i) = lhs(i).and.rhs_and_result(i)
    end do
  end subroutine

  function check_derived_type_reduction() result(diag)
    type(test_diagnosis_t) :: diag
    type(pair), parameter :: values(*,*) = reshape( &
        [ pair(1, 53.), pair(3, 47.) &
        , pair(5, 43.), pair(7, 41.) &
        , pair(11, 37.), pair(13, 31.) &
        , pair(17, 29.), pair(19, 23.) &
        ], &
        [2, 4])
    integer :: me, ni, i
    type(pair), dimension(size(values,1)) :: my_val, expected
    type(pair), dimension(:,:), allocatable :: tmp
    procedure(prif_operation_wrapper_interface), pointer :: op
    real, parameter :: tolerance = 0D0

    op => pair_adder
    call prif_this_image_no_coarray(this_image=me)
    call prif_num_images(ni)

    my_val = values(:, mod(me-1, size(values,2))+1)
    call prif_co_reduce(my_val, op, c_loc(dummy))

    allocate(tmp(size(values,1),ni))
    tmp = reshape([(values(:, mod(i-1,size(values,2))+1), i = 1, ni)], [size(values,1),ni])
#if defined(__GFORTRAN__)
    ! gfortran 14 lacks the F18 intrinsic REDUCE()
    block
      integer :: j
      do i = 1, size(tmp,1)
        expected(i) = tmp(i,1)
        do j = 2, size(tmp,2)
          expected(i) = add_pair(expected(i), tmp(i,j))
        end do
      end do
    end block
#else
    expected = reduce(tmp, add_pair, dim=2)
#endif
    diag = .all. (my_val%fst .equalsExpected. expected%fst) &
      .also. (.all. ( my_val%snd .approximates. expected%snd .within. tolerance))
  end function

  pure function add_pair(lhs, rhs) result(total)
    type(pair), intent(in) :: lhs, rhs
    type(pair) :: total

    total%fst = lhs%fst + rhs%fst
    total%snd = lhs%snd + rhs%snd
  end function

  subroutine pair_adder(arg1, arg2_and_out, count, cdata) bind(C)
    type(c_ptr), intent(in), value :: arg1, arg2_and_out
    integer(c_size_t), intent(in), value :: count
    type(c_ptr), intent(in), value :: cdata

    type(pair), pointer :: lhs(:), rhs_and_result(:)
    integer(c_size_t) :: i

    if (count == 0) return
    call_julienne_assert(cdata .equalsExpected. c_loc(dummy))
    call c_f_pointer(arg1, lhs, [count])
    call c_f_pointer(arg2_and_out, rhs_and_result, [count])
    do i = 1, count
      rhs_and_result(i) = add_pair(lhs(i), rhs_and_result(i))
    end do
  end subroutine

#if HAVE_PARAM_DERIVED
! As of LLVM20, flang does not implement the types used by this test:
! flang/lib/Lower/ConvertType.cpp:482: not yet implemented: parameterized derived types
! error: Actual argument associated with TYPE(*) dummy argument 'a=' may not have a parameterized derived type

! Gfortran 14.2 also lacks the type support for this test:
! Error: Derived type 'pdtarray' at (1) is being used before it is defined

  function check_type_parameter_reduction() result(diag)
    type(test_diagnosis_t) :: diag
    type(array), parameter :: values(*,*) = reshape( &
        [ array(elements=[1, 53]), array(elements=[3, 47]) &
        , array(elements=[5, 43]), array(elements=[7, 41]) &
        , array(elements=[11, 37]), array(elements=[13, 31]) &
        , array(elements=[17, 29]), array(elements=[19, 23]) &
        ], &
        [2, 4])
    integer :: me, ni, i
    type(array(values%length)), dimension(size(values,1)) :: my_val, expected
    procedure(prif_operation_wrapper_interface), pointer :: op
    type(reduction_context_data), target :: context

    op => array_wrapper
    context%user_op = c_funloc(add_array)
    context%length = values%length
    call prif_this_image_no_coarray(this_image=me)
    call prif_num_images(ni)

    my_val = values(:, mod(me-1, size(values,2))+1)
    call prif_co_reduce(my_val, op, c_loc(context))

    expected = reduce(reshape([(values(:, mod(i-1,size(values,2))+1), i = 1, ni)], [size(values,1),ni]), add_array, dim=2)
    diag = .all. (my_val%elements .equalsExpected. expected%elements)
  end function

  pure function add_array(lhs, rhs) result(total)
    type(array), intent(in) :: lhs, rhs
    type(array) :: total

    total%elements = lhs%elements + rhs%elements
  end function

  subroutine array_wrapper(arg1, arg2_and_out, count, cdata) bind(C)
    type(c_ptr), intent(in), value :: arg1, arg2_and_out
    integer(c_size_t), intent(in), value :: count
    type(c_ptr), intent(in), value :: cdata

    type(reduction_context_data), pointer :: context

    if (count == 0) return
    call c_f_pointer(cdata, context)
    block
      abstract interface
        pure function op_interface(lhs, rhs) result(res)
          import :: array, context
          implicit none
          type(array(context%length)), intent(in) :: lhs, rhs
          type(array(context%length)) :: res
        end function
      end interface
      procedure(op_interface), pointer :: op
      type(array(context%length)), pointer :: lhs(:), rhs_and_result(:)
      integer(c_size_t) :: i

      call c_f_procpointer(context%user_op, op)
      call c_f_pointer(arg1, lhs, [count])
      call c_f_pointer(arg2_and_out, rhs_and_result, [count])
      do i = 1, count
        rhs_and_result(i) = op(lhs(i), rhs_and_result(i))
      end do
    end block
  end subroutine
#endif /* HAVE_PARAM_DERIVED */

end module prif_co_reduce_test_m

#include "test-utils.F90"
#include "language-support.F90"

module prif_teams_test_m
# include "test-uses-alloc.F90"
    use prif
    use julienne_m, only: test_description_t, test_diagnosis_t, test_result_t, test_t, string_t, usher &
      ,operator(.also.), operator(.isAtLeast.), operator(.isAtMost.), operator(.equalsExpected.), operator(//)

    implicit none
    private
    public :: prif_teams_test_t

    type, extends(test_t) :: prif_teams_test_t
    contains
      procedure, nopass, non_overridable :: subject
      procedure, nopass, non_overridable :: results
    end type

    integer :: cleanup_count = 0

contains
    pure function subject()
      character(len=:), allocatable :: subject
      subject = "PRIF Teams"
    end function

    function results() result(test_results)
        type(test_result_t), allocatable :: test_results(:)
        type(prif_teams_test_t) prif_teams_test

        allocate(test_results, source = prif_teams_test%run([ &
            test_description_t("creating, changing to, and allocating coarrays", usher(check_teams)) &
        ]))
    end function

    function check_teams() result(diag)
        type(test_diagnosis_t) :: diag

        integer :: dummy_element, i
        integer(c_int) :: initial_num_imgs, num_imgs, me, me_child, x
        integer(c_size_t) :: element_size
        integer(c_int64_t) :: which_team, n
        integer, parameter :: num_coarrays = 10
        type(prif_coarray_handle) :: initial_coarray, coarrays(num_coarrays)
        type(c_ptr) :: allocated_memory
        type(prif_team_type) :: team, initial_team, t, team_self

        diag = .true.

        call prif_num_images(num_images=initial_num_imgs)
        ALSO2(initial_num_imgs .isAtLeast. 1,  "invalid prif_num_images")

        call prif_this_image_no_coarray(this_image=me)
        ALSO2(me .isAtLeast. 1, "invalid prif_this_image")
        ALSO2(me .isAtMost. initial_num_imgs, "invalid prif_this_image")

        n = 0 ! clear outputs
        call prif_team_number(team_number=n)
        ALSO2(n .equalsExpected. -1_c_int64_t, "Initial team number is -1")

        n = 0 ! clear outputs
        call prif_get_team(team=initial_team)
        call prif_team_number(team=initial_team, team_number=n)
        ALSO2(n .equalsExpected. -1_c_int64_t, "prif_get_team retrieval of current initial team")
          
        ! ensure prif_sync_team is usable
        call prif_sync_team(team=initial_team)

        x = 0 ! clear outputs
        call prif_num_images_with_team(team=initial_team, num_images=x)
        ALSO2(x .equalsExpected. initial_num_imgs, "prif_num_images in initial team")
          
        x = 0 ! clear outputs
        call prif_num_images_with_team_number(team_number=-1_c_int64_t, num_images=x)
        ALSO2(x .equalsExpected. initial_num_imgs, "prif_num_images_with_team_number in initial team")

        x = 0 ! clear outputs
        call prif_this_image_no_coarray(team=initial_team, this_image=x)
        ALSO2(x .equalsExpected. me, "prif_this_image_no_coarray in initial team")
          
        t = prif_team_type() ; n = 0 ! clear outputs
        call prif_get_team(level=PRIF_INITIAL_TEAM, team=t)
        call prif_team_number(team=t, team_number=n)
        ALSO2(n .equalsExpected. -1_c_int64_t, "prif_get_team(PRIF_INITIAL_TEAM) retrieves initial team")
          
        t = prif_team_type() ; n = 0 ! clear outputs
        call prif_get_team(level=PRIF_CURRENT_TEAM, team=t)
        call prif_team_number(team=t, team_number=n)
        ALSO2(n .equalsExpected. -1_c_int64_t, "prif_get_team(PRIF_CURRENT_TEAM) retrieval of initial team when current team is initial team")

        t = prif_team_type() ; n = 0 ! clear outputs
        call prif_get_team(level=PRIF_PARENT_TEAM, team=t)
        call prif_team_number(team=t, team_number=n)
        ALSO2(n .equalsExpected. -1_c_int64_t, "prif_get_team(PRIF_PARENT_TEAM) retrieves initial team when parent team is initial team")
          
        element_size = int(storage_size(dummy_element)/8, c_size_t)
        call prif_allocate_coarray( &
            lcobounds = [1_c_int64_t], &
            ucobounds = [integer(c_int64_t)::], &
            size_in_bytes = element_size, &
            final_func = c_null_funptr, &
            coarray_handle = initial_coarray, &
            allocated_memory = allocated_memory)
        n = 0 ! clear outputs
        call prif_ucobound_with_dim(initial_coarray, 1, n)
        ALSO(n .equalsExpected. int(initial_num_imgs, c_int64_t))

        which_team = merge(1_c_int64_t, 2_c_int64_t, mod(me, 2) == 0)
        call prif_form_team(team_number = which_team, team = team)
        call prif_change_team(team)
            call prif_num_images(num_images=num_imgs)
            ALSO2(num_imgs .equalsExpected.  initial_num_imgs/2 + mod(initial_num_imgs,2)*(int(which_team)-1), "Team has correct number of images")

            ! ensure prif_sync_team is usable
            call prif_sync_team(team=team)
            call prif_sync_team(team=initial_team)

            x = 0 ! clear outputs
            call prif_num_images_with_team(team=team, num_images=x)
            ALSO2(x .equalsExpected. num_imgs, "prif_num_images works with team")

            x = 0 ! clear outputs
            call prif_num_images_with_team_number(team_number=which_team, num_images=x)
            ALSO2 (x .equalsExpected. num_imgs, "prif_num_images_with_team_number works with current team")

            call prif_this_image_no_coarray(this_image=me_child)
            ALSO2(me_child .equalsExpected. (me - 1)/2 + 1, "prif_this_image is valid")
              

            x = 0 ! clear outputs
            call prif_this_image_no_coarray(team=team, this_image=x)
            ALSO2(x .equalsExpected. me_child, "prif_this_image is valid")

            n = 0 ! clear outputs
            call prif_team_number(team_number=n)
            ALSO2(n .equalsExpected. which_team, "Correct current team number")
    
            n = 0 ! clear outputs
            call prif_team_number(team=team, team_number=n)
            ALSO2(n .equalsExpected. which_team, "Correct current team number")
    
            t = prif_team_type() ; n = 0 ! clear outputs
            call prif_get_team(team=t)
            call prif_team_number(team=t, team_number=n)
            ALSO2(n .equalsExpected. which_team, "prif_get_team retrieves current team")
    
            t = prif_team_type() ; n = 0 ! clear outputs
            call prif_get_team(level=PRIF_INITIAL_TEAM, team=t)
            call prif_team_number(team=t, team_number=n)
            ALSO2(n .equalsExpected. -1_c_int64_t, "prif_get_team(PRIF_INITIAL_TEAM) retrieves initial team")
    
            t = prif_team_type() ; n = 0 ! clear outputs
            call prif_get_team(level=PRIF_CURRENT_TEAM, team=t)
            call prif_team_number(team=t, team_number=n)
            ALSO2(n .equalsExpected. which_team, "prif_get_team(PRIF_CURRENT_TEAM) retrieves current team")
    
            t = prif_team_type() ; n = 0 ! clear outputs
            call prif_get_team(level=PRIF_PARENT_TEAM, team=t)
            call prif_team_number(team=t, team_number=n)
            ALSO2(n .equalsExpected. -1_c_int64_t, "prif_get_team(PRIF_PARENT_TEAM) retrieves initial team when parent team is initial team")

            x = 0 ! clear outputs
            call prif_num_images_with_team(team=initial_team, num_images=x)
            ALSO2(x .equalsExpected. initial_num_imgs, "prif_num_images works with initial team")

            x = 0 ! clear outputs
            call prif_num_images_with_team_number(team_number=-1_c_int64_t, num_images=x)
            ALSO2(x .equalsExpected. initial_num_imgs, "prif_num_images_with_team_number works with initial team")

            x = 0 ! clear outputs
            call prif_this_image_no_coarray(team=initial_team, this_image=x)
            ALSO2(x .equalsExpected. me, "prif_this_image_no_coarray works with initial team")

            n = 0 ! clear outputs
            call prif_ucobound_with_dim(initial_coarray, 1, n)
            ALSO(n .equalsExpected. int(num_imgs, c_int64_t))

            ALSO(cleanup_count .equalsExpected. 0)
            do i = 1, num_coarrays
                call prif_allocate_coarray( &
                    lcobounds = [1_c_int64_t], &
                    ucobounds = [integer(c_int64_t)::], &
                    size_in_bytes = element_size, &
#if HAVE_FINAL_FUNC_SUPPORT
                    final_func = c_funloc(coarray_cleanup), &
#  define CHECK_COUNT(n) ALSO(cleanup_count .equalsExpected. n)
#else
                    final_func = c_null_funptr, &
#  define CHECK_COUNT(n) 
#endif
                    coarray_handle = coarrays(i), &
                    allocated_memory = allocated_memory)
            end do
            CHECK_COUNT(0)
            call prif_deallocate_coarrays(coarrays(4:4))
            call prif_deallocate_coarrays(coarrays(2:2))
            call prif_deallocate_coarray(coarrays(7))
            CHECK_COUNT(3)

            call prif_form_team(team_number = int(me,c_int64_t), team = team_self)
            x = 0 ! clear outputs
            call prif_num_images_with_team(team=team_self, num_images=x)
            ALSO2(x .equalsExpected. 1, "prif_num_images works with team_self")
            call prif_change_team(team_self)
                x = 0 ! clear outputs
                call prif_num_images(num_images=x)
                ALSO2(x .equalsExpected. 1, "prif_num_images works in team_self")
                x = 0 ! clear outputs
                call prif_this_image_no_coarray(this_image=x)
                ALSO2(x .equalsExpected. 1, "prif_this_image is valid in team_self")
                x = 0 ! clear outputs
                call prif_this_image_no_coarray(team=team, this_image=x)
                ALSO2(x .equalsExpected. me_child, "prif_this_image is valid")
                x = 0 ! clear outputs
                call prif_this_image_no_coarray(team=initial_team, this_image=x)
                ALSO2(x .equalsExpected. me, "prif_this_image is valid")

                ! ensure prif_sync_team is usable
                call prif_sync_team(team=team)
                call prif_sync_team(team=initial_team)
                call prif_sync_team(team=team_self)

                n = 0 ! clear outputs
                call prif_ucobound_with_dim(initial_coarray, 1, n)
                ALSO(n .equalsExpected. 1_c_int64_t)
                n = 0 ! clear outputs
                call prif_ucobound_with_dim(coarrays(3), 1, n)
                ALSO(n .equalsExpected. 1_c_int64_t)

                CHECK_COUNT(3)
            call prif_end_team()

            CHECK_COUNT(3)
        call prif_end_team()
        CHECK_COUNT(num_coarrays)

        ! ensure prif_sync_team is usable
        call prif_sync_team(team=team)
        call prif_sync_team(team=initial_team)

        t = prif_team_type() ; n = 0 ! clear outputs
        call prif_get_team(team=t)
        call prif_team_number(team=t, team_number=n)
        ALSO2(n .equalsExpected. -1_c_int64_t, "prif_end_team restores initial team")

    end function

#if HAVE_FINAL_FUNC_SUPPORT
    subroutine coarray_cleanup(handle, stat, errmsg) bind(C)
      type(prif_coarray_handle), pointer, intent(in) :: handle
      integer(c_int), intent(out) :: stat
      character(len=:), intent(out), allocatable :: errmsg

      cleanup_count = cleanup_count + 1
      stat = 0
    end subroutine
#endif
end module prif_teams_test_m

#include "test-utils.F90"
#include "assert_macros.h"

! TEST_ASSERT activates immediate assertions in test code
#if !TEST_ASSERT
#undef  call_assert
#define call_assert(c)
#undef  call_assert_describe
#define call_assert_describe(c,d)
#endif

module prif_event_test_m
# include "test-uses-alloc.F90"
    use assert_m
    use prif, only: &
            prif_event_type, prif_event_post, prif_event_post_indirect, prif_event_wait, prif_event_query, &
            prif_notify_type, prif_notify_wait, prif_put_with_notify, prif_put_strided_with_notify, &
            prif_num_images, &
            prif_put, &
            prif_sync_all, &
            prif_this_image_no_coarray
    use julienne_m, only: test_description_t, test_diagnosis_t, test_result_t, test_t, string_t, usher &
      ,operator(.all.), operator(.also.), operator(.equalsExpected.), operator(//)

    implicit none
    private
    public :: prif_event_test_t

    type, extends(test_t) :: prif_event_test_t
    contains
      procedure, nopass, non_overridable :: subject
      procedure, nopass, non_overridable :: results
    end type

contains
   pure function subject()
     character(len=:), allocatable :: subject
     subject = "PRIF Events"
   end function

    function results() result(test_results)
        type(test_result_t), allocatable :: test_results(:)
        type(prif_event_test_t) prif_event_test

        allocate(test_results, source = prif_event_test%run([ &
           test_description_t("a serial event test", usher(check_event_serial)) &
          ,test_description_t("a parallel hot-spot event test", usher(check_event_parallel)) &
          ,test_description_t("a parallel hot-spot notify test", usher(check_notify)) &
        ]))
    end function

    function test_rand(lo, hi) result(result_)
        integer :: lo, hi, result_
        real :: r
        call random_number(r) ! Generate a uniform random number in [0, 1)
        result_ = int(r * (hi - lo + 1)) + lo
        call_assert(result_ >= lo .and. result_ <= hi)
    end function

    function check_event_serial() result(diag)
        type(test_diagnosis_t) diag 

        integer :: me
        type(prif_event_type) :: dummy_event
        integer(c_size_t) :: sizeof_event
        type(prif_coarray_handle) :: coarray_handle
        type(c_ptr) :: allocated_memory
        type(prif_event_type), pointer :: local_event
        integer(c_intptr_t) :: base_addr

        diag = .true.
        call RANDOM_INIT(REPEATABLE=.true., IMAGE_DISTINCT=.true.)

        sizeof_event = int(storage_size(dummy_event)/8, c_size_t)
        call prif_this_image_no_coarray(this_image=me)

        ! type(event_type) :: evt[*]
        call prif_allocate_coarray( &
                lcobounds = [1_c_int64_t], &
                ucobounds = [integer(c_int64_t)::], &
                size_in_bytes = sizeof_event, &
                final_func = c_null_funptr, &
                coarray_handle = coarray_handle, &
                allocated_memory = allocated_memory)
        call c_f_pointer(allocated_memory, local_event)
        base_addr = transfer(allocated_memory, base_addr)
        local_event = dummy_event ! default initialize

        block
          integer, parameter :: lim = 10
          integer i, j, c, r
          integer(c_int64_t) :: count, expect
          character(len=50) :: context

          expect = 0
          do i=1, lim
            call prif_event_query(c_loc(local_event), count)
            ALSO2(count .equalsExpected. expect, "event count at top of loop")
            call_assert(expect == count)

            do j=1,i
              call prif_event_post(me, coarray_handle, 0_c_size_t)
              expect = expect + 1

              call prif_event_query(c_loc(local_event), count)
              ALSO2(count .equalsExpected. expect, "after event_post")
              call_assert(expect == count)

              call prif_event_post_indirect(me, base_addr)
              expect = expect + 1

              call prif_event_query(c_loc(local_event), count)
              ALSO2(count .equalsExpected. expect, "event count after event_post_indirect")
              call_assert(expect == count)

              if (expect >= 1) then
                c = test_rand(1, int(expect))
                if (c > 1) then
                  context = "after event_wait(c)"
                  call prif_event_wait(c_loc(local_event), int(c,c_int64_t))
                else if (test_rand(0,1) == 0) then
                  call_assert(c == 1)
                  context = "after event_wait(1)"
                  call prif_event_wait(c_loc(local_event), 1_c_int64_t)
                else if (test_rand(0,1) == 0) then
                  call_assert(c == 1)
                  context = "after event_wait()"
                  call prif_event_wait(c_loc(local_event))
                else
                  call_assert(c == 1)
                  context = "after event_wait(r)"
                  r = test_rand(-50, 0)
                  call prif_event_wait(c_loc(local_event), int(r,c_int64_t))
                endif
                expect = expect - c

                call prif_event_query(c_loc(local_event), count)
                ALSO2(count .equalsExpected. expect, context)
                call_assert_describe(expect == count, context)
              end if
            end do
          end do
        end block 

        call prif_deallocate_coarray(coarray_handle)
    end function


    function check_event_parallel() result(diag)
        type(test_diagnosis_t) :: diag

        integer :: me, num_imgs
        type(prif_event_type) :: dummy_event
        integer(c_size_t) :: sizeof_event, sizeof_int
        type(prif_coarray_handle) :: coarray_handle_evt
        type(prif_coarray_handle) :: coarray_handle_ctr
        type(c_ptr) :: allocated_memory
        type(prif_event_type), pointer :: local_evt
        integer, pointer :: local_ctr(:)

        diag = .true.
        sizeof_event = int(storage_size(dummy_event)/8, c_size_t)
        sizeof_int = c_sizeof(me)
        call prif_num_images(num_images=num_imgs)
        call prif_this_image_no_coarray(this_image=me)

        ! type(event_type) :: evt[*]
        call prif_allocate_coarray( &
                lcobounds = [1_c_int64_t], &
                ucobounds = [integer(c_int64_t)::], &
                size_in_bytes = sizeof_event, &
                final_func = c_null_funptr, &
                coarray_handle = coarray_handle_evt, &
                allocated_memory = allocated_memory)
        call c_f_pointer(allocated_memory, local_evt)
        local_evt = dummy_event ! default initialize

        ! integer :: ctr(num_images())[*]
        call prif_allocate_coarray( &
                lcobounds = [1_c_int64_t], &
                ucobounds = [integer(c_int64_t)::], &
                size_in_bytes = num_imgs * sizeof_int, &
                final_func = c_null_funptr, &
                coarray_handle = coarray_handle_ctr, &
                allocated_memory = allocated_memory)
        call c_f_pointer(allocated_memory, local_ctr, [num_imgs])
        local_ctr = 0 ! initialize

        call prif_sync_all

        block
          integer, parameter :: lim = 10
          integer, target :: i, j

          do i=1, lim
            ! every image writes a coarray value on image 1, then posts event

            ! ctr(me)[1] = i
            call prif_put( &
                image_num = 1, &
                coarray_handle = coarray_handle_ctr, &
                offset = (me-1) * sizeof_int, &
                current_image_buffer = c_loc(i), &
                size_in_bytes = sizeof_int)

            ! EVENT POST ( evt[1] )
            call prif_event_post(1, coarray_handle_evt, 0_c_size_t)

            if (me == 1) then
              ! image 1 waits on the events, then validates data arrival

              ! EVENT WAIT ( evt, UNTIL_COUNT=num_imgs )
              call prif_event_wait(c_loc(local_evt), int(num_imgs,c_int64_t))

              ! validate ctr(:)[1] == i
              ALSO2(.all. (local_ctr(1:num_imgs) .equalsExpected. i), "gather result")

              ! image 1 writes back a coarray value to each image, then posts an event
              do j=1,num_imgs
                ! ctr(1)[j] = i
                call prif_put( &
                  image_num = j, &
                  coarray_handle = coarray_handle_ctr, &
                  offset = 0_c_size_t, &
                  current_image_buffer = c_loc(i), &
                  size_in_bytes = sizeof_int)

                ! EVENT POST ( evt[j] )
                call prif_event_post(j, coarray_handle_evt, 0_c_size_t)
              end do
            end if


            ! EVENT WAIT ( evt )
            call prif_event_wait(c_loc(local_evt))

            ! validate ctr(1)[me] == i
            ALSO2(local_ctr(1) .equalsExpected. i, "scatter result")

          end do
        end block

        call prif_deallocate_coarrays(([coarray_handle_ctr, coarray_handle_evt]))
    end function

    function check_notify() result(diag)
        type(test_diagnosis_t) diag

        integer :: me, num_imgs
        type(prif_notify_type) :: dummy_notify
        integer(c_size_t) :: sizeof_notify, sizeof_int
        type(prif_coarray_handle) :: coarray_handle_evt
        type(prif_coarray_handle) :: coarray_handle_ctr
        type(c_ptr) :: allocated_memory
        type(prif_notify_type), pointer :: local_evt
        integer, pointer :: local_ctr(:)

        diag = .true.
        sizeof_notify = int(storage_size(dummy_notify)/8, c_size_t)
        sizeof_int = c_sizeof(me)
        call prif_num_images(num_images=num_imgs)
        call prif_this_image_no_coarray(this_image=me)

        ! type(notify_type) :: evt[*]
        call prif_allocate_coarray( &
                lcobounds = [1_c_int64_t], &
                ucobounds = [integer(c_int64_t)::], &
                size_in_bytes = sizeof_notify, &
                final_func = c_null_funptr, &
                coarray_handle = coarray_handle_evt, &
                allocated_memory = allocated_memory)
        call c_f_pointer(allocated_memory, local_evt)
        local_evt = dummy_notify ! default initialize

        ! integer :: ctr(num_images())[*]
        call prif_allocate_coarray( &
                lcobounds = [1_c_int64_t], &
                ucobounds = [integer(c_int64_t)::], &
                size_in_bytes = num_imgs * sizeof_int, &
                final_func = c_null_funptr, &
                coarray_handle = coarray_handle_ctr, &
                allocated_memory = allocated_memory)
        call c_f_pointer(allocated_memory, local_ctr, [num_imgs])
        local_ctr = 0 ! initialize

        call prif_sync_all

        block
          integer, parameter :: lim = 10
          integer, target :: i, j

          do i=1, lim
            ! every image writes a coarray value on image 1 with notify

            ! ctr(me)[1,notify=evt] = i
            call prif_put_with_notify( &
                image_num = 1, &
                coarray_handle = coarray_handle_ctr, &
                offset = (me-1) * sizeof_int, &
                current_image_buffer = c_loc(i), &
                size_in_bytes = sizeof_int, &
                notify_coarray_handle = coarray_handle_evt, &
                notify_offset = 0_c_size_t)

            if (me == 1) then
              ! image 1 waits on the notifys, then validates data arrival

              ! NOTIFY WAIT ( evt, UNTIL_COUNT=num_imgs )
              call prif_notify_wait(c_loc(local_evt), int(num_imgs,c_int64_t))

              ! validate ctr(:)[1] == i
              ALSO2(.all. (local_ctr(1:num_imgs) .equalsExpected. i), "gather result")

              ! image 1 writes back a coarray value to each image with notify
              do j=1,num_imgs
                ! ctr(1)[j, notify=evt] = i
                call prif_put_strided_with_notify( &
                  image_num = j, &
                  coarray_handle = coarray_handle_ctr, &
                  offset = 0_c_size_t, &
                  remote_stride = [sizeof_int], &
                  current_image_buffer = c_loc(i), &
                  current_image_stride = [sizeof_int], &
                  element_size = sizeof_int, &
                  extent = [1_c_size_t], &
                  notify_coarray_handle = coarray_handle_evt, &
                  notify_offset = 0_c_size_t)
              end do
            end if


            ! NOTIFY WAIT ( evt )
            call prif_notify_wait(c_loc(local_evt))

            ! validate ctr(1)[me] == i
            ALSO2(local_ctr(1) .equalsExpected. i, "scatter result")

          end do
        end block

        call prif_deallocate_coarrays(([coarray_handle_ctr, coarray_handle_evt]))
    end function

end module prif_event_test_m

module prif_num_images_test_m
  use prif, only : prif_num_images
  use julienne_m, only:  &
     operator(//) &
    ,operator(.isAtLeast.) &
    ,usher &
    ,test_description_t &
    ,test_diagnosis_t &
    ,test_result_t &
    ,test_t

  implicit none
  private
  public :: prif_num_images_test_t

  type, extends(test_t) :: prif_num_images_test_t
  contains
    procedure, nopass, non_overridable :: subject
    procedure, nopass, non_overridable :: results
  end type

contains

  pure function subject() result(test_subject)
    character(len=:), allocatable :: test_subject
    test_subject = "prif_num_images"
  end function

  function results() result(test_results)
    type(test_result_t), allocatable :: test_results(:)
    type(prif_num_images_test_t) prif_num_images_test

    allocate(test_results, source = prif_num_images_test%run([ &
        test_description_t("returning a valid number of images when invoked with no arguments", usher(check_num_images_valid)) &
    ]))
  end function


  function check_num_images_valid() result(diag)
    type(test_diagnosis_t) :: diag
    integer num_imgs
    call prif_num_images(num_images=num_imgs)
    diag = (num_imgs .isAtLeast. 1) // "positive number of images"
  end function

end module prif_num_images_test_m

#include "julienne-assert-macros.h"
#include "test-utils.F90"

module prif_atomic_test_m
# include "test-uses-alloc.F90"
    use julienne_m, only: call_julienne_assert_, test_description_t, test_diagnosis_t, test_result_t, test_t, string_t, usher &
      ,operator(.also.), operator(.equalsExpected.), operator(.isAtLeast.), operator(.isAtMost.), operator(.lessThan.), operator(//)
    use prif

    implicit none
    private
    public :: prif_atomic_test_t

    type, extends(test_t) :: prif_atomic_test_t
    contains
      procedure, nopass, non_overridable :: subject
      procedure, nopass, non_overridable :: results
    end type

    ! define an .equalsExpected. for logical(PRIF_ATOMIC_LOGICAL_KIND)
    interface operator(.equalsExpected.)
      module procedure prif_logical_equals
    end interface operator(.equalsExpected.)
contains
    pure function prif_logical_equals(lhs, rhs) result(diag)
        logical(PRIF_ATOMIC_LOGICAL_KIND), intent(in) :: lhs, rhs
        type(test_diagnosis_t) :: diag

        diag = test_diagnosis_t(logical(lhs .eqv. rhs), &
             string_t("expected ") // merge('T','F',rhs) // "; actual value is " // merge('T','F',lhs))
    end function prif_logical_equals

    pure function subject()
        character(len=:), allocatable :: subject
        subject = "PRIF Atomics"
    end function

    function results() result(test_results)
        type(test_result_t), allocatable :: test_results(:)
        type(prif_atomic_test_t) prif_atomic_test

        allocate(test_results, source = prif_atomic_test%run([ &
              test_description_t("an uncontended atomic test", usher(check_atomic_uncontended)) &
            , test_description_t("a contended hot-spot atomic test", usher(check_atomic_contended)) &
        ]))
    end function

    subroutine test_srand(seed)
        integer, intent(in) :: seed
        integer :: size
        call random_seed(size=size)
        block
          integer :: vals(size)
          vals = seed
          call random_seed(put=vals)
        end block
    end subroutine

    function test_rand(lo, hi) result(result_)
        integer :: lo, hi, result_
        real :: r
        call random_number(r) ! Generate a uniform random number in [0, 1)
        result_ = int(r * (hi - lo + 1)) + lo
        call_julienne_assert((result_ .isAtLeast. lo) .also. (result_ .isAtMost. hi))
    end function

    function check_atomic_uncontended() result(diag)
        type(test_diagnosis_t) :: diag

        integer, parameter :: lim = 100
        integer :: me, num_imgs, peer, i
        integer(PRIF_ATOMIC_INT_KIND) :: dummy_atomic_int
        logical(PRIF_ATOMIC_LOGICAL_KIND) :: dummy_atomic_logical
        integer(c_size_t) :: sizeof_atomic_int, sizeof_atomic_logical
        type(prif_coarray_handle) :: coarray_handle_int, coarray_handle_logical
        type(c_ptr) :: c_ptr_int, c_ptr_logical

        integer(c_intptr_t) :: base_addr_int, base_addr_logical

        diag = .true.

        sizeof_atomic_int = int(storage_size(dummy_atomic_int)/8, c_size_t)
        sizeof_atomic_logical = int(storage_size(dummy_atomic_logical)/8, c_size_t)
        ! Check an invariant of the current Caffeine impl, not required by PRIF:
        call_julienne_assert(sizeof_atomic_int .equalsExpected. 8_c_size_t)
        call_julienne_assert(sizeof_atomic_logical .equalsExpected. 8_c_size_t)

        call prif_num_images(num_images=num_imgs)
        call prif_this_image_no_coarray(this_image=me)
        call test_srand(me)

        ! integer(PRIF_ATOMIC_INT_KIND) :: atomic_int[*]
        call prif_allocate_coarray( &
                lcobounds = [1_c_int64_t], &
                ucobounds = [integer(c_int64_t)::], &
                size_in_bytes = sizeof_atomic_int, &
                final_func = c_null_funptr, &
                coarray_handle = coarray_handle_int, &
                allocated_memory = c_ptr_int)
        base_addr_int = transfer(c_ptr_int, base_addr_int)

        ! logical(PRIF_ATOMIC_LOGICAL_KIND) :: atomic_logical[*]
        call prif_allocate_coarray( &
                lcobounds = [1_c_int64_t], &
                ucobounds = [integer(c_int64_t)::], &
                size_in_bytes = sizeof_atomic_logical, &
                final_func = c_null_funptr, &
                coarray_handle = coarray_handle_logical, &
                allocated_memory = c_ptr_logical)
        base_addr_logical = transfer(c_ptr_logical, base_addr_logical)

        block 
          integer(PRIF_ATOMIC_INT_KIND) :: value_int, expect_int
          logical(PRIF_ATOMIC_LOGICAL_KIND) :: value_logical, expect_logical

          ! local init and access operations

          do i=1, lim

            call prif_sync_all() ! only here for subtest isolation

            ! integer tests

            expect_int = me
            call prif_atomic_define_int(me, coarray_handle_int, 0_c_size_t, value=expect_int)
            call prif_atomic_ref_int(me, coarray_handle_int, 0_c_size_t, value=value_int)
            ALSO2(value_int .equalsExpected. expect_int, "local define direct / ref direct")
            call prif_atomic_ref_int_indirect(me, base_addr_int, value=value_int)
            ALSO2(value_int .equalsExpected. expect_int, "local define direct / ref indirect")

            expect_int = me * 100 
            call prif_atomic_define_int_indirect(me, base_addr_int, value=expect_int)
            call prif_atomic_ref_int_indirect(me, base_addr_int, value=value_int)
            ALSO2(value_int .equalsExpected. expect_int, "local define indirect / ref indirect")

            call prif_atomic_cas_int(me, coarray_handle_int, 0_c_size_t, &
                                     old=value_int, compare=expect_int, new=(expect_int*10))
            ALSO2(value_int .equalsExpected. expect_int, "local cas direct")
            expect_int = expect_int * 10

            call prif_atomic_cas_int_indirect(me, base_addr_int, &
                                              old=value_int, compare=expect_int, new=(expect_int*10))
            ALSO2(value_int .equalsExpected. expect_int, "local cas indirect")
            expect_int = expect_int * 10

            call prif_atomic_ref_int(me, coarray_handle_int, 0_c_size_t, value=value_int)
            ALSO2(value_int .equalsExpected. expect_int, "local cas / ref direct")

            expect_int = 0
            call prif_atomic_define_int(me, coarray_handle_int, 0_c_size_t, value=expect_int)
            call prif_atomic_ref_int(me, coarray_handle_int, 0_c_size_t, value=value_int)
            ALSO2(value_int .equalsExpected. expect_int, "local define direct / ref direct (final)")

            call prif_sync_all() ! only here for subtest isolation

            ! logical tests

            expect_logical = (IOR(me,1) == 1)
            call prif_atomic_define_logical(me, coarray_handle_logical, 0_c_size_t, value=expect_logical)
            call prif_atomic_ref_logical(me, coarray_handle_logical, 0_c_size_t, value=value_logical)
            ALSO2(value_logical .equalsExpected. expect_logical, "local define direct / ref direct)")
            call prif_atomic_ref_logical_indirect(me, base_addr_logical, value=value_logical)
            ALSO2(value_logical .equalsExpected. expect_logical, "local define direct / ref indirect")

            expect_logical = .not. expect_logical
            call prif_atomic_define_logical_indirect(me, base_addr_logical, value=expect_logical)
            call prif_atomic_ref_logical_indirect(me, base_addr_logical, value=value_logical)
            ALSO2(value_logical .equalsExpected. expect_logical, "local define indirect / ref indirect")

            call prif_atomic_cas_logical(me, coarray_handle_logical, 0_c_size_t, &
                                         old=value_logical, compare=expect_logical, new=(.not. expect_logical))
            ALSO2(value_logical .equalsExpected. expect_logical, "local cas direct")
            expect_logical = .not. expect_logical

            call prif_atomic_cas_logical_indirect(me, base_addr_logical, &
                                                  old=value_logical, compare=expect_logical, new=(.not. expect_logical))
            ALSO2(value_logical .equalsExpected. expect_logical, "local cas indirect")
            expect_logical = .not. expect_logical

            call prif_atomic_ref_logical(me, coarray_handle_logical, 0_c_size_t, value=value_logical)
            ALSO2(value_logical .equalsExpected. expect_logical, "local cas / ref direct")

            expect_logical = .false.
            call prif_atomic_define_logical(me, coarray_handle_logical, 0_c_size_t, value=expect_logical)
            call prif_atomic_ref_logical(me, coarray_handle_logical, 0_c_size_t, value=value_logical)
            ALSO2(value_logical .equalsExpected. expect_logical, "local define direct / ref direct (final)")

          end do

          call prif_sync_all()

          ! uncontended test targeting peer's location

          call_julienne_assert(expect_int .equalsExpected. 0_c_size_t)
          call_julienne_assert(logical(expect_logical .eqv. .false.))
          
          peer = mod(me,num_imgs)+1

          ! logical test

          do i=1, lim
          block
            character(:), allocatable :: test_desc
            logical(PRIF_ATOMIC_LOGICAL_KIND) :: tmp

            tmp = (IAND(i,1) == 1)
            select case (test_rand(1,3))
              case (1) ; test_desc = "define"
                expect_logical = tmp
                call prif_atomic_define_logical(peer, coarray_handle_logical, 0_c_size_t, value=expect_logical)

              case (2) ; test_desc = "cas succeed"
                call prif_atomic_cas_logical(peer, coarray_handle_logical, 0_c_size_t, &
                                         old=value_logical, compare=expect_logical, new=tmp)
                ALSO2(value_logical .equalsExpected. expect_logical, "int cas direct succeed")
                expect_logical = tmp

              case (3) ; test_desc = "cas fail"
                call prif_atomic_cas_logical(peer, coarray_handle_logical, 0_c_size_t, &
                                         old=value_logical, compare=(.not. expect_logical), new=tmp)
                ALSO2(value_logical .equalsExpected. expect_logical, "int cas direct fail")

              case default ; test_desc = "internal error"; call_julienne_assert(.false.)
            end select

            call prif_atomic_ref_logical(peer, coarray_handle_logical, 0_c_size_t, value=value_logical)
            ALSO2(value_logical .equalsExpected. expect_logical, "result check for peer int "//test_desc)
          end block
          end do

          call prif_sync_all() ! only here for subtest isolation

          ! integer test

          do i=1, lim
          block
            character(:), allocatable :: test_desc
            integer(PRIF_ATOMIC_INT_KIND) :: tmp

            tmp = i
            select case (test_rand(1,11))
              case (1) ; test_desc = "define"
                expect_int = i
                call prif_atomic_define_int(peer, coarray_handle_int, 0_c_size_t, value=expect_int)

              case (2) ; test_desc = "cas succeed"
                call prif_atomic_cas_int(peer, coarray_handle_int, 0_c_size_t, &
                                         old=value_int, compare=expect_int, new=tmp)
                ALSO2(value_int .equalsExpected. expect_int, "int cas direct succeed")
                expect_int = tmp

              case (3) ; test_desc = "cas fail"
                call prif_atomic_cas_int(peer, coarray_handle_int, 0_c_size_t, &
                                         old=value_int, compare=expect_int+1, new=tmp)
                ALSO2(value_int .equalsExpected. expect_int, "int cas direct fail")

              case (4) ; test_desc = "add"
                call prif_atomic_add(peer, coarray_handle_int, 0_c_size_t, value=tmp)
                expect_int = expect_int + tmp

              case (5) ; test_desc = "fetch_add"
                call prif_atomic_fetch_add(peer, coarray_handle_int, 0_c_size_t, value=tmp, old=value_int)
                ALSO2(value_int .equalsExpected. expect_int, "fetch_add fetch check")
                expect_int = expect_int + tmp

              case (6) ; test_desc = "and"
                call prif_atomic_and(peer, coarray_handle_int, 0_c_size_t, value=tmp)
                expect_int = IAND(expect_int, tmp)

              case (7) ; test_desc = "fetch_and"
                call prif_atomic_fetch_and(peer, coarray_handle_int, 0_c_size_t, value=tmp, old=value_int)
                ALSO2(value_int .equalsExpected. expect_int, "fetch_and fetch check")
                expect_int = IAND(expect_int, tmp)

              case (8) ; test_desc = "or"
                call prif_atomic_or(peer, coarray_handle_int, 0_c_size_t, value=tmp)
                expect_int = IOR(expect_int, tmp)

              case (9) ; test_desc = "fetch_or"
                call prif_atomic_fetch_or(peer, coarray_handle_int, 0_c_size_t, value=tmp, old=value_int)
                ALSO2(value_int .equalsExpected. expect_int, "fetch_or fetch check")
                expect_int = IOR(expect_int, tmp)

              case (10) ; test_desc = "xor"
                call prif_atomic_xor(peer, coarray_handle_int, 0_c_size_t, value=tmp)
                expect_int = IEOR(expect_int, tmp)

              case (11) ; test_desc = "fetch_xor"
                call prif_atomic_fetch_xor(peer, coarray_handle_int, 0_c_size_t, value=tmp, old=value_int)
                ALSO2(value_int .equalsExpected. expect_int, "fetch_xor fetch check")
                expect_int = IEOR(expect_int, tmp)

              case default ; test_desc = "internal error"; call_julienne_assert(.false.)

            end select

            call prif_atomic_ref_int(peer, coarray_handle_int, 0_c_size_t, value=value_int)
            ALSO2(value_int .equalsExpected. expect_int, "result check for peer int "//test_desc)
          end block
          end do

        end block

        call prif_deallocate_coarrays(([coarray_handle_int,coarray_handle_logical]))
    end function

    function check_atomic_contended() result(diag)
        type(test_diagnosis_t) diag

        integer, parameter :: lim = 100
        integer :: me, num_imgs, root, i
        integer(PRIF_ATOMIC_INT_KIND) :: dummy_atomic_int
        logical(PRIF_ATOMIC_LOGICAL_KIND) :: dummy_atomic_logical
        integer(c_size_t) :: sizeof_atomic_int, sizeof_atomic_logical
        type(c_ptr) :: c_ptr_int, c_ptr_logical
        integer(c_intptr_t) :: base_addr_int, base_addr_logical
        integer(PRIF_ATOMIC_INT_KIND), parameter :: zero = 0, plus_one = 1, minus_one = -1
        integer(PRIF_ATOMIC_INT_KIND) :: value_int, expect_int, tmp_int, my_bit
        logical(PRIF_ATOMIC_LOGICAL_KIND) :: false = .false.
        logical(PRIF_ATOMIC_LOGICAL_KIND) :: value_logical, expect_logical, tmp_logical
        character(len=:),allocatable :: desc

        diag = .true.

        sizeof_atomic_int = int(storage_size(dummy_atomic_int)/8, c_size_t)
        sizeof_atomic_logical = int(storage_size(dummy_atomic_logical)/8, c_size_t)

        call prif_num_images(num_images=num_imgs)
        call prif_this_image_no_coarray(this_image=me)
        call test_srand(me)
        root = 1

        ! allocate centralized atomic variables on the root image
        if (me == root) then
          call prif_allocate(sizeof_atomic_int, c_ptr_int)
          base_addr_int = transfer(c_ptr_int, base_addr_int)
          call prif_atomic_define_int_indirect(me, base_addr_int, value=zero)

          call prif_allocate(sizeof_atomic_logical, c_ptr_logical)
          base_addr_logical = transfer(c_ptr_logical, base_addr_logical)
          call prif_atomic_define_logical_indirect(me, base_addr_logical, value=false)
        endif
        call prif_co_broadcast(base_addr_int, root)
        call prif_co_broadcast(base_addr_logical, root)

        desc = "integer add-up test "
        expect_int = zero
        do i=1, lim

          call prif_sync_all()

          call prif_atomic_add_indirect(root, base_addr_int, value=plus_one)
          call prif_atomic_add_indirect(root, base_addr_int, value=minus_one)
          call prif_atomic_fetch_add_indirect(root, base_addr_int, value=plus_one, old=value_int)
          ALSO2(value_int .isAtLeast.  expect_int, desc//"mid-increment lower bound")
          ALSO2(value_int .lessThan. (expect_int + num_imgs), desc//"mid-increment upper bound")

          call prif_sync_all()

          expect_int = expect_int + num_imgs
          call prif_atomic_ref_int_indirect(root, base_addr_int, value=value_int)
          ALSO2(value_int .equalsExpected. expect_int, desc//"loop-bottom check")
        end do


        desc = "integer cas-up test "
        do i=1, MAX(2,lim/num_imgs**2) ! running time grows superlinearly with scale due to contention

          call prif_sync_all()

          tmp_int = expect_int
          do
            call prif_atomic_cas_int_indirect(root, base_addr_int, &
                                              old=value_int, compare=tmp_int, new=(tmp_int+1))
            ALSO2(value_int .isAtLeast. expect_int, desc//"mid-increment lower bound")
            ALSO2(value_int .lessThan. (expect_int + num_imgs), desc//"mid-increment upper bound")
            if (value_int == tmp_int) exit ! success 
            tmp_int = value_int ! collision => retry
          end do

          call prif_sync_all()

          expect_int = expect_int + num_imgs
          call prif_atomic_ref_int_indirect(root, base_addr_int, value=value_int)
          ALSO2(value_int .equalsExpected. expect_int, desc//"loop-bottom check")
        end do


        desc = "logical cas-toggle test "
        expect_logical = false
        do i=1, MAX(2,lim/num_imgs**2) ! running time grows superlinearly with scale due to contention

          call prif_sync_all()

          tmp_logical = expect_logical
          do
            call prif_atomic_cas_logical_indirect(root, base_addr_logical, &
                                              old=value_logical, compare=tmp_logical, new=(.not. tmp_logical))
            if (value_logical .eqv. tmp_logical) exit ! success 
            ALSO2(logical(value_logical .eqv. .not. tmp_logical), desc//"mid-swap sanity check")
            tmp_logical = value_logical ! collision => retry
          end do

          call prif_sync_all()

          expect_logical = merge(expect_logical, .not. expect_logical, mod(num_imgs,2) == 0)
          call prif_atomic_ref_logical_indirect(root, base_addr_logical, value=value_logical)
          ALSO2(value_logical .equalsExpected. expect_logical, desc//"loop-bottom check")
        end do

        call prif_sync_all()
        if (me == root) then
          call prif_atomic_define_int_indirect(me, base_addr_int, value=zero)
        endif
        call prif_sync_all()

        desc = "randomized integer bitwise test "
        if (me <= sizeof_atomic_int*8) then
          my_bit = SHIFTL(plus_one, me-1) 
        else
          my_bit = 0
        endif
        expect_int = 0
        do i=1, lim
        block
          character(:), allocatable :: test_desc

          select case (test_rand(1,6))
            case (1) ; test_desc = "and"
              call prif_atomic_and_indirect(root, base_addr_int, value=NOT(my_bit))
              expect_int = IAND(expect_int, NOT(my_bit))

            case (2) ; test_desc = "fetch_and"
              call prif_atomic_fetch_and_indirect(root, base_addr_int, value=NOT(my_bit), old=value_int)
              ALSO2(IAND(value_int,my_bit) .equalsExpected. expect_int, desc//"fetch_and fetch check")
              expect_int = IAND(expect_int, NOT(my_bit))

            case (3) ; test_desc = "or"
              call prif_atomic_or_indirect(root, base_addr_int, value=my_bit)
              expect_int = IOR(expect_int, my_bit)

            case (4) ; test_desc = "fetch_or"
              call prif_atomic_fetch_or_indirect(root, base_addr_int, value=my_bit, old=value_int)
              ALSO2(IAND(value_int,my_bit) .equalsExpected. expect_int, desc//"fetch_or fetch check")
              expect_int = IOR(expect_int, my_bit)

            case (5) ; test_desc = "xor"
              call prif_atomic_xor_indirect(root, base_addr_int, value=my_bit)
              expect_int = IEOR(expect_int, my_bit)

            case (6) ; test_desc = "fetch_xor"
              call prif_atomic_fetch_xor_indirect(root, base_addr_int, value=my_bit, old=value_int)
              ALSO2(IAND(value_int,my_bit) .equalsExpected. expect_int, desc//"fetch_xor fetch check")
              expect_int = IEOR(expect_int, my_bit)

            case default ; test_desc = "internal error"; call_julienne_assert(.false.)

          end select

          call prif_atomic_ref_int_indirect(root, base_addr_int, value=value_int)
          ALSO2(IAND(value_int,my_bit) .equalsExpected. expect_int, desc//"result check for int "//test_desc)

        end block
        end do

        call prif_sync_all()
        if (me == root) then
          call prif_deallocate(c_ptr_int)
          call prif_deallocate(c_ptr_logical)
        endif
    end function

end module

! Copyright (c), The Regents of the University
! Terms of use are as specified in LICENSE.txt
module unit_test_parameters_m
  use iso_c_binding, only: c_int
  use prif, only: prif_sync_all, prif_this_image_no_coarray
  !! Define values and utilities for consistent use throughout the test suite
  implicit none

  public

  integer(c_int), parameter :: expected_stop_code=99, expected_error_stop_code=100
      ! used in stop/error-stop unit tests and example/test-support supporting programs

  character(len=:), allocatable :: subjob_prefix
  character(len=:), allocatable :: fpm_driver

contains

  ! Retrieve an environment parameter or its default value
  subroutine getenv_withdefault(key, default, result)
    use iso_fortran_env, only: error_unit
    character(len=*), intent(in) :: key, default
    character(len=:), allocatable, intent(inout) :: result
    character(len=:), allocatable :: suffix

    character :: dummy
    integer :: len

    ! TODO: it would be preferable to consult the GASNet global environment, when available
    call get_environment_variable(key, dummy, len)
    if (len > 0) then
      allocate(character(len=len)::result)
      call get_environment_variable(key, result, len)
      result = trim(adjustl(result))
      suffix = ""
    else 
      result = default
      suffix = " (default)"
    endif

    ! report the envvar in verbose mode
    call get_environment_variable("GASNET_VERBOSEENV", dummy, len)
    if (len > 0) then
      write(error_unit, '(A, T64, A)') "ENV parameter: "//key//"='"//result//"'", suffix
    end if
  end subroutine

  ! subjob support used by stop/error-stop unit tests
  ! setup for subjob launch, initializes subjob_prefix and
  ! returns whether this is the first image
  function subjob_setup() result(result_)
    logical :: result_
    integer :: me
  
    if (.not. allocated(subjob_prefix)) then
      call getenv_withdefault("SUBJOB_PREFIX", "", subjob_prefix)
      if (len(subjob_prefix) > 0) subjob_prefix = subjob_prefix//" "
    end if
    if (.not. allocated(fpm_driver)) then
      call getenv_withdefault("FPM_DRIVER", "./run-fpm.sh", fpm_driver)
    end if
        
    call prif_sync_all()
    call prif_this_image_no_coarray(this_image=me)
    result_ = (me == 1) .and. (trim(subjob_prefix) /= "skip")
  end function 


end module unit_test_parameters_m

#include "test-utils.F90"

module prif_coarray_inquiry_test_m
# include "test-uses-alloc.F90"
  use prif, only : &
      prif_coarray_handle, prif_num_images, &
      prif_local_data_pointer, prif_size_bytes, &
      prif_lcobound_no_dim, prif_lcobound_with_dim, &
      prif_ucobound_no_dim, prif_ucobound_with_dim, &
      prif_coshape

  use julienne_m, only: &
     operator(//) &
    ,operator(.all.) &
    ,operator(.also.) &
    ,operator(.equalsExpected.) &
    ,usher &
    ,string_t &
    ,test_description_t &
    ,test_diagnosis_t &
    ,test_result_t &
    ,test_t

  implicit none
  private
  public :: prif_coarray_inquiry_test_t

  type, extends(test_t) :: prif_coarray_inquiry_test_t
  contains
    procedure, nopass, non_overridable :: subject
    procedure, nopass, non_overridable :: results
  end type

contains

  pure function subject() result(test_subject)
     character(len=:), allocatable :: test_subject
     test_subject = "PRIF Coarray Inquiries"
  end function

  function results() result(test_results)
    type(test_result_t), allocatable :: test_results(:)
    type(prif_coarray_inquiry_test_t) prif_coarray_inquiry_test

    allocate(test_results, source = prif_coarray_inquiry_test%run([ &
       test_description_t("preserving the prif_local_data_pointer for an allocated coarray", usher(check_prif_local_data_pointer)) &
      ,test_description_t("checking passed cobounds", usher(check_cobounds)) &
    ]))
  end function

  function check_prif_local_data_pointer() result(diag)
      type(test_diagnosis_t) :: diag

      integer :: dummy_element
      type(prif_coarray_handle) :: coarray_handle
      type(c_ptr) :: allocation_ptr, local_ptr


      call prif_allocate_coarray( &
              [integer(c_int64_t):: 1], &
              [integer(c_int64_t)::], &
              int(storage_size(dummy_element)/8, c_size_t), &
              c_null_funptr, &
              coarray_handle, &
              allocation_ptr)
      call prif_local_data_pointer(coarray_handle, local_ptr)
      diag = c_associated(local_ptr, allocation_ptr)
      call prif_deallocate_coarray(coarray_handle)
  end function

  impure elemental function check_cobound(corank, omit_trailing) result(diag)
    type(test_diagnosis_t) :: diag
    integer(c_int), intent(in) :: corank
    logical, intent(in) :: omit_trailing

    ! Allocate memory for an integer scalar coarray with given corank
    ! and then test some queries on it

    integer :: num_imgs, i
    integer(kind=c_int64_t), dimension(corank) :: lcobounds, ucobounds, tmp_bounds
    integer(kind=c_int64_t), dimension(corank-1) :: leading_ucobounds
    integer(kind=c_int64_t) :: tmp_bound
    integer(kind=c_size_t), dimension(corank)  :: sizes
    type(prif_coarray_handle) :: coarray_handle
    type(c_ptr) :: allocated_memory
    integer(c_size_t) :: data_size, query_size

    diag = .true.

    call prif_num_images(num_images=num_imgs)
    lcobounds(1) = 1
    ucobounds(1) = num_imgs
    do i = 2,corank
      lcobounds(i) = i
      ucobounds(i) = i + merge(1,0,mod(i,2)==0)
    end do

    allocated_memory = c_null_ptr
    data_size = 64 * corank

    if (omit_trailing) then
      leading_ucobounds = ucobounds(1:corank-1)
      call prif_allocate_coarray( lcobounds, leading_ucobounds, data_size, c_null_funptr, &
        coarray_handle, allocated_memory)
    else
      call prif_allocate_coarray( lcobounds, ucobounds, data_size, c_null_funptr, &
        coarray_handle, allocated_memory)
    end if

    if (corank > 1) ucobounds(corank) = lcobounds(corank) ! trailing ucobound gets rounded down

    ALSO(c_associated(allocated_memory))

    call prif_size_bytes(coarray_handle, data_size=query_size)
    ALSO2(query_size .equalsExpected. data_size, "prif_size_bytes is valid")

    call prif_lcobound_no_dim(coarray_handle, tmp_bounds)
    ALSO2(.all. (tmp_bounds .equalsExpected. lcobounds), "prif_lcobound_no_dim is valid")

    call prif_ucobound_no_dim(coarray_handle, tmp_bounds)
    ALSO2(.all. (tmp_bounds .equalsExpected. ucobounds), "prif_ucobound_no_dim is valid")

    do i = 1, corank
      call prif_lcobound_with_dim(coarray_handle, i, tmp_bound)
      ALSO2(tmp_bound .equalsExpected. lcobounds(i), "prif_lcobound_with_dim is valid")

      call prif_ucobound_with_dim(coarray_handle, i, tmp_bound)
      ALSO2(tmp_bound .equalsExpected. ucobounds(i), "prif_ucobound_with_dim is valid")
    end do

    call prif_coshape(coarray_handle, sizes)
    ALSO2(.all. ((ucobounds - lcobounds + 1) .equalsExpected. sizes), "prif_coshape is valid")

    call prif_deallocate_coarray(coarray_handle)
  end function

  function check_cobounds() result(diag)
    type(test_diagnosis_t) :: diag
    integer(c_int) :: corank

    diag = .true.

    ALSO(.all. check_cobound([(corank, corank = 1_c_int, 15_c_int)], .false.))
    ALSO(.all. check_cobound([(corank, corank = 1_c_int, 15_c_int)], .true.))
  end function

end module prif_coarray_inquiry_test_m

! Copyright (c), The Regents of the University of California
! Terms of use are as specified in LICENSE.txt

#include "language-support.F90"

module prif

  use iso_c_binding, only: &
      c_char, c_int, c_bool, c_intptr_t, c_ptr, &
      c_funptr, c_size_t, c_ptrdiff_t, c_null_ptr, c_int64_t
#if HAVE_LOGICAL64
  use iso_fortran_env, only: logical64
#endif
#if CAF_IMPORT_ATOMIC_CONSTANTS
  use iso_fortran_env, only: ATOMIC_INT_KIND, ATOMIC_LOGICAL_KIND
#endif
#if CAF_IMPORT_STAT_CONSTANTS
  use iso_fortran_env, only: &
      STAT_FAILED_IMAGE, STAT_STOPPED_IMAGE, &
      STAT_LOCKED, STAT_LOCKED_OTHER_IMAGE, &
      STAT_UNLOCKED, STAT_UNLOCKED_FAILED_IMAGE
#endif
#if CAF_IMPORT_TEAM_CONSTANTS
  use iso_fortran_env, only: CURRENT_TEAM, INITIAL_TEAM, PARENT_TEAM
#endif

  implicit none

  private
  public :: prif_init
  public :: prif_register_stop_callback, prif_stop_callback_interface
  public :: prif_stop, prif_error_stop, prif_fail_image
  public :: prif_allocate_coarray, prif_allocate, prif_deallocate
#if CAF_PRIF_VERSION <= 6
  public :: prif_deallocate_coarray
#else
  public :: prif_deallocate_coarray, prif_deallocate_coarrays
#endif
  public :: prif_put, prif_put_indirect, prif_get, prif_get_indirect, prif_put_with_notify, prif_put_with_notify_indirect
  public :: prif_put_indirect_with_notify, prif_put_indirect_with_notify_indirect
  public :: prif_get_strided, prif_get_strided_indirect, prif_put_strided, prif_put_strided_indirect
  public :: prif_put_strided_with_notify, prif_put_strided_with_notify_indirect
  public :: prif_put_strided_indirect_with_notify, prif_put_strided_indirect_with_notify_indirect
  public :: prif_alias_create, prif_alias_destroy
  public :: prif_lcobound_with_dim, prif_lcobound_no_dim, prif_ucobound_with_dim, prif_ucobound_no_dim, prif_coshape
  public :: prif_image_index, prif_image_index_with_team, prif_image_index_with_team_number
  public :: prif_initial_team_index, prif_initial_team_index_with_team, prif_initial_team_index_with_team_number
  public :: prif_this_image_no_coarray, prif_this_image_with_coarray, prif_this_image_with_dim
  public :: prif_num_images, prif_num_images_with_team, prif_num_images_with_team_number
  public :: prif_failed_images, prif_stopped_images, prif_image_status
  public :: prif_local_data_pointer, prif_set_context_data, prif_get_context_data, prif_size_bytes
  public :: prif_co_sum, prif_co_max, prif_co_min, prif_co_reduce, prif_co_broadcast
  public :: prif_co_min_character, prif_co_max_character
  public :: prif_operation_wrapper_interface
  public :: prif_form_team, prif_change_team, prif_end_team, prif_get_team, prif_team_number
  public :: prif_sync_all, prif_sync_images, prif_sync_team, prif_sync_memory
  public :: prif_lock, prif_lock_indirect, prif_unlock, prif_unlock_indirect
  public :: prif_critical, prif_end_critical
  public :: prif_event_post, prif_event_post_indirect, prif_event_wait, prif_event_query
  public :: prif_notify_wait
  public :: prif_atomic_add, prif_atomic_add_indirect, prif_atomic_and, prif_atomic_and_indirect
  public :: prif_atomic_or, prif_atomic_or_indirect, prif_atomic_xor, prif_atomic_xor_indirect
  public :: prif_atomic_cas_int, prif_atomic_cas_int_indirect, prif_atomic_cas_logical, prif_atomic_cas_logical_indirect
  public :: prif_atomic_fetch_add, prif_atomic_fetch_add_indirect
  public :: prif_atomic_fetch_and, prif_atomic_fetch_and_indirect, prif_atomic_fetch_or, prif_atomic_fetch_or_indirect
  public :: prif_atomic_fetch_xor, prif_atomic_fetch_xor_indirect
  public :: prif_atomic_define_int, prif_atomic_define_int_indirect, prif_atomic_define_logical, prif_atomic_define_logical_indirect
  public :: prif_atomic_ref_int, prif_atomic_ref_int_indirect, prif_atomic_ref_logical, prif_atomic_ref_logical_indirect

  integer(c_int), parameter, public :: PRIF_VERSION_MAJOR = CAF_PRIF_VERSION_MAJOR
  integer(c_int), parameter, public :: PRIF_VERSION_MINOR = CAF_PRIF_VERSION_MINOR

#if CAF_IMPORT_ATOMIC_CONSTANTS
   integer, parameter, public :: PRIF_ATOMIC_INT_KIND =     ATOMIC_INT_KIND
   integer, parameter, public :: PRIF_ATOMIC_LOGICAL_KIND = ATOMIC_LOGICAL_KIND
#else
   integer, parameter, public :: PRIF_ATOMIC_INT_KIND = c_int64_t

#  if HAVE_SELECTED_LOGICAL_KIND
     integer, parameter, public :: PRIF_ATOMIC_LOGICAL_KIND = selected_logical_kind(64)
#  elif HAVE_LOGICAL64
     integer, parameter, public :: PRIF_ATOMIC_LOGICAL_KIND = logical64
#  else
     integer, parameter, public :: PRIF_ATOMIC_LOGICAL_KIND = PRIF_ATOMIC_INT_KIND
#  endif
#endif

#if CAF_IMPORT_TEAM_CONSTANTS
  integer(c_int), parameter, public :: &
    PRIF_CURRENT_TEAM               = CURRENT_TEAM, &
    PRIF_INITIAL_TEAM               = INITIAL_TEAM, &
    PRIF_PARENT_TEAM                = PARENT_TEAM
#else
  integer(c_int), parameter, public :: &
    PRIF_CURRENT_TEAM               = 101, &
    PRIF_INITIAL_TEAM               = 102, &
    PRIF_PARENT_TEAM                = 103
#endif

#if CAF_IMPORT_STAT_CONSTANTS
  integer(c_int), parameter, public :: &
    PRIF_STAT_FAILED_IMAGE          = STAT_FAILED_IMAGE, &
    PRIF_STAT_LOCKED                = STAT_LOCKED, &
    PRIF_STAT_LOCKED_OTHER_IMAGE    = STAT_LOCKED_OTHER_IMAGE, &
    PRIF_STAT_STOPPED_IMAGE         = STAT_STOPPED_IMAGE, &
    PRIF_STAT_UNLOCKED              = STAT_UNLOCKED, &
    PRIF_STAT_UNLOCKED_FAILED_IMAGE = STAT_UNLOCKED_FAILED_IMAGE
#else
  integer(c_int), parameter, public :: &
    PRIF_STAT_FAILED_IMAGE          =-201, &
    PRIF_STAT_LOCKED                = 202, &
    PRIF_STAT_LOCKED_OTHER_IMAGE    = 203, &
    PRIF_STAT_STOPPED_IMAGE         = 204, &
    PRIF_STAT_UNLOCKED              = 205, &
    PRIF_STAT_UNLOCKED_FAILED_IMAGE = 206
#endif

  integer(c_int), parameter, public :: &
    PRIF_STAT_OUT_OF_MEMORY         = 301, &
    PRIF_STAT_ALREADY_INIT          = 302

  integer(c_int), parameter, private :: &
    CAF_STAT_INVALID_ARGUMENT       = 404

  type, public :: prif_event_type
    private
    integer(PRIF_ATOMIC_INT_KIND) :: counter = 0
  end type

  type, public :: prif_lock_type
    private
    ! TODO: actual implementation
    integer :: unimplemented_feature_placeholder = 0
  end type

  type, public :: prif_critical_type
    private
    ! TODO: actual implementation
    integer :: unimplemented_feature_placeholder = 0
  end type

  type, public :: prif_notify_type
    private
    integer(PRIF_ATOMIC_INT_KIND) :: counter = 0
  end type

  type, public :: prif_coarray_handle
    private
    type(prif_coarray_descriptor), pointer :: info
  end type

  type, public :: prif_team_type
    private
    type(prif_team_descriptor), pointer :: info => null()
  end type

  abstract interface
    subroutine prif_stop_callback_interface( &
          is_error_stop, quiet, stop_code_int, stop_code_char)
      import :: c_bool, c_int
      implicit none
      logical(c_bool), intent(in) :: is_error_stop, quiet
      integer(c_int), intent(in), optional :: stop_code_int
      character(len=*), intent(in), optional :: stop_code_char
    end subroutine

    subroutine prif_operation_wrapper_interface(arg1, arg2_and_out, count, cdata) bind(C)
      import :: c_ptr, c_size_t
      implicit none
      type(c_ptr), intent(in), value :: arg1, arg2_and_out
      integer(c_size_t), intent(in), value :: count
      type(c_ptr), intent(in), value :: cdata
    end subroutine
  end interface

  interface

    module subroutine prif_init(stat)
      implicit none
      integer(c_int), intent(out) :: stat
    end subroutine

    module subroutine prif_register_stop_callback(callback)
      implicit none
      procedure(prif_stop_callback_interface), pointer, intent(in) :: callback
    end subroutine

    module subroutine prif_stop(quiet, stop_code_int, stop_code_char)
      implicit none
      logical(c_bool), intent(in) :: quiet
      integer(c_int), intent(in), optional :: stop_code_int
      character(len=*), intent(in), optional :: stop_code_char
    end subroutine

    module subroutine prif_error_stop(quiet, stop_code_int, stop_code_char)
      implicit none
      logical(c_bool), intent(in) :: quiet
      integer(c_int), intent(in), optional :: stop_code_int
      character(len=*), intent(in), optional :: stop_code_char
    end subroutine

    module subroutine prif_fail_image()
      implicit none
    end subroutine

    module subroutine prif_allocate_coarray( &
        lcobounds, ucobounds, size_in_bytes, final_func, coarray_handle, &
        allocated_memory, stat, errmsg, errmsg_alloc)
      implicit none
      integer(c_int64_t), dimension(:), intent(in) :: lcobounds, ucobounds
      integer(c_size_t), intent(in) :: size_in_bytes
      type(c_funptr), intent(in) :: final_func
      type(prif_coarray_handle), intent(out) :: coarray_handle
      type(c_ptr), intent(out) :: allocated_memory
      integer(c_int), intent(out), optional :: stat
      character(len=*), intent(inout), optional :: errmsg
      character(len=:), intent(inout), allocatable, optional :: errmsg_alloc
    end subroutine

    module subroutine prif_allocate(size_in_bytes, allocated_memory, stat, errmsg, errmsg_alloc)
      implicit none
      integer(c_size_t) :: size_in_bytes
      type(c_ptr), intent(out) :: allocated_memory
      integer(c_int), intent(out), optional :: stat
      character(len=*), intent(inout), optional :: errmsg
      character(len=:), intent(inout), allocatable, optional :: errmsg_alloc
    end subroutine

#if CAF_PRIF_VERSION <= 6
    module subroutine prif_deallocate_coarray(coarray_handles, stat, errmsg, errmsg_alloc)
      implicit none
      type(prif_coarray_handle), intent(in) :: coarray_handles(:)
      integer(c_int), intent(out), optional :: stat
      character(len=*), intent(inout), optional :: errmsg
      character(len=:), intent(inout), allocatable, optional :: errmsg_alloc
    end subroutine
#else
    module subroutine prif_deallocate_coarray(coarray_handle, stat, errmsg, errmsg_alloc)
      implicit none
      type(prif_coarray_handle), intent(in) :: coarray_handle
      integer(c_int), intent(out), optional :: stat
      character(len=*), intent(inout), optional :: errmsg
      character(len=:), intent(inout), allocatable, optional :: errmsg_alloc
    end subroutine
    module subroutine prif_deallocate_coarrays(coarray_handles, stat, errmsg, errmsg_alloc)
      implicit none
      type(prif_coarray_handle), intent(in) :: coarray_handles(:)
      integer(c_int), intent(out), optional :: stat
      character(len=*), intent(inout), optional :: errmsg
      character(len=:), intent(inout), allocatable, optional :: errmsg_alloc
    end subroutine
#endif

    module subroutine prif_deallocate(mem, stat, errmsg, errmsg_alloc)
      implicit none
      type(c_ptr), intent(in) :: mem
      integer(c_int), intent(out), optional :: stat
      character(len=*), intent(inout), optional :: errmsg
      character(len=:), intent(inout), allocatable, optional :: errmsg_alloc
    end subroutine

    module subroutine prif_put( &
        image_num, coarray_handle, offset, current_image_buffer, size_in_bytes, stat, errmsg, errmsg_alloc)
      implicit none
      integer(c_int), intent(in) :: image_num
      type(prif_coarray_handle), intent(in) :: coarray_handle
      integer(c_size_t), intent(in) :: offset
      type(c_ptr), intent(in) :: current_image_buffer
      integer(c_size_t), intent(in) :: size_in_bytes
      integer(c_int), intent(out), optional :: stat
      character(len=*), intent(inout), optional :: errmsg
      character(len=:), intent(inout), allocatable, optional :: errmsg_alloc
    end subroutine

    module subroutine prif_put_indirect( &
        image_num, remote_ptr, current_image_buffer, size_in_bytes, stat, errmsg, errmsg_alloc)
      implicit none
      integer(c_int), intent(in) :: image_num
      integer(c_intptr_t), intent(in) :: remote_ptr
      type(c_ptr), intent(in) :: current_image_buffer
      integer(c_size_t), intent(in) :: size_in_bytes
      integer(c_int), intent(out), optional :: stat
      character(len=*), intent(inout), optional :: errmsg
      character(len=:), intent(inout), allocatable, optional :: errmsg_alloc
    end subroutine

    module subroutine prif_put_with_notify( &
        image_num, coarray_handle, offset, current_image_buffer, size_in_bytes, &
        notify_coarray_handle, notify_offset, stat, errmsg, errmsg_alloc)
      implicit none
      integer(c_int), intent(in) :: image_num
      type(prif_coarray_handle), intent(in) :: coarray_handle
      integer(c_size_t), intent(in) :: offset
      type(c_ptr), intent(in) :: current_image_buffer
      integer(c_size_t), intent(in) :: size_in_bytes
      type(prif_coarray_handle), intent(in) :: notify_coarray_handle
      integer(c_size_t), intent(in) :: notify_offset
      integer(c_int), intent(out), optional :: stat
      character(len=*), intent(inout), optional :: errmsg
      character(len=:), intent(inout), allocatable, optional :: errmsg_alloc
    end subroutine

    module subroutine prif_put_with_notify_indirect( &
        image_num, coarray_handle, offset, current_image_buffer, size_in_bytes, notify_ptr, stat, errmsg, errmsg_alloc)
      implicit none
      integer(c_int), intent(in) :: image_num
      type(prif_coarray_handle), intent(in) :: coarray_handle
      integer(c_size_t), intent(in) :: offset
      type(c_ptr), intent(in) :: current_image_buffer
      integer(c_size_t), intent(in) :: size_in_bytes
      integer(c_intptr_t), intent(in) :: notify_ptr
      integer(c_int), intent(out), optional :: stat
      character(len=*), intent(inout), optional :: errmsg
      character(len=:), intent(inout), allocatable, optional :: errmsg_alloc
    end subroutine

    module subroutine prif_put_indirect_with_notify( &
        image_num, remote_ptr, current_image_buffer, size_in_bytes, notify_coarray_handle, notify_offset, &
        stat, errmsg, errmsg_alloc)
      implicit none
      integer(c_int), intent(in) :: image_num
      integer(c_intptr_t), intent(in) :: remote_ptr
      type(c_ptr), intent(in) :: current_image_buffer
      integer(c_size_t), intent(in) :: size_in_bytes
      type(prif_coarray_handle), intent(in) :: notify_coarray_handle
      integer(c_size_t), intent(in) :: notify_offset
      integer(c_int), intent(out), optional :: stat
      character(len=*), intent(inout), optional :: errmsg
      character(len=:), intent(inout), allocatable, optional :: errmsg_alloc
    end subroutine

    module subroutine prif_put_indirect_with_notify_indirect( &
        image_num, remote_ptr, current_image_buffer, size_in_bytes, notify_ptr, stat, errmsg, errmsg_alloc)
      implicit none
      integer(c_int), intent(in) :: image_num
      integer(c_intptr_t), intent(in) :: remote_ptr
      type(c_ptr), intent(in) :: current_image_buffer
      integer(c_size_t), intent(in) :: size_in_bytes
      integer(c_intptr_t), intent(in) :: notify_ptr
      integer(c_int), intent(out), optional :: stat
      character(len=*), intent(inout), optional :: errmsg
      character(len=:), intent(inout), allocatable, optional :: errmsg_alloc
    end subroutine

    module subroutine prif_get( &
        image_num, coarray_handle, offset, current_image_buffer, size_in_bytes, stat, errmsg, errmsg_alloc)
      implicit none
      integer(c_int), intent(in) :: image_num
      type(prif_coarray_handle), intent(in) :: coarray_handle
      integer(c_size_t), intent(in) :: offset
      type(c_ptr), intent(in) :: current_image_buffer
      integer(c_size_t), intent(in) :: size_in_bytes
      integer(c_int), intent(out), optional :: stat
      character(len=*), intent(inout), optional :: errmsg
      character(len=:), intent(inout), allocatable, optional :: errmsg_alloc
    end subroutine

    module subroutine prif_get_indirect(image_num, remote_ptr, current_image_buffer, size_in_bytes, stat, errmsg, errmsg_alloc)
      implicit none
      integer(c_int), intent(in) :: image_num
      integer(c_intptr_t), intent(in) :: remote_ptr
      type(c_ptr), intent(in) :: current_image_buffer
      integer(c_size_t), intent(in) :: size_in_bytes
      integer(c_int), intent(out), optional :: stat
      character(len=*), intent(inout), optional :: errmsg
      character(len=:), intent(inout), allocatable, optional :: errmsg_alloc
    end subroutine

    module subroutine prif_get_strided( &
        image_num, coarray_handle, offset, remote_stride, current_image_buffer, current_image_stride, &
        element_size, extent, stat, errmsg, errmsg_alloc)
      implicit none
      integer(c_int), intent(in) :: image_num
      type(prif_coarray_handle), intent(in) :: coarray_handle
      integer(c_size_t), intent(in) :: offset
      integer(c_ptrdiff_t), intent(in) :: remote_stride(:)
      type(c_ptr), intent(in) :: current_image_buffer
      integer(c_ptrdiff_t), intent(in) :: current_image_stride(:)
      integer(c_size_t), intent(in) :: element_size
      integer(c_size_t), intent(in) :: extent(:)
      integer(c_int), intent(out), optional :: stat
      character(len=*), intent(inout), optional :: errmsg
      character(len=:), intent(inout), allocatable, optional :: errmsg_alloc
    end subroutine

    module subroutine prif_get_strided_indirect( &
        image_num, remote_ptr, remote_stride, current_image_buffer, current_image_stride, element_size, extent, &
        stat, errmsg, errmsg_alloc)
      implicit none
      integer(c_int), intent(in) :: image_num
      integer(c_intptr_t), intent(in) :: remote_ptr
      integer(c_ptrdiff_t), intent(in) :: remote_stride(:)
      type(c_ptr), intent(in) :: current_image_buffer
      integer(c_ptrdiff_t), intent(in) :: current_image_stride(:)
      integer(c_size_t), intent(in) :: element_size
      integer(c_size_t), intent(in) :: extent(:)
      integer(c_int), intent(out), optional :: stat
      character(len=*), intent(inout), optional :: errmsg
      character(len=:), intent(inout), allocatable, optional :: errmsg_alloc
    end subroutine

    module subroutine prif_put_strided( &
        image_num, coarray_handle, offset, remote_stride, current_image_buffer, current_image_stride, element_size, &
        extent, stat, errmsg, errmsg_alloc)
      implicit none
      integer(c_int), intent(in) :: image_num
      type(prif_coarray_handle), intent(in) :: coarray_handle
      integer(c_size_t), intent(in) :: offset
      integer(c_ptrdiff_t), intent(in) :: remote_stride(:)
      type(c_ptr), intent(in) :: current_image_buffer
      integer(c_ptrdiff_t), intent(in) :: current_image_stride(:)
      integer(c_size_t), intent(in) :: element_size
      integer(c_size_t), intent(in) :: extent(:)
      integer(c_int), intent(out), optional :: stat
      character(len=*), intent(inout), optional :: errmsg
      character(len=:), intent(inout), allocatable, optional :: errmsg_alloc
    end subroutine

    module subroutine prif_put_strided_indirect( &
        image_num, remote_ptr, remote_stride, current_image_buffer, current_image_stride, element_size, extent, &
        stat, errmsg, errmsg_alloc)
      implicit none
      integer(c_int), intent(in) :: image_num
      integer(c_intptr_t), intent(in) :: remote_ptr
      integer(c_ptrdiff_t), intent(in) :: remote_stride(:)
      type(c_ptr), intent(in) :: current_image_buffer
      integer(c_ptrdiff_t), intent(in) :: current_image_stride(:)
      integer(c_size_t), intent(in) :: element_size
      integer(c_size_t), intent(in) :: extent(:)
      integer(c_int), intent(out), optional :: stat
      character(len=*), intent(inout), optional :: errmsg
      character(len=:), intent(inout), allocatable, optional :: errmsg_alloc
    end subroutine

    module subroutine prif_put_strided_with_notify( &
        image_num, coarray_handle, offset, remote_stride, current_image_buffer, current_image_stride, element_size, &
        extent, notify_coarray_handle, notify_offset, stat, errmsg, errmsg_alloc)
      implicit none
      integer(c_int), intent(in) :: image_num
      type(prif_coarray_handle), intent(in) :: coarray_handle
      integer(c_size_t), intent(in) :: offset
      integer(c_ptrdiff_t), intent(in) :: remote_stride(:)
      type(c_ptr), intent(in) :: current_image_buffer
      integer(c_ptrdiff_t), intent(in) :: current_image_stride(:)
      integer(c_size_t), intent(in) :: element_size
      integer(c_size_t), intent(in) :: extent(:)
      type(prif_coarray_handle), intent(in) :: notify_coarray_handle
      integer(c_size_t), intent(in) :: notify_offset
      integer(c_int), intent(out), optional :: stat
      character(len=*), intent(inout), optional :: errmsg
      character(len=:), intent(inout), allocatable, optional :: errmsg_alloc
    end subroutine

    module subroutine prif_put_strided_with_notify_indirect( &
        image_num, coarray_handle, offset, remote_stride, current_image_buffer, current_image_stride, element_size, &
        extent, notify_ptr, stat, errmsg, errmsg_alloc)
      implicit none
      integer(c_int), intent(in) :: image_num
      type(prif_coarray_handle), intent(in) :: coarray_handle
      integer(c_size_t), intent(in) :: offset
      integer(c_ptrdiff_t), intent(in) :: remote_stride(:)
      type(c_ptr), intent(in) :: current_image_buffer
      integer(c_ptrdiff_t), intent(in) :: current_image_stride(:)
      integer(c_size_t), intent(in) :: element_size
      integer(c_size_t), intent(in) :: extent(:)
      integer(c_intptr_t), intent(in) :: notify_ptr
      integer(c_int), intent(out), optional :: stat
      character(len=*), intent(inout), optional :: errmsg
      character(len=:), intent(inout), allocatable, optional :: errmsg_alloc
    end subroutine

    module subroutine prif_put_strided_indirect_with_notify( &
        image_num, remote_ptr, remote_stride, current_image_buffer, current_image_stride, element_size, extent, &
        notify_coarray_handle, notify_offset, stat, errmsg, errmsg_alloc)
      implicit none
      integer(c_int), intent(in) :: image_num
      integer(c_intptr_t), intent(in) :: remote_ptr
      integer(c_ptrdiff_t), intent(in) :: remote_stride(:)
      type(c_ptr), intent(in) :: current_image_buffer
      integer(c_ptrdiff_t), intent(in) :: current_image_stride(:)
      integer(c_size_t), intent(in) :: element_size
      integer(c_size_t), intent(in) :: extent(:)
      type(prif_coarray_handle), intent(in) :: notify_coarray_handle
      integer(c_size_t), intent(in) :: notify_offset
      integer(c_int), intent(out), optional :: stat
      character(len=*), intent(inout), optional :: errmsg
      character(len=:), intent(inout), allocatable, optional :: errmsg_alloc
    end subroutine

    module subroutine prif_put_strided_indirect_with_notify_indirect( &
        image_num, remote_ptr, remote_stride, current_image_buffer, current_image_stride, element_size, extent, &
        notify_ptr, stat, errmsg, errmsg_alloc)
      implicit none
      integer(c_int), intent(in) :: image_num
      integer(c_intptr_t), intent(in) :: remote_ptr
      integer(c_ptrdiff_t), intent(in) :: remote_stride(:)
      type(c_ptr), intent(in) :: current_image_buffer
      integer(c_ptrdiff_t), intent(in) :: current_image_stride(:)
      integer(c_size_t), intent(in) :: element_size
      integer(c_size_t), intent(in) :: extent(:)
      integer(c_intptr_t), intent(in) :: notify_ptr
      integer(c_int), intent(out), optional :: stat
      character(len=*), intent(inout), optional :: errmsg
      character(len=:), intent(inout), allocatable, optional :: errmsg_alloc
    end subroutine

    module subroutine prif_alias_create(source_handle, alias_lcobounds, alias_ucobounds, &
#   if CAF_PRIF_VERSION >= 6
                                        data_pointer_offset, &
#   endif
                                        alias_handle)
      implicit none
      type(prif_coarray_handle), intent(in) :: source_handle
      integer(c_int64_t), intent(in) :: alias_lcobounds(:)
      integer(c_int64_t), intent(in) :: alias_ucobounds(:)
#   if CAF_PRIF_VERSION >= 6
      integer(c_size_t), intent(in) :: data_pointer_offset
#   endif
      type(prif_coarray_handle), intent(out) :: alias_handle
    end subroutine

    module subroutine prif_alias_destroy(alias_handle)
      implicit none
      type(prif_coarray_handle), intent(in) :: alias_handle
    end subroutine

    module subroutine prif_lcobound_with_dim(coarray_handle, dim, lcobound)
      implicit none
      type(prif_coarray_handle), intent(in) :: coarray_handle
      integer(c_int), intent(in) :: dim
      integer(c_int64_t), intent(out) :: lcobound
    end subroutine

    module subroutine prif_lcobound_no_dim(coarray_handle, lcobounds)
      implicit none
      type(prif_coarray_handle), intent(in) :: coarray_handle
      integer(c_int64_t), intent(out) :: lcobounds(:)
    end subroutine

    module subroutine prif_ucobound_with_dim(coarray_handle, dim, ucobound)
      implicit none
      type(prif_coarray_handle), intent(in) :: coarray_handle
      integer(c_int), intent(in) :: dim
      integer(c_int64_t), intent(out) :: ucobound
    end subroutine

    module subroutine prif_ucobound_no_dim(coarray_handle, ucobounds)
      implicit none
      type(prif_coarray_handle), intent(in) :: coarray_handle
      integer(c_int64_t), intent(out) :: ucobounds(:)
    end subroutine

    module subroutine prif_coshape(coarray_handle, sizes)
      implicit none
      type(prif_coarray_handle), intent(in) :: coarray_handle
      integer(c_size_t), intent(out) :: sizes(:)
    end subroutine

    module subroutine prif_image_index(coarray_handle, sub, image_index)
      implicit none
      type(prif_coarray_handle), intent(in) :: coarray_handle
      integer(c_int64_t), intent(in) :: sub(:)
      integer(c_int), intent(out) :: image_index
    end subroutine

    module subroutine prif_image_index_with_team(coarray_handle, sub, team, image_index)
      implicit none
      type(prif_coarray_handle), intent(in) :: coarray_handle
      integer(c_int64_t), intent(in) :: sub(:)
      type(prif_team_type), intent(in) :: team
      integer(c_int), intent(out) :: image_index
    end subroutine

    module subroutine prif_image_index_with_team_number(coarray_handle, sub, team_number, image_index)
      implicit none
      type(prif_coarray_handle), intent(in) :: coarray_handle
      integer(c_int64_t), intent(in) :: sub(:)
      integer(c_int64_t), intent(in) :: team_number
      integer(c_int), intent(out) :: image_index
    end subroutine

    module subroutine prif_initial_team_index(coarray_handle, sub, initial_team_index, stat)
      implicit none
      type(prif_coarray_handle), intent(in) :: coarray_handle
      integer(c_int64_t), intent(in) :: sub(:)
      integer(c_int), intent(out) :: initial_team_index
      integer(c_int), intent(out), optional :: stat
    end subroutine
    
    module subroutine prif_initial_team_index_with_team(coarray_handle, sub, team, initial_team_index, stat)
      implicit none
      type(prif_coarray_handle), intent(in) :: coarray_handle
      integer(c_int64_t), intent(in) :: sub(:)
      type(prif_team_type), intent(in) :: team
      integer(c_int), intent(out) :: initial_team_index
      integer(c_int), intent(out), optional :: stat
    end subroutine
    
    module subroutine prif_initial_team_index_with_team_number(coarray_handle, sub, team_number, initial_team_index, stat)
      implicit none
      type(prif_coarray_handle), intent(in) :: coarray_handle
      integer(c_int64_t), intent(in) :: sub(:)
      integer(c_int64_t), intent(in) :: team_number
      integer(c_int), intent(out) :: initial_team_index
      integer(c_int), intent(out), optional :: stat
    end subroutine

    module subroutine prif_num_images(num_images)
      implicit none
      integer(c_int), intent(out) :: num_images
    end subroutine

    module subroutine prif_num_images_with_team(team, num_images)
      implicit none
      type(prif_team_type), intent(in) :: team
      integer(c_int), intent(out) :: num_images
    end subroutine

    module subroutine prif_num_images_with_team_number(team_number, num_images)
      implicit none
      integer(c_int64_t), intent(in) :: team_number
      integer(c_int), intent(out) :: num_images
    end subroutine

    module subroutine prif_this_image_no_coarray(team, this_image)
      implicit none
      type(prif_team_type), intent(in), optional :: team
      integer(c_int), intent(out) :: this_image
    end subroutine

    module subroutine prif_this_image_with_coarray(coarray_handle, team, cosubscripts)
      implicit none
      type(prif_coarray_handle), intent(in) :: coarray_handle
      type(prif_team_type), intent(in), optional :: team
      integer(c_int64_t), intent(out) :: cosubscripts(:)
    end subroutine

    module subroutine prif_this_image_with_dim(coarray_handle, dim, team, cosubscript)
      implicit none
      type(prif_coarray_handle), intent(in) :: coarray_handle
      integer(c_int), intent(in) :: dim
      type(prif_team_type), intent(in), optional :: team
      integer(c_int64_t), intent(out) :: cosubscript
    end subroutine

    module subroutine prif_failed_images(team, failed_images)
      implicit none
      type(prif_team_type), intent(in), optional :: team
      integer(c_int), allocatable, intent(out) :: failed_images(:)
    end subroutine

    module subroutine prif_stopped_images(team, stopped_images)
      implicit none
      type(prif_team_type), intent(in), optional :: team
      integer(c_int), allocatable, intent(out) :: stopped_images(:)
    end subroutine

    module impure elemental subroutine prif_image_status(image, team, image_status)
      implicit none
      integer(c_int), intent(in) :: image
      type(prif_team_type), intent(in), optional :: team
      integer(c_int), intent(out) :: image_status
    end subroutine

    module subroutine prif_local_data_pointer(coarray_handle, local_data)
      type(prif_coarray_handle), intent(in) :: coarray_handle
      type(c_ptr), intent(out) :: local_data
    end subroutine

    module subroutine prif_set_context_data(coarray_handle, context_data)
      implicit none
      type(prif_coarray_handle), intent(in) :: coarray_handle
      type(c_ptr), intent(in) :: context_data
    end subroutine

    module subroutine prif_get_context_data(coarray_handle, context_data)
      implicit none
      type(prif_coarray_handle), intent(in) :: coarray_handle
      type(c_ptr), intent(out) :: context_data
    end subroutine

    module subroutine prif_size_bytes(coarray_handle, data_size)
      implicit none
      type(prif_coarray_handle), intent(in) :: coarray_handle
      integer(c_size_t), intent(out) :: data_size
    end subroutine

    module subroutine prif_co_sum(a, result_image, stat, errmsg, errmsg_alloc)
      implicit none
      type(*), intent(inout), target :: a(..)
      integer(c_int), intent(in), optional :: result_image
      integer(c_int), intent(out), optional :: stat
      character(len=*), intent(inout), optional :: errmsg
      character(len=:), intent(inout), allocatable, optional :: errmsg_alloc
    end subroutine

    module subroutine prif_co_max(a, result_image, stat, errmsg, errmsg_alloc)
      implicit none
      type(*), intent(inout), target :: a(..)
      integer(c_int), intent(in), optional :: result_image
      integer(c_int), intent(out), optional :: stat
      character(len=*), intent(inout), optional :: errmsg
      character(len=:), intent(inout), allocatable, optional :: errmsg_alloc
    end subroutine

    module subroutine prif_co_max_character(a, result_image, stat, errmsg, errmsg_alloc)
      implicit none
      character(len=*, kind=c_char), intent(inout), target :: a(..)
      integer(c_int), intent(in), optional :: result_image
      integer(c_int), intent(out), optional :: stat
      character(len=*), intent(inout), optional :: errmsg
      character(len=:), intent(inout), allocatable, optional :: errmsg_alloc
    end subroutine

    module subroutine prif_co_min(a, result_image, stat, errmsg, errmsg_alloc)
      implicit none
      type(*), intent(inout), target :: a(..)
      integer(c_int), intent(in), optional :: result_image
      integer(c_int), intent(out), optional :: stat
      character(len=*), intent(inout), optional :: errmsg
      character(len=:), intent(inout), allocatable, optional :: errmsg_alloc
    end subroutine

    module subroutine prif_co_min_character(a, result_image, stat, errmsg, errmsg_alloc)
      implicit none
      character(len=*, kind=c_char), intent(inout), target :: a(..)
      integer(c_int), intent(in), optional :: result_image
      integer(c_int), intent(out), optional :: stat
      character(len=*), intent(inout), optional :: errmsg
      character(len=:), intent(inout), allocatable, optional :: errmsg_alloc
    end subroutine

    module subroutine prif_co_reduce(a, operation_wrapper, cdata, result_image, stat, errmsg, errmsg_alloc)
      implicit none
      type(*), intent(inout), target :: a(..)
      procedure(prif_operation_wrapper_interface), pointer, intent(in) :: operation_wrapper
      type(c_ptr), intent(in), value :: cdata
      integer(c_int), intent(in), optional :: result_image
      integer(c_int), intent(out), optional :: stat
      character(len=*), intent(inout), optional :: errmsg
      character(len=:), intent(inout), allocatable, optional :: errmsg_alloc
    end subroutine

    module subroutine prif_co_broadcast(a, source_image, stat, errmsg, errmsg_alloc)
      implicit none
      type(*), intent(inout), target :: a(..)
      integer(c_int), intent(in) :: source_image
      integer(c_int), intent(out), optional :: stat
      character(len=*), intent(inout), optional :: errmsg
      character(len=:), intent(inout), allocatable, optional :: errmsg_alloc
    end subroutine

    module subroutine prif_form_team(team_number, team, new_index, stat, errmsg, errmsg_alloc)
      implicit none
      integer(c_int64_t), intent(in) :: team_number
      type(prif_team_type), intent(out) :: team
      integer(c_int), intent(in), optional :: new_index
      integer(c_int), intent(out), optional :: stat
      character(len=*), intent(inout), optional :: errmsg
      character(len=:), intent(inout), allocatable, optional :: errmsg_alloc
    end subroutine

    module subroutine prif_change_team(team, stat, errmsg, errmsg_alloc)
      implicit none
      type(prif_team_type), intent(in) :: team
      integer(c_int), intent(out), optional :: stat
      character(len=*), intent(inout), optional :: errmsg
      character(len=:), intent(inout), allocatable, optional :: errmsg_alloc
    end subroutine

    module subroutine prif_end_team(stat, errmsg, errmsg_alloc)
      implicit none
      integer(c_int), intent(out), optional :: stat
      character(len=*), intent(inout), optional :: errmsg
      character(len=:), intent(inout), allocatable, optional :: errmsg_alloc
    end subroutine

    module subroutine prif_get_team(level, team)
      implicit none
      integer(c_int), intent(in), optional :: level
      type(prif_team_type), intent(out) :: team
    end subroutine

    module subroutine prif_team_number(team, team_number)
      implicit none
      type(prif_team_type), intent(in), optional :: team
      integer(c_int64_t), intent(out) :: team_number
    end subroutine

    module subroutine prif_sync_all(stat, errmsg, errmsg_alloc)
      implicit none
      integer(c_int), intent(out), optional :: stat
      character(len=*), intent(inout), optional :: errmsg
      character(len=:), intent(inout), allocatable, optional :: errmsg_alloc
    end subroutine

    module subroutine prif_sync_images(image_set, stat, errmsg, errmsg_alloc)
      implicit none
      integer(c_int), intent(in), optional :: image_set(:)
      integer(c_int), intent(out), optional :: stat
      character(len=*), intent(inout), optional :: errmsg
      character(len=:), intent(inout), allocatable, optional :: errmsg_alloc
    end subroutine

    module subroutine prif_sync_team(team, stat, errmsg, errmsg_alloc)
      implicit none
      type(prif_team_type), intent(in) :: team
      integer(c_int), intent(out), optional :: stat
      character(len=*), intent(inout), optional :: errmsg
      character(len=:), intent(inout), allocatable, optional :: errmsg_alloc
    end subroutine

    module subroutine prif_sync_memory(stat, errmsg, errmsg_alloc)
      implicit none
      integer(c_int), intent(out), optional :: stat
      character(len=*), intent(inout), optional :: errmsg
      character(len=:), intent(inout), allocatable, optional :: errmsg_alloc
    end subroutine

    module subroutine prif_lock(image_num, coarray_handle, offset, acquired_lock, stat, errmsg, errmsg_alloc)
      implicit none
      integer(c_int), intent(in) :: image_num
      type(prif_coarray_handle), intent(in) :: coarray_handle
      integer(c_size_t), intent(in) :: offset
      logical(c_bool), intent(out), optional :: acquired_lock
      integer(c_int), intent(out), optional :: stat
      character(len=*), intent(inout), optional :: errmsg
      character(len=:), intent(inout), allocatable, optional :: errmsg_alloc
    end subroutine

    module subroutine prif_lock_indirect(image_num, lock_var_ptr, acquired_lock, stat, errmsg, errmsg_alloc)
      implicit none
      integer(c_int), intent(in) :: image_num
      integer(c_intptr_t), intent(in) :: lock_var_ptr
      logical(c_bool), intent(out), optional :: acquired_lock
      integer(c_int), intent(out), optional :: stat
      character(len=*), intent(inout), optional :: errmsg
      character(len=:), intent(inout), allocatable, optional :: errmsg_alloc
    end subroutine

    module subroutine prif_unlock(image_num, coarray_handle, offset, stat, errmsg, errmsg_alloc)
      implicit none
      integer(c_int), intent(in) :: image_num
      type(prif_coarray_handle), intent(in) :: coarray_handle
      integer(c_size_t), intent(in) :: offset
      integer(c_int), intent(out), optional :: stat
      character(len=*), intent(inout), optional :: errmsg
      character(len=:), intent(inout), allocatable, optional :: errmsg_alloc
    end subroutine

    module subroutine prif_unlock_indirect(image_num, lock_var_ptr, stat, errmsg, errmsg_alloc)
      implicit none
      integer(c_int), intent(in) :: image_num
      integer(c_intptr_t), intent(in) :: lock_var_ptr
      integer(c_int), intent(out), optional :: stat
      character(len=*), intent(inout), optional :: errmsg
      character(len=:), intent(inout), allocatable, optional :: errmsg_alloc
    end subroutine

    module subroutine prif_critical(critical_coarray, stat, errmsg, errmsg_alloc)
      implicit none
      type(prif_coarray_handle), intent(in) :: critical_coarray
      integer(c_int), intent(out), optional :: stat
      character(len=*), intent(inout), optional :: errmsg
      character(len=:), intent(inout), allocatable, optional :: errmsg_alloc
    end subroutine

    module subroutine prif_end_critical(critical_coarray)
      implicit none
      type(prif_coarray_handle), intent(in) :: critical_coarray
    end subroutine

    module subroutine prif_event_post(image_num, coarray_handle, offset, stat, errmsg, errmsg_alloc)
      implicit none
      integer(c_int), intent(in) :: image_num
      type(prif_coarray_handle), intent(in) :: coarray_handle
      integer(c_size_t), intent(in) :: offset
      integer(c_int), intent(out), optional :: stat
      character(len=*), intent(inout), optional :: errmsg
      character(len=:), intent(inout), allocatable, optional :: errmsg_alloc
    end subroutine

    module subroutine prif_event_post_indirect(image_num, event_var_ptr, stat, errmsg, errmsg_alloc)
      implicit none
      integer(c_int), intent(in) :: image_num
      integer(c_intptr_t), intent(in) :: event_var_ptr
      integer(c_int), intent(out), optional :: stat
      character(len=*), intent(inout), optional :: errmsg
      character(len=:), intent(inout), allocatable, optional :: errmsg_alloc
    end subroutine

    module subroutine prif_event_wait(event_var_ptr, until_count, stat, errmsg, errmsg_alloc)
      implicit none
      type(c_ptr), intent(in) :: event_var_ptr
      integer(c_int64_t), intent(in), optional :: until_count
      integer(c_int), intent(out), optional :: stat
      character(len=*), intent(inout), optional :: errmsg
      character(len=:), intent(inout), allocatable, optional :: errmsg_alloc
    end subroutine

    module subroutine prif_event_query(event_var_ptr, count, stat)
      implicit none
      type(c_ptr), intent(in) :: event_var_ptr
      integer(c_int64_t), intent(out) :: count
      integer(c_int), intent(out), optional :: stat
    end subroutine

    module subroutine prif_notify_wait(notify_var_ptr, until_count, stat, errmsg, errmsg_alloc)
      implicit none
      type(c_ptr), intent(in) :: notify_var_ptr
      integer(c_int64_t), intent(in), optional :: until_count
      integer(c_int), intent(out), optional :: stat
      character(len=*), intent(inout), optional :: errmsg
      character(len=:), intent(inout), allocatable, optional :: errmsg_alloc
    end subroutine

    module subroutine prif_atomic_add(image_num, coarray_handle, offset, value, stat)
      implicit none
      integer(c_int), intent(in) :: image_num
      type(prif_coarray_handle), intent(in) :: coarray_handle
      integer(c_size_t), intent(in) :: offset
      integer(PRIF_ATOMIC_INT_KIND), intent(in) :: value
      integer(c_int), intent(out), optional :: stat
    end subroutine

    module subroutine prif_atomic_add_indirect(image_num, atom_remote_ptr, value, stat)
      implicit none
      integer(c_int), intent(in) :: image_num
      integer(c_intptr_t), intent(in) :: atom_remote_ptr
      integer(PRIF_ATOMIC_INT_KIND), intent(in) :: value
      integer(c_int), intent(out), optional :: stat
    end subroutine

    module subroutine prif_atomic_and(image_num, coarray_handle, offset, value, stat)
      implicit none
      integer(c_int), intent(in) :: image_num
      type(prif_coarray_handle), intent(in) :: coarray_handle
      integer(c_size_t), intent(in) :: offset
      integer(PRIF_ATOMIC_INT_KIND), intent(in) :: value
      integer(c_int), intent(out), optional :: stat
    end subroutine

    module subroutine prif_atomic_and_indirect(image_num, atom_remote_ptr, value, stat)
      implicit none
      integer(c_int), intent(in) :: image_num
      integer(c_intptr_t), intent(in) :: atom_remote_ptr
      integer(PRIF_ATOMIC_INT_KIND), intent(in) :: value
      integer(c_int), intent(out), optional :: stat
    end subroutine

    module subroutine prif_atomic_or(image_num, coarray_handle, offset, value, stat)
      implicit none
      integer(c_int), intent(in) :: image_num
      type(prif_coarray_handle), intent(in) :: coarray_handle
      integer(c_size_t), intent(in) :: offset
      integer(PRIF_ATOMIC_INT_KIND), intent(in) :: value
      integer(c_int), intent(out), optional :: stat
    end subroutine

    module subroutine prif_atomic_or_indirect(image_num, atom_remote_ptr, value, stat)
      implicit none
      integer(c_int), intent(in) :: image_num
      integer(c_intptr_t), intent(in) :: atom_remote_ptr
      integer(PRIF_ATOMIC_INT_KIND), intent(in) :: value
      integer(c_int), intent(out), optional :: stat
    end subroutine

    module subroutine prif_atomic_xor(image_num, coarray_handle, offset, value, stat)
      implicit none
      integer(c_int), intent(in) :: image_num
      type(prif_coarray_handle), intent(in) :: coarray_handle
      integer(c_size_t), intent(in) :: offset
      integer(PRIF_ATOMIC_INT_KIND), intent(in) :: value
      integer(c_int), intent(out), optional :: stat
    end subroutine

    module subroutine prif_atomic_xor_indirect(image_num, atom_remote_ptr, value, stat)
      implicit none
      integer(c_int), intent(in) :: image_num
      integer(c_intptr_t), intent(in) :: atom_remote_ptr
      integer(PRIF_ATOMIC_INT_KIND), intent(in) :: value
      integer(c_int), intent(out), optional :: stat
    end subroutine

    module subroutine prif_atomic_cas_int(image_num, coarray_handle, offset, old, compare, new, stat)
      implicit none
      integer(c_int), intent(in) :: image_num
      type(prif_coarray_handle), intent(in) :: coarray_handle
      integer(c_size_t), intent(in) :: offset
      integer(PRIF_ATOMIC_INT_KIND), intent(out) :: old
      integer(PRIF_ATOMIC_INT_KIND), intent(in) :: compare
      integer(PRIF_ATOMIC_INT_KIND), intent(in) :: new
      integer(c_int), intent(out), optional :: stat
    end subroutine

    module subroutine prif_atomic_cas_int_indirect(image_num, atom_remote_ptr, old, compare, new, stat)
      implicit none
      integer(c_int), intent(in) :: image_num
      integer(c_intptr_t), intent(in) :: atom_remote_ptr
      integer(PRIF_ATOMIC_INT_KIND), intent(out) :: old
      integer(PRIF_ATOMIC_INT_KIND), intent(in) :: compare
      integer(PRIF_ATOMIC_INT_KIND), intent(in) :: new
      integer(c_int), intent(out), optional :: stat
    end subroutine

    module subroutine prif_atomic_cas_logical(image_num, coarray_handle, offset, old, compare, new, stat)
      implicit none
      integer(c_int), intent(in) :: image_num
      type(prif_coarray_handle), intent(in) :: coarray_handle
      integer(c_size_t), intent(in) :: offset
      logical(PRIF_ATOMIC_LOGICAL_KIND), intent(out) :: old
      logical(PRIF_ATOMIC_LOGICAL_KIND), intent(in) :: compare
      logical(PRIF_ATOMIC_LOGICAL_KIND), intent(in) :: new
      integer(c_int), intent(out), optional :: stat
    end subroutine

    module subroutine prif_atomic_cas_logical_indirect(image_num, atom_remote_ptr, old, compare, new, stat)
      implicit none
      integer(c_int), intent(in) :: image_num
      integer(c_intptr_t), intent(in) :: atom_remote_ptr
      logical(PRIF_ATOMIC_LOGICAL_KIND), intent(out) :: old
      logical(PRIF_ATOMIC_LOGICAL_KIND), intent(in) :: compare
      logical(PRIF_ATOMIC_LOGICAL_KIND), intent(in) :: new
      integer(c_int), intent(out), optional :: stat
    end subroutine

    module subroutine prif_atomic_fetch_add(image_num, coarray_handle, offset, value, old, stat)
      implicit none
      integer(c_int), intent(in) :: image_num
      type(prif_coarray_handle), intent(in) :: coarray_handle
      integer(c_size_t), intent(in) :: offset
      integer(PRIF_ATOMIC_INT_KIND), intent(in) :: value
      integer(PRIF_ATOMIC_INT_KIND), intent(out) :: old
      integer(c_int), intent(out), optional :: stat
    end subroutine

    module subroutine prif_atomic_fetch_add_indirect(image_num, atom_remote_ptr, value, old, stat)
      implicit none
      integer(c_int), intent(in) :: image_num
      integer(c_intptr_t), intent(in) :: atom_remote_ptr
      integer(PRIF_ATOMIC_INT_KIND), intent(in) :: value
      integer(PRIF_ATOMIC_INT_KIND), intent(out) :: old
      integer(c_int), intent(out), optional :: stat
    end subroutine

    module subroutine prif_atomic_fetch_and(image_num, coarray_handle, offset, value, old, stat)
      implicit none
      integer(c_int), intent(in) :: image_num
      type(prif_coarray_handle), intent(in) :: coarray_handle
      integer(c_size_t), intent(in) :: offset
      integer(PRIF_ATOMIC_INT_KIND), intent(in) :: value
      integer(PRIF_ATOMIC_INT_KIND), intent(out) :: old
      integer(c_int), intent(out), optional :: stat
    end subroutine

    module subroutine prif_atomic_fetch_and_indirect(image_num, atom_remote_ptr, value, old, stat)
      implicit none
      integer(c_int), intent(in) :: image_num
      integer(c_intptr_t), intent(in) :: atom_remote_ptr
      integer(PRIF_ATOMIC_INT_KIND), intent(in) :: value
      integer(PRIF_ATOMIC_INT_KIND), intent(out) :: old
      integer(c_int), intent(out), optional :: stat
    end subroutine

    module subroutine prif_atomic_fetch_or(image_num, coarray_handle, offset, value, old, stat)
      implicit none
      integer(c_int), intent(in) :: image_num
      type(prif_coarray_handle), intent(in) :: coarray_handle
      integer(c_size_t), intent(in) :: offset
      integer(PRIF_ATOMIC_INT_KIND), intent(in) :: value
      integer(PRIF_ATOMIC_INT_KIND), intent(out) :: old
      integer(c_int), intent(out), optional :: stat
    end subroutine

    module subroutine prif_atomic_fetch_or_indirect(image_num, atom_remote_ptr, value, old, stat)
      implicit none
      integer(c_int), intent(in) :: image_num
      integer(c_intptr_t), intent(in) :: atom_remote_ptr
      integer(PRIF_ATOMIC_INT_KIND), intent(in) :: value
      integer(PRIF_ATOMIC_INT_KIND), intent(out) :: old
      integer(c_int), intent(out), optional :: stat
    end subroutine

    module subroutine prif_atomic_fetch_xor(image_num, coarray_handle, offset, value, old, stat)
      implicit none
      integer(c_int), intent(in) :: image_num
      type(prif_coarray_handle), intent(in) :: coarray_handle
      integer(c_size_t), intent(in) :: offset
      integer(PRIF_ATOMIC_INT_KIND), intent(in) :: value
      integer(PRIF_ATOMIC_INT_KIND), intent(out) :: old
      integer(c_int), intent(out), optional :: stat
    end subroutine

    module subroutine prif_atomic_fetch_xor_indirect(image_num, atom_remote_ptr, value, old, stat)
      implicit none
      integer(c_int), intent(in) :: image_num
      integer(c_intptr_t), intent(in) :: atom_remote_ptr
      integer(PRIF_ATOMIC_INT_KIND), intent(in) :: value
      integer(PRIF_ATOMIC_INT_KIND), intent(out) :: old
      integer(c_int), intent(out), optional :: stat
    end subroutine

    module subroutine prif_atomic_define_int(image_num, coarray_handle, offset, value, stat)
      implicit none
      integer(c_int), intent(in) :: image_num
      type(prif_coarray_handle), intent(in) :: coarray_handle
      integer(c_size_t), intent(in) :: offset
      integer(PRIF_ATOMIC_INT_KIND), intent(in) :: value
      integer(c_int), intent(out), optional :: stat
    end subroutine

    module subroutine prif_atomic_define_int_indirect(image_num, atom_remote_ptr, value, stat)
      implicit none
      integer(c_int), intent(in) :: image_num
      integer(c_intptr_t), intent(in) :: atom_remote_ptr
      integer(PRIF_ATOMIC_INT_KIND), intent(in) :: value
      integer(c_int), intent(out), optional :: stat
    end subroutine

    module subroutine prif_atomic_define_logical(image_num, coarray_handle, offset, value, stat)
      implicit none
      integer(c_int), intent(in) :: image_num
      type(prif_coarray_handle), intent(in) :: coarray_handle
      integer(c_size_t), intent(in) :: offset
      logical(PRIF_ATOMIC_LOGICAL_KIND), intent(in) :: value
      integer(c_int), intent(out), optional :: stat
    end subroutine

    module subroutine prif_atomic_define_logical_indirect(image_num, atom_remote_ptr, value, stat)
      implicit none
      integer(c_int), intent(in) :: image_num
      integer(c_intptr_t), intent(in) :: atom_remote_ptr
      logical(PRIF_ATOMIC_LOGICAL_KIND), intent(in) :: value
      integer(c_int), intent(out), optional :: stat
    end subroutine

    module subroutine prif_atomic_ref_int(image_num, coarray_handle, offset, value, stat)
      implicit none
      integer(c_int), intent(in) :: image_num
      type(prif_coarray_handle), intent(in) :: coarray_handle
      integer(c_size_t), intent(in) :: offset
      integer(PRIF_ATOMIC_INT_KIND), intent(out) :: value
      integer(c_int), intent(out), optional :: stat
    end subroutine

    module subroutine prif_atomic_ref_int_indirect(image_num, atom_remote_ptr, value, stat)
      implicit none
      integer(c_int), intent(in) :: image_num
      integer(c_intptr_t), intent(in) :: atom_remote_ptr
      integer(PRIF_ATOMIC_INT_KIND), intent(out) :: value
      integer(c_int), intent(out), optional :: stat
    end subroutine

    module subroutine prif_atomic_ref_logical(image_num, coarray_handle, offset, value, stat)
      implicit none
      integer(c_int), intent(in) :: image_num
      type(prif_coarray_handle), intent(in) :: coarray_handle
      integer(c_size_t), intent(in) :: offset
      logical(PRIF_ATOMIC_LOGICAL_KIND), intent(out) :: value
      integer(c_int), intent(out), optional :: stat
    end subroutine

    module subroutine prif_atomic_ref_logical_indirect(image_num, atom_remote_ptr, value, stat)
      implicit none
      integer(c_int), intent(in) :: image_num
      integer(c_intptr_t), intent(in) :: atom_remote_ptr
      logical(PRIF_ATOMIC_LOGICAL_KIND), intent(out) :: value
      integer(c_int), intent(out), optional :: stat
    end subroutine

  end interface

! Type definitions only relevant to Caffeine internals

  type, private, bind(C) :: prif_coarray_descriptor
    private
    type(c_ptr) :: coarray_data
    integer(c_int) :: corank
    integer(c_size_t) :: coarray_size
    type(c_funptr) :: final_func
    type(c_ptr) :: previous_handle = c_null_ptr, next_handle = c_null_ptr
    integer(c_int64_t) :: lcobounds(15), ucobounds(14)
    integer(c_int) :: coshape_epp(15)
    type(c_ptr) :: p_context_data
    type(c_ptr) :: reserved
  end type

  type, private :: prif_team_descriptor
    type(c_ptr) :: gex_team
    type(c_ptr) :: heap_mspace
    integer(c_intptr_t) :: heap_start
    integer(c_size_t) :: heap_size
    integer(c_int64_t) :: team_number
    integer(c_int) :: this_image, num_images
    type(prif_team_descriptor), pointer :: parent_team => null()
    type(prif_coarray_descriptor), pointer :: coarrays => null()
    type(child_team_info), pointer :: child_heap_info => null()
  end type

  type :: child_team_info
    type(c_ptr) :: allocated_memory
    integer(c_ptrdiff_t) :: offset
    integer(c_size_t) :: size
  end type
end module prif

program hello_world
  use iso_c_binding, only: c_bool
  use iso_fortran_env, only: output_unit,error_unit
  use prif, only : &
     prif_init &
    ,prif_this_image_no_coarray &
    ,prif_num_images &
    ,prif_stop &
    ,prif_error_stop &
    ,prif_sync_all &
    ,PRIF_STAT_ALREADY_INIT
  implicit none

  integer :: init_exit_code, me, num_imgs, exitcase = 1
  logical(kind=c_bool), parameter :: false = .false._c_bool, true = .true._c_bool
  character(len=256) :: arg_string

  call prif_init(init_exit_code)
  if (init_exit_code /= 0 .and. init_exit_code /= PRIF_STAT_ALREADY_INIT) then
    call prif_error_stop(quiet=false, stop_code_char="program startup failed")
  end if

  call prif_this_image_no_coarray(this_image=me)
  call prif_num_images(num_images=num_imgs)
  if (command_argument_count() > 0) then
    call get_command_argument(1, arg_string)
    read(arg_string, *) exitcase
  end if
  if (me == 1) write(output_unit,*) "testing exit case ", exitcase
  
  call prif_sync_all()

  write(output_unit,'(A,I1,A,I1)') "stdout from image ", me, " of ", num_imgs
  write(error_unit,'(A,I1,A,I1)')  "stderr from image ", me, " of ", num_imgs

  call prif_sync_all()

  select case (exitcase) 
  case (1)
    call prif_stop(quiet=true, stop_code_int=exitcase+100)
  case (2)
    call prif_stop(quiet=false, stop_code_int=exitcase+100)
  case (3)
    if (me == num_imgs) call prif_error_stop(quiet=true, stop_code_int=exitcase+100)
  case default
    if (me == num_imgs) call prif_error_stop(quiet=false, stop_code_int=exitcase+100)
  end select

  call prif_sync_all()

end program

module prif_init_test_m
    use prif, only : prif_init, PRIF_STAT_ALREADY_INIT
    use julienne_m, only: test_description_t, test_diagnosis_t, test_result_t, test_t, operator(.equalsExpected.), usher

    implicit none
    private
    public :: prif_init_test_t, check_caffeination

    type, extends(test_t) :: prif_init_test_t
    contains
      procedure, nopass, non_overridable :: subject
      procedure, nopass, non_overridable :: results
    end type

contains

  pure function subject() result(test_subject)
    character(len=:), allocatable :: test_subject
    test_subject = "prif_init"
  end function

  function results() result(test_results)
    type(test_result_t), allocatable ::  test_results(:)
    type(prif_init_test_t) prif_init_test

    allocate(test_results, source = prif_init_test%run([ &
        test_description_t("completing successfully", usher(check_caffeination)) &
       ,test_description_t("returning PRIF_STAT_ALREADY_INIT on a subsequent call ", usher(check_subsequent_prif_init_call)) &
    ]))
  end function


  function check_caffeination() result(diag)
    ! this test needs to run very early at startup, so we memoize the result
    type(test_diagnosis_t) :: diag
    type(test_diagnosis_t), save :: memo
    logical, save :: first_pass = .true.

    if (first_pass) then
      first_pass = .false.
      block
#if HAVE_MULTI_IMAGE
        integer, parameter :: successful_initiation = PRIF_STAT_ALREADY_INIT
#else
        integer, parameter :: successful_initiation = 0
#endif
        integer init_exit_code

        call prif_init(init_exit_code)
        memo = init_exit_code .equalsExpected. successful_initiation
      end block
    endif 

    diag = memo
  end function

  function check_subsequent_prif_init_call() result(diag)
    type(test_diagnosis_t) :: diag
    integer stat

    call prif_init(stat)
    call prif_init(stat)
    diag = stat .equalsExpected. PRIF_STAT_ALREADY_INIT
  end function

end module prif_init_test_m

#include "test-utils.F90"

module prif_types_test_m
    use iso_fortran_env, only: int8
    use iso_c_binding, only: c_ptr, c_loc, c_intptr_t
    use prif, only: prif_team_type, prif_event_type, prif_notify_type, prif_lock_type, prif_critical_type, prif_coarray_handle, prif_this_image_no_coarray
    use julienne_m, only: test_description_t, test_diagnosis_t, test_result_t, test_t, string_t, usher &
       ,operator(.all.), operator(.also.), operator(.equalsExpected.), operator(.greaterThan.), operator(.isAtMost.), operator(//)

    implicit none
    private
    public :: prif_types_test_t


    type, extends(test_t) :: prif_types_test_t
    contains
      procedure, nopass, non_overridable :: subject
      procedure, nopass, non_overridable :: results
    end type

    type, private :: dummy_t
      private
      integer foo
      type(dummy_t), pointer :: p
    end type

    type :: pointer_wrapper_t
      private
      type(dummy_t), pointer :: info => null()
    end type

    type :: cptr_wrapper_t
      private
      type(c_ptr) :: info
    end type

contains
    pure function subject()
      character(len=:), allocatable :: subject
      subject = "PRIF Types"
    end function

    function results() result(test_results)
      type(test_result_t), allocatable :: test_results(:)
      type(prif_types_test_t) prif_types_test

      allocate(test_results, source = prif_types_test%run([ &
            test_description_t("having a compliant prif_coarray_handle representation", usher(check_coarray_handle)) &
          , test_description_t("having a compliant prif_team_type representation", usher(check_team_type)) &
          , test_description_t("having a compliant prif_event_type representation", usher(check_event_type)) &
          , test_description_t("having a compliant prif_notify_type representation", usher(check_notify_type)) &
          , test_description_t("having a compliant prif_lock_type representation", usher(check_lock_type)) &
          , test_description_t("having a compliant prif_critical_type representation", usher(check_critical_type)) &
      ]))
    end function

    subroutine report_size(typename,sz, align_cptr)
      character(len=*), intent(in) :: typename
      integer, intent(in) :: sz
      type(c_ptr), intent(in) :: align_cptr(:)
      character(len=20) :: typestr
      integer :: me, i
      integer(c_intptr_t) :: cint, align
      call prif_this_image_no_coarray(this_image=me)
      if (me == 1) then
        typestr = typename
        align = 0
        do i=1,size(align_cptr)
          cint = transfer(align_cptr(i),cint)
          align = ior(align, cint)
        end do
        align = iand(align, -align)
        write(*,'(*(A,I3))') "   " // typestr // ": ", sz, " bytes, ", align, "-byte aligned"
      end if
    end subroutine

    ! declare typename variables in various ways to try and deduce minimum alignment requirement
    ! this heuristic might fail to discover the narrowest aligment, but does a reasonable job in practice
#   define ALIGN(typename) \
        integer :: aai ; \
        type :: align_check ; \
          integer(int8) :: a_pad ; \
          type(typename) :: t ; \
        end type ; \
        type(align_check), target :: align_arr(256) ; \
        integer(int8) :: a_pad2 ; \
        type(align_check), target :: align_s1 ; \
        integer(int8) :: a_pad3 ; \
        type(typename), target :: align_s2 ; \
        type(typename), target, save :: align_s3 ; \
        a_pad2 = 0 ; a_pad3 = 0 ; aai = a_pad2 + a_pad3 ! avoid unused warnings
#   define ALIGN_ARGS [ \
              c_loc(align_s1%t), c_loc(align_s2), c_loc(align_s3), \
            ( c_loc(align_arr(aai)%t), aai = 1,size(align_arr) ) \
           ]

    function check_team_type() result(diag)
        type(test_diagnosis_t) :: diag
        type(prif_team_type) :: team
        type(pointer_wrapper_t) :: pointer_wrap
        type(dummy_t), target :: tgt
        ALIGN(prif_team_type)

        diag = .true.

        ! size check
        call report_size("prif_team_type", storage_size(team)/8, ALIGN_ARGS)
        ALSO(storage_size(team) .equalsExpected. storage_size(pointer_wrap))

        ! default initialization check
        pointer_wrap%info => tgt
        pointer_wrap = transfer(team, pointer_wrap)
        ALSO2(.not. associated(pointer_wrap%info), "default initialization to null")
    end function

    function check_event_type() result(diag)
        type(test_diagnosis_t) :: diag
        type(prif_event_type) :: event
        integer :: ssz
        integer(int8), allocatable :: bytes(:)
        ALIGN(prif_event_type)

        diag = .true.

        ! size check
        call report_size("prif_event_type", storage_size(event)/8, ALIGN_ARGS)
        ssz = storage_size(event)
        ALSO(ssz .greaterThan. 0)
        ALSO(ssz .isAtMost. 64*8) 

        ! default initialization check
        allocate(bytes(64))
        bytes = transfer(event, bytes)
        ALSO2(.all.(int(bytes) .equalsExpected. 0), "default initialization to zero")
    end function

    function check_lock_type() result(diag)
        type(test_diagnosis_t) :: diag
        type(prif_lock_type) :: lock
        integer :: ssz
        integer(int8), allocatable :: bytes(:)
        ALIGN(prif_lock_type)

        diag = .true.

        ! size check
        call report_size("prif_lock_type", storage_size(lock)/8, ALIGN_ARGS)
        ssz = storage_size(lock)
        ALSO(ssz .greaterThan. 0)
        ALSO(ssz .isAtMost. 64*8) 

        ! default initialization check
        allocate(bytes(64))
        bytes = transfer(lock, bytes)
        ALSO2(.all.(int(bytes) .equalsExpected. 0), "default initialization to zero")
    end function

    function check_notify_type() result(diag)
        type(test_diagnosis_t) :: diag
        type(prif_notify_type) :: notify
        integer :: ssz
        integer(int8), allocatable :: bytes(:)
        ALIGN(prif_notify_type)

        diag = .true.

        ! size check
        call report_size("prif_notify_type", storage_size(notify)/8, ALIGN_ARGS)
        ssz = storage_size(notify)
        ALSO(ssz .greaterThan. 0)
        ALSO(ssz .isAtMost. 64*8) 

        ! default initialization check
        allocate(bytes(64))
        bytes = transfer(notify, bytes)
        ALSO2(.all.(int(bytes) .equalsExpected. 0), "default initialization to zero")
    end function

    function check_critical_type() result(diag)
        type(test_diagnosis_t) :: diag
        type(prif_critical_type) :: critical
        integer :: ssz
        integer(int8), allocatable :: bytes(:)
        ALIGN(prif_critical_type)

        diag = .true.

        ! size check
        call report_size("prif_critical_type", storage_size(critical)/8, ALIGN_ARGS)
        ssz = storage_size(critical)
        ALSO(ssz .greaterThan. 0)
        ALSO(ssz .isAtMost. 64*8) 

        ! default initialization check
        allocate(bytes(64))
        bytes = transfer(critical, bytes)
        ALSO2(.all.(int(bytes) .equalsExpected. 0), "default initialization to zero")
    end function

    function check_coarray_handle() result(diag)
        type(test_diagnosis_t) :: diag
        type(prif_coarray_handle) :: handle
        type(cptr_wrapper_t) :: cptr_wrap
        ALIGN(prif_coarray_handle)

        diag = .true.

        ! size check
        call report_size("prif_coarray_handle", storage_size(handle)/8, ALIGN_ARGS)
        ALSO(storage_size(handle) .equalsExpected. storage_size(cptr_wrap))
    end function

end module prif_types_test_m

module prif_rma_test_m
# include "test-uses-alloc.F90"
    use prif, only: &
            prif_num_images, &
            prif_put, &
            prif_put_indirect, &
            prif_get, &
            prif_get_indirect, &
            prif_sync_all, &
            prif_sync_memory, &
            prif_this_image_no_coarray
    use julienne_m, only: test_description_t, test_diagnosis_t, test_result_t, test_t, usher, operator(.equalsExpected.)

    implicit none
    private
    public :: prif_rma_test_t

    type, extends(test_t) :: prif_rma_test_t
    contains
      procedure, nopass, non_overridable :: subject
      procedure, nopass, non_overridable :: results
    end type

contains

    pure function subject()
      character(len=:), allocatable :: subject
      subject = "PRIF RMA"
    end function

    function results() result(test_results)
        type(test_result_t), allocatable :: test_results(:)
        type(prif_rma_test_t) prif_rma_test

        allocate(test_results, source = prif_rma_test%run([ &
           test_description_t("sending a value to another image", usher(check_put)) &
          ,test_description_t("sending a value with indirect interface", usher(check_put_indirect)) &
          ,test_description_t("getting a value from another image", usher(check_get)) &
          ,test_description_t("getting a value with indirect interface", usher(check_get_indirect)) &
        ]))
    end function

    function check_put() result(diag)
        type(test_diagnosis_t) :: diag

        integer :: dummy_element, num_imgs, expected, neighbor
        integer, target :: me
        type(prif_coarray_handle) :: coarray_handle
        type(c_ptr) :: allocated_memory
        integer, pointer :: local_slice

        call prif_allocate_coarray( &
                [integer(c_int64_t) :: 1], [integer(c_int64_t)::], &
                size_in_bytes = int(storage_size(dummy_element)/8, c_size_t), &
                final_func = c_null_funptr, &
                coarray_handle = coarray_handle, &
                allocated_memory = allocated_memory)
        call c_f_pointer(allocated_memory, local_slice)

        call prif_num_images(num_images=num_imgs)
        call prif_this_image_no_coarray(this_image=me)
        neighbor = merge(me+1, 1, me < num_imgs)
        expected = merge(me-1, num_imgs, me > 1)

        call prif_put( &
                image_num = neighbor, &
                coarray_handle = coarray_handle, &
                offset = 0_c_size_t, &
                current_image_buffer = c_loc(me), &
                size_in_bytes = c_sizeof(me))
        call prif_sync_all

        ! superfluous, just to ensure prif_sync_memory is usable
        call prif_sync_memory

        diag = local_slice .equalsExpected. expected

        call prif_deallocate_coarray(coarray_handle)
    end function

    function check_put_indirect() result(diag)
        type(test_diagnosis_t) :: diag

        type :: my_type
          type(c_ptr) :: my_component
        end type

        type(my_type), target :: dummy_element
        integer, pointer :: component_access
        integer :: dummy_component, num_imgs, expected, neighbor
        integer, target :: me
        type(prif_coarray_handle) :: coarray_handle
        type(c_ptr) :: allocated_memory
        type(my_type), pointer :: local_slice
        integer(c_intptr_t) :: base_addr

        call prif_allocate_coarray( &
                [integer(c_int64_t) :: 1], [integer(c_int64_t)::], &
                size_in_bytes = int(storage_size(dummy_element)/8, c_size_t), &
                final_func = c_null_funptr, &
                coarray_handle = coarray_handle, &
                allocated_memory = allocated_memory)
        call c_f_pointer(allocated_memory, local_slice)
        call prif_allocate( &
                size_in_bytes = int(storage_size(dummy_component)/8, c_size_t), &
                allocated_memory = local_slice%my_component)
        call prif_sync_all

        call prif_num_images(num_images=num_imgs)
        call prif_this_image_no_coarray(this_image=me)
        neighbor = merge(me+1, 1, me < num_imgs)
        expected = merge(me-1, num_imgs, me > 1)

        call prif_get( &
                image_num = neighbor, &
                coarray_handle = coarray_handle, &
                offset = 0_c_size_t, &
                current_image_buffer = c_loc(dummy_element), &
                size_in_bytes = int(storage_size(dummy_element)/8, c_size_t))
        base_addr = transfer(dummy_element%my_component, base_addr)
        call prif_put_indirect( &
                image_num = neighbor, &
                remote_ptr = base_addr, &
                current_image_buffer = c_loc(me), &
                size_in_bytes = int(storage_size(me)/8, c_size_t))
        call prif_sync_all

        call c_f_pointer(local_slice%my_component, component_access)
        diag = component_access .equalsExpected. expected

        call prif_deallocate(local_slice%my_component)
        call prif_deallocate_coarray(coarray_handle)
    end function

    function check_get() result(diag)
        type(test_diagnosis_t) :: diag

        integer :: dummy_element, num_imgs, me, neighbor, expected
        integer, target :: retrieved
        type(prif_coarray_handle) :: coarray_handle
        type(c_ptr) :: allocated_memory
        integer, pointer :: local_slice

        call prif_allocate_coarray( &
                [integer(c_int64_t) :: 1], [integer(c_int64_t)::], &
                size_in_bytes = int(storage_size(dummy_element)/8, c_size_t), &
                final_func = c_null_funptr, &
                coarray_handle = coarray_handle, &
                allocated_memory = allocated_memory)
        call c_f_pointer(allocated_memory, local_slice)

        call prif_num_images(num_images=num_imgs)
        call prif_this_image_no_coarray(this_image=me)
        neighbor = merge(me+1, 1, me < num_imgs)
        expected = neighbor
        local_slice = me
        call prif_sync_all

        call prif_get( &
                image_num = neighbor, &
                coarray_handle = coarray_handle, &
                offset = 0_c_size_t, &
                current_image_buffer = c_loc(retrieved), &
                size_in_bytes = c_sizeof(retrieved))

        diag = retrieved .equalsExpected. expected

        call prif_deallocate_coarray(coarray_handle)
    end function

    function check_get_indirect() result(diag)
        type(test_diagnosis_t) :: diag

        type :: my_type
          type(c_ptr) :: my_component
        end type

        type(my_type), target :: dummy_element
        integer, pointer :: component_access
        integer :: dummy_component, num_imgs, me, expected, neighbor
        integer, target :: retrieved
        type(prif_coarray_handle) :: coarray_handle
        type(c_ptr) :: allocated_memory
        type(my_type), pointer :: local_slice
        integer(c_intptr_t) :: base_addr

        call prif_allocate_coarray( &
                [integer(c_int64_t) :: 1], [integer(c_int64_t)::], &
                size_in_bytes = int(storage_size(dummy_element)/8, c_size_t), &
                final_func = c_null_funptr, &
                coarray_handle = coarray_handle, &
                allocated_memory = allocated_memory)
        call c_f_pointer(allocated_memory, local_slice)
        call prif_allocate( &
                size_in_bytes = int(storage_size(dummy_component)/8, c_size_t), &
                allocated_memory = local_slice%my_component)

        call prif_num_images(num_images=num_imgs)
        call prif_this_image_no_coarray(this_image=me)
        neighbor = merge(me+1, 1, me < num_imgs)
        expected = neighbor
        call c_f_pointer(local_slice%my_component, component_access)
        component_access = me
        call prif_sync_all

        call prif_get( &
                image_num = neighbor, &
                coarray_handle = coarray_handle, &
                offset = 0_c_size_t, &
                current_image_buffer = c_loc(dummy_element), &
                size_in_bytes = int(storage_size(dummy_element)/8, c_size_t))
        base_addr = transfer(dummy_element%my_component, base_addr)
        call prif_get_indirect( &
                image_num = neighbor, &
                remote_ptr = base_addr, &
                current_image_buffer = c_loc(retrieved), &
                size_in_bytes = int(storage_size(retrieved)/8, c_size_t))

        diag = retrieved .equalsExpected. expected

        call prif_deallocate(local_slice%my_component)
        call prif_deallocate_coarray(coarray_handle)
    end function
end module

#include "test-utils.F90"

module prif_image_index_test_m
# include "test-uses-alloc.F90"
    use prif, only: &
                    prif_image_index, prif_num_images, &
                    prif_team_type, prif_get_team, &
                    prif_this_image_no_coarray, &
                    prif_form_team, prif_change_team, prif_end_team, &
                    prif_image_index_with_team, prif_image_index_with_team_number, &
                    prif_initial_team_index, prif_initial_team_index_with_team, prif_initial_team_index_with_team_number, &
                    prif_this_image_with_coarray, prif_this_image_with_dim, &
                    prif_lcobound_no_dim, prif_ucobound_no_dim, &
                    prif_num_images_with_team, PRIF_INITIAL_TEAM
    use julienne_m, only: test_description_t, test_diagnosis_t, test_result_t, test_t, string_t, usher &
       ,operator(.also.), operator(.equalsExpected.), operator(.isAtLeast.), operator(.isAtMost.), operator(//)

    implicit none
    private
    public :: prif_image_index_test_t

    type, extends(test_t) :: prif_image_index_test_t
    contains
      procedure, nopass, non_overridable :: subject
      procedure, nopass, non_overridable :: results
    end type
contains
    pure function subject()
      character(len=:), allocatable :: subject
      subject = "prif_image_index and prif_initial_team_index"
    end function
      
    function results() result(test_results)
      type(test_result_t), allocatable :: test_results(:)
      type(prif_image_index_test_t) prif_image_index_test

      allocate(test_results, source = prif_image_index_test%run([ &
         test_description_t("returning 1 for the simplest case", usher(check_simple_case)) &
        ,test_description_t("returning 1 when given the lower bounds", usher(check_lower_bounds)) &
        ,test_description_t("returning 0 with invalid subscripts", usher(check_invalid_subscripts)) &
        ,test_description_t("returning the expected answer for a more complicated case w/corank=2", usher(check_complicated_2d)) &
        ,test_description_t("returning the expected answer for a more complicated case w/corank=3", usher(check_complicated_3d)) &
        ,test_description_t("returning the expected answer with a child team and corank=2", usher(check_complicated_2d_team)) &
      ]))
    end function

    function check_this_image_coarray(coarray_handle, corank, team) result(diag)
        type(prif_coarray_handle) :: coarray_handle
        integer(c_int) :: corank
        type(prif_team_type), optional :: team
        type(test_diagnosis_t) :: diag

        integer(c_int64_t) :: co, cosubscripts(corank), colbound(corank), coubound(corank)
        integer(c_int) :: i, me, me_initial
        type(prif_team_type) :: initial_team

        diag = .true.

        call prif_get_team(PRIF_INITIAL_TEAM, team=initial_team)

        call prif_lcobound_no_dim(coarray_handle, colbound)
        call prif_ucobound_no_dim(coarray_handle, coubound)
        call prif_this_image_no_coarray(team, me)
        call prif_this_image_no_coarray(initial_team, me_initial)

        call prif_this_image_with_coarray(coarray_handle, team=team, cosubscripts=cosubscripts)
        do i=1,corank
          call prif_this_image_with_dim(coarray_handle, dim=i, team=team, cosubscript=co)
          ALSO(co .equalsExpected. cosubscripts(i))

          ALSO(co .isAtLeast. colbound(i))
          if (i /= corank) ALSO(co .isatMost. coubound(i)) ! trailing will differ with team
        end do

        ! verify reverse mapping
        if (present(team)) then
          call prif_image_index_with_team(coarray_handle, cosubscripts, team, i)
        else
          call prif_image_index(coarray_handle, cosubscripts, i)
        end if
        ALSO(i .equalsExpected. me)

        ! and prif_initial_team_index
        if (present(team)) then
          call prif_initial_team_index_with_team(coarray_handle, cosubscripts, team, i)
        else
          call prif_initial_team_index(coarray_handle, cosubscripts, i)
        end if
        ALSO(i .equalsExpected. me_initial)

    end function

    function check_simple_case() result(diag)
        type(test_diagnosis_t) :: diag

        type(prif_coarray_handle) :: coarray_handle
        type(c_ptr) :: allocated_memory
        integer(c_int) :: answer

        diag = .true.

        call prif_allocate_coarray( &
                lcobounds = [1_c_int64_t], &
                ucobounds = [integer(c_int64_t)::], &
                size_in_bytes = 1_c_size_t, &
                final_func = c_null_funptr, &
                coarray_handle = coarray_handle, &
                allocated_memory = allocated_memory)
        call prif_image_index(coarray_handle, [1_c_int64_t], image_index=answer)
        ALSO(answer .equalsExpected. 1_c_int )

        call prif_initial_team_index(coarray_handle, [1_c_int64_t], initial_team_index=answer)
        ALSO(answer .equalsExpected. 1_c_int)

        ALSO(check_this_image_coarray(coarray_handle, 1))

        call prif_deallocate_coarray(coarray_handle)
    end function

    function check_lower_bounds() result(diag)
        type(test_diagnosis_t) :: diag

        type(prif_coarray_handle) :: coarray_handle
        type(c_ptr) :: allocated_memory
        integer(c_int) :: answer

        diag = .true.

        call prif_allocate_coarray( &
                lcobounds = [2_c_int64_t, 3_c_int64_t], &
                ucobounds = [3_c_int64_t], &
                size_in_bytes = 1_c_size_t, &
                final_func = c_null_funptr, &
                coarray_handle = coarray_handle, &
                allocated_memory = allocated_memory)
        call prif_image_index(coarray_handle, [2_c_int64_t, 3_c_int64_t], image_index=answer)
        ALSO(answer .equalsExpected. 1_c_int)

        call prif_initial_team_index(coarray_handle, [2_c_int64_t, 3_c_int64_t], initial_team_index=answer)
        ALSO(answer .equalsExpected. 1_c_int)

        ALSO(check_this_image_coarray(coarray_handle, 2))

        call prif_deallocate_coarray(coarray_handle)
    end function

    function check_invalid_subscripts() result(diag)
        type(test_diagnosis_t) diag

        type(prif_coarray_handle) :: coarray_handle
        type(c_ptr) :: allocated_memory
        integer(c_int) :: answer

        diag = .true.

        call prif_allocate_coarray( &
                lcobounds = [-2_c_int64_t, 2_c_int64_t], &
                ucobounds = [2_c_int64_t], &
                size_in_bytes = 1_c_size_t, &
                final_func = c_null_funptr, &
                coarray_handle = coarray_handle, &
                allocated_memory = allocated_memory)
        call prif_image_index(coarray_handle, [-1_c_int64_t, 1_c_int64_t], image_index=answer)
        ALSO(answer .equalsExpected. 0_c_int)

        ALSO(check_this_image_coarray(coarray_handle, 2))

        call prif_deallocate_coarray(coarray_handle)
    end function

    function check_complicated_2d() result(diag)
        type(test_diagnosis_t) :: diag

        type(prif_coarray_handle) :: coarray_handle
        type(c_ptr) :: allocated_memory
        integer(c_int) :: answer, ni, expected

        diag = .true.

        call prif_num_images(num_images=ni)

        call prif_allocate_coarray( &
                lcobounds = [1_c_int64_t, 2_c_int64_t], &
                ucobounds = [2_c_int64_t], &
                size_in_bytes = 1_c_size_t, &
                final_func = c_null_funptr, &
                coarray_handle = coarray_handle, &
                allocated_memory = allocated_memory)
        call prif_image_index(coarray_handle, [1_c_int64_t, 3_c_int64_t], image_index=answer)
        expected = merge(3_c_int,0_c_int,ni >= 3)
        ALSO(answer .equalsExpected. expected)

        if (expected > 0) then
          call prif_initial_team_index(coarray_handle, [1_c_int64_t, 3_c_int64_t], initial_team_index=answer)
          ALSO(answer .equalsExpected. expected)
        end if

        ALSO(check_this_image_coarray(coarray_handle, 2))

        call prif_deallocate_coarray(coarray_handle)
    end function

    function check_complicated_3d() result(diag)
        type(test_diagnosis_t) diag

        type(prif_coarray_handle) :: coarray_handle
        type(c_ptr) :: allocated_memory
        integer(c_int) :: answer, ni, expected
        type(prif_team_type) :: initial_team

        diag = .true.

        call prif_get_team(team=initial_team)
        call prif_num_images_with_team(team=initial_team, num_images=ni)

        call prif_allocate_coarray( &
                lcobounds = [1_c_int64_t, 0_c_int64_t, 0_c_int64_t], &
                ucobounds = [2_c_int64_t, 1_c_int64_t], &
                size_in_bytes = 1_c_size_t, &
                final_func = c_null_funptr, &
                coarray_handle = coarray_handle, &
                allocated_memory = allocated_memory)
        call prif_image_index_with_team(coarray_handle, &
                           [2_c_int64_t, 1_c_int64_t, 1_c_int64_t], &
                           team=initial_team, image_index=answer)
        expected = merge(8_c_int,0_c_int,ni >= 8)
        ALSO(answer .equalsExpected. expected)

        if (expected > 0) then
          call prif_initial_team_index_with_team(coarray_handle, &
                           [2_c_int64_t, 1_c_int64_t, 1_c_int64_t], &
                           team=initial_team, initial_team_index=answer)
          ALSO(answer .equalsExpected. expected)
        endif

        ALSO(check_this_image_coarray(coarray_handle, 3))

        call prif_deallocate_coarray(coarray_handle)
    end function

    function check_complicated_2d_team() result(diag)
        type(test_diagnosis_t) diag

        type(prif_coarray_handle) :: coarray_handle
        type(c_ptr) :: allocated_memory
        integer(c_int) :: answer, ni, cni, me
        integer(c_int64_t) :: which_team
        type(prif_team_type) :: initial_team, child_team

        diag = .true.

        call prif_get_team(team=initial_team)
        call prif_num_images_with_team(team=initial_team, num_images=ni)
        call prif_this_image_no_coarray(this_image=me)

        call prif_allocate_coarray( &
                lcobounds = [0_c_int64_t, 2_c_int64_t], &
                ucobounds = [1_c_int64_t], &
                size_in_bytes = 1_c_size_t, &
                final_func = c_null_funptr, &
                coarray_handle = coarray_handle, &
                allocated_memory = allocated_memory)

        which_team = merge(2_c_int64_t, 1_c_int64_t, mod(me, 2) == 0)
        call prif_form_team(team_number = which_team, team = child_team)
        call prif_change_team(child_team)

          call prif_num_images_with_team(team=child_team, num_images=cni)

          ! image_index lcobound

          call prif_image_index_with_team(coarray_handle, &
                              [0_c_int64_t, 2_c_int64_t], &
                              team=initial_team, image_index=answer)
          ALSO(answer .equalsExpected. 1_c_int)

          call prif_image_index_with_team_number(coarray_handle, &
                              [0_c_int64_t, 2_c_int64_t], &
                              team_number=-1_c_int64_t, image_index=answer)
          ALSO(answer .equalsExpected. 1_c_int)

          call prif_image_index_with_team(coarray_handle, &
                              [0_c_int64_t, 2_c_int64_t], &
                              team=child_team, image_index=answer)
          ALSO(answer .equalsExpected. 1_c_int)

          call prif_image_index_with_team_number(coarray_handle, &
                              [0_c_int64_t, 2_c_int64_t], &
                              team_number=which_team, image_index=answer)
          ALSO(answer .equalsExpected. 1_c_int)

          call prif_image_index(coarray_handle, &
                              [0_c_int64_t, 2_c_int64_t], &
                              image_index=answer)
          ALSO(answer .equalsExpected. 1_c_int)

          ! initial_team_index lcobound

          call prif_initial_team_index_with_team(coarray_handle, &
                              [0_c_int64_t, 2_c_int64_t], &
                              initial_team, answer)
          ALSO(answer .equalsExpected. 1_c_int)

          call prif_initial_team_index_with_team_number(coarray_handle, &
                              [0_c_int64_t, 2_c_int64_t], &
                              -1_c_int64_t, answer)
          ALSO(answer .equalsExpected. 1_c_int)

          call prif_initial_team_index_with_team(coarray_handle, &
                              [0_c_int64_t, 2_c_int64_t], &
                              child_team, answer)
          ALSO(answer .equalsExpected. merge(1_c_int,2_c_int,which_team==1))

          call prif_initial_team_index_with_team_number(coarray_handle, &
                              [0_c_int64_t, 2_c_int64_t], &
                              which_team, answer)
          ALSO(answer .equalsExpected. merge(1_c_int,2_c_int,which_team==1))

          call prif_initial_team_index(coarray_handle, &
                              [0_c_int64_t, 2_c_int64_t], &
                              answer)
          ALSO(answer .equalsExpected. merge(1_c_int,2_c_int,which_team==1))

          ! image_index 3

          call prif_image_index_with_team(coarray_handle, &
                              [0_c_int64_t, 3_c_int64_t], &
                              team=initial_team, image_index=answer)
          ALSO(answer .equalsExpected. merge(3_c_int,0_c_int,ni >= 3))

          call prif_image_index_with_team_number(coarray_handle, &
                              [0_c_int64_t, 3_c_int64_t], &
                              team_number=-1_c_int64_t, image_index=answer)
          ALSO(answer .equalsExpected. merge(3_c_int,0_c_int,ni >= 3))

          call prif_image_index_with_team(coarray_handle, &
                              [0_c_int64_t, 3_c_int64_t], &
                              team=child_team, image_index=answer)
          ALSO(answer .equalsExpected. merge(3_c_int,0_c_int,cni >= 3))

          call prif_image_index_with_team_number(coarray_handle, &
                              [0_c_int64_t, 3_c_int64_t], &
                              team_number=which_team, image_index=answer)
          ALSO(answer .equalsExpected. merge(3_c_int,0_c_int,cni >= 3))

          call prif_image_index(coarray_handle, &
                              [0_c_int64_t, 3_c_int64_t], &
                              image_index=answer)
          ALSO(answer .equalsExpected. merge(3_c_int,0_c_int,cni >= 3))

          ! initial_team_index 3
          if (ni >= 3) then
            call prif_initial_team_index_with_team(coarray_handle, &
                                [0_c_int64_t, 3_c_int64_t], &
                                team=initial_team, initial_team_index=answer)
            ALSO(answer .equalsExpected. 3_c_int)
  
            call prif_initial_team_index_with_team_number(coarray_handle, &
                                [0_c_int64_t, 3_c_int64_t], &
                                team_number=-1_c_int64_t, initial_team_index=answer)
            ALSO(answer .equalsExpected. 3_c_int)
          end if
          if (cni >= 3) then
            call prif_initial_team_index_with_team(coarray_handle, &
                                [0_c_int64_t, 3_c_int64_t], &
                                team=child_team, initial_team_index=answer)
            ALSO(answer .equalsExpected. merge(5_c_int,6_c_int,which_team==1))
  
            call prif_initial_team_index_with_team_number(coarray_handle, &
                                [0_c_int64_t, 3_c_int64_t], &
                                team_number=which_team, initial_team_index=answer)
            ALSO(answer .equalsExpected. merge(5_c_int,6_c_int,which_team==1))
  
            call prif_initial_team_index(coarray_handle, &
                                [0_c_int64_t, 3_c_int64_t], &
                                initial_team_index=answer)
            ALSO(answer .equalsExpected. merge(5_c_int,6_c_int,which_team==1))
          end if

          ALSO(check_this_image_coarray(coarray_handle, 2, initial_team))
          ALSO(check_this_image_coarray(coarray_handle, 2, child_team))

        call prif_end_team()
        call prif_deallocate_coarray(coarray_handle)
    end function

end module

! Copyright (c), The Regents of the University of California
! Terms of use are as specified in LICENSE.txt

#ifndef CAF_INCLUDED_LANGUAGE_SUPPORT
#define CAF_INCLUDED_LANGUAGE_SUPPORT

#ifdef __GNUC__
#  define HAVE_GCC_VERSION (__GNUC__ * 10000 + __GNUC_MINOR__ * 100 + __GNUC_PATCHLEVEL__)
#endif

#ifndef HAVE_SELECTED_LOGICAL_KIND
  ! Define whether the compiler supports standard intrinsic function selected_logical_kind(), 
  ! a feature introduced in Fortran 2023 clause 16.9.182.
#if defined(_CRAYFTN) || defined(NAGFOR) || defined(__flang__) || (HAVE_GCC_VERSION >= 150000)
#define HAVE_SELECTED_LOGICAL_KIND 1
#else
#define HAVE_SELECTED_LOGICAL_KIND 0
#endif  
#endif

#ifndef HAVE_PROCEDURE_ACTUAL_FOR_POINTER_DUMMY
  ! Define whether the compiler supports associating a procedure pointer dummy argument with an
  ! actual argument that is a valid target for the pointer dummy in a procedure assignment, a 
  ! feature introduced in Fortran 2008 and described in Fortran 2023 clause 15.5.2.10 paragraph 5.
#if defined(_CRAYFTN) || defined(__INTEL_COMPILER) || defined(NAGFOR) || defined(__flang__) || (HAVE_GCC_VERSION > 140200)
#  define HAVE_PROCEDURE_ACTUAL_FOR_POINTER_DUMMY 1
#else
#  define HAVE_PROCEDURE_ACTUAL_FOR_POINTER_DUMMY 0
#endif  
#endif

#ifndef NEED_C_FUNLOC_WORKAROUND
# if __GFORTRAN__ && HAVE_GCC_VERSION <= 150200
  ! Gfortran 13..15.2 bug workaround, believed to be fixed in 15.3 and 16.x:
  !   https://gcc.gnu.org/bugzilla/show_bug.cgi?id=124652
#   define NEED_C_FUNLOC_WORKAROUND 1
# else
#   define NEED_C_FUNLOC_WORKAROUND 0
# endif
#endif
#if NEED_C_FUNLOC_WORKAROUND
# define CAF_C_FUNLOC_PROCPTR(p) caf_c_funloc_deref(c_funloc(p))
#else
# define CAF_C_FUNLOC_PROCPTR(p) c_funloc(p)
#endif

! ISO_FORTRAN_ENV constant value control:
! The following knobs influence Caffeine's choice of value for the named constants 
! specified by PRIF for ISO_FORTRAN_ENV:
! * CAF_IMPORT_{ATOMIC,STAT,TEAM}_CONSTANTS: Import PRIF constant values 
!   of the given category from the compiler's ISO_FORTRAN_ENV
! * CAF_IMPORT_CONSTANTS: Provides a default value for each category-specific knob above, 
!   which take precedence
! NOTE: In all cases imported constant values are silently assumed to satisfy
! the requirements for the corresponding PRIF named constant.
! Additionally, the ATOMIC KIND constants are assumed to denote a 64-bit interoperable type
#ifndef CAF_IMPORT_CONSTANTS
#  if defined(__flang__)
#    define CAF_IMPORT_CONSTANTS 1
#  else
#    define CAF_IMPORT_CONSTANTS 0
#  endif
#endif
#ifndef CAF_IMPORT_ATOMIC_CONSTANTS
#define CAF_IMPORT_ATOMIC_CONSTANTS CAF_IMPORT_CONSTANTS
#endif
#ifndef CAF_IMPORT_STAT_CONSTANTS
#define CAF_IMPORT_STAT_CONSTANTS   CAF_IMPORT_CONSTANTS
#endif
#ifndef CAF_IMPORT_TEAM_CONSTANTS
#define CAF_IMPORT_TEAM_CONSTANTS   CAF_IMPORT_CONSTANTS
#endif

#endif

! Copyright (c), The Regents of the University of California
! Terms of use are as specified in LICENSE.txt

#include "assert_macros.h"

submodule(prif:prif_private_s) sync_stmt_s
  ! DO NOT ADD USE STATEMENTS HERE
  ! All use statements belong in prif_private_s.F90
  implicit none

  ! Data structures used to implement prif_sync_images
  type(prif_coarray_handle) :: si_coarray_handle
  type(prif_event_type), pointer :: si_evt(:)
  integer(c_size_t) :: sizeof_event

contains

  module procedure prif_sync_all
    call caf_sync_team(current_team%info%gex_team)
    if (present(stat)) stat = 0
  end procedure

  module procedure prif_sync_team
    call caf_sync_team(team%info%gex_team)
    if (present(stat)) stat = 0
  end procedure

  module procedure prif_sync_memory
    call caf_sync_memory
    if (present(stat)) stat = 0
  end procedure

  module procedure sync_init
    ! Create the array coarray used to implement prif_sync_images
    ! This following is effectively: 
    !   type(EVENT_TYPE), allocatable :: si_evt(:)[*]
    !   ALLOCATE( si_evt(NUM_IMAGES()) )
    type(prif_event_type) :: dummy_event
    type(c_ptr) :: allocated_memory

    associate(num_imgs => initial_team%num_images) 

      sizeof_event = int(storage_size(dummy_event)/8, c_size_t)

      call prif_allocate_coarray( &
            lcobounds = [1_c_int64_t], &
            ucobounds = [int(num_imgs,c_int64_t)], &
            size_in_bytes = sizeof_event * num_imgs, &
            final_func = c_null_funptr, &
            coarray_handle = si_coarray_handle, &
            allocated_memory = allocated_memory)
      call c_f_pointer(allocated_memory, si_evt, [num_imgs])
      si_evt = dummy_event ! default initialize

   end associate
    
  end procedure

  module procedure prif_sync_images
    integer(c_int) :: i, img, l, u
    integer(c_intptr_t) :: evt_ptr

    call_assert(coarray_handle_check(si_coarray_handle))

    call caf_sync_memory ! end segment and amortize release fence

    associate(num_imgs => current_team%info%num_images) 
      if (present(image_set)) then
        l = lbound(image_set,1)
        u = ubound(image_set,1)
#       if ASSERTIONS
          block ! input validation
            logical p(num_imgs)
            p = .false.
            do i = l,u
              call_assert(image_set(i) >= 1 .and. image_set(i) <= num_imgs)
              call_assert_describe(.not. p(image_set(i)), "image indices in SYNC IMAGES are not distinct!")
              p(image_set(i)) = .true.
            end do
          end block
#       endif
      else ! SYNC IMAGES (*)
        l = 1
        u = num_imgs
      endif
    end associate

    ! post an event to each peer in my slot
    do i=l,u
      if (present(image_set)) then
        img = image_set(i)
      else
        img = i
      endif
      img = caf_image_to_initial( current_team%info%gex_team, img )
      call base_pointer(si_coarray_handle, img, evt_ptr)
      evt_ptr = evt_ptr + sizeof_event * (initial_team%this_image - 1)
      call caf_event_post(img, evt_ptr, &
                          segment_boundary=0, release_fence=0)
    end do

    ! reap an event from each peer in its slot
    ! final iteration issues acquire fence
    do i=l,u
      if (present(image_set)) then
        img = image_set(i)
      else
        img = i
      endif
      img = caf_image_to_initial( current_team%info%gex_team, img )
      call caf_event_wait(c_loc(si_evt(img)), 1_c_int64_t, &
                          segment_boundary=0, &
                          acquire_fence=merge(1,0,i==u))
    end do

    if (present(stat)) stat = 0
  end procedure

end submodule

! Copyright (c), The Regents of the University of California
! Terms of use are as specified in LICENSE.txt

#include "assert_macros.h"

submodule(prif:prif_private_s) co_min_s
  ! DO NOT ADD USE STATEMENTS HERE
  ! All use statements belong in prif_private_s.F90
  implicit none

contains

  module procedure prif_co_min
    if (present(result_image)) then
      call_assert(result_image >= 1 .and. result_image <= current_team%info%num_images)
    endif
    call contiguous_co_min(a, result_image, stat, errmsg, errmsg_alloc)
  end procedure

  subroutine contiguous_co_min(a, result_image, stat, errmsg, errmsg_alloc)
    implicit none
    type(*), intent(inout), target, contiguous :: a(..)
    integer(c_int), intent(in), optional :: result_image
    integer(c_int), intent(out), optional :: stat
    character(len=*), intent(inout), optional :: errmsg
    character(len=:), intent(inout), allocatable, optional :: errmsg_alloc

    if (present(stat)) stat=0

    call caf_co_min( &
          a, &
          optional_value(result_image), &
          int(product(shape(a)), c_size_t), &
          current_team%info%gex_team)
  end subroutine

  subroutine char_min_wrapper(arg1, arg2_and_out, count, cdata) bind(C)
    type(c_ptr), intent(in), value :: arg1, arg2_and_out
    integer(c_size_t), intent(in), value :: count
    type(c_ptr), intent(in), value :: cdata

    integer(c_size_t), pointer :: char_len
    integer(c_size_t) :: i

    if (count == 0) return
    call c_f_pointer(cdata, char_len)
    block
      character(len=char_len,kind=c_char), pointer :: lhs(:), rhs_and_result(:)
      call c_f_pointer(arg1, lhs, [count])
      call c_f_pointer(arg2_and_out, rhs_and_result, [count])
      do i = 1, count
        if (lhs(i) <= rhs_and_result(i)) rhs_and_result(i) = lhs(i)
      end do
    end block
  end subroutine

  module procedure prif_co_min_character
    integer(c_size_t), target :: char_len
    procedure(prif_operation_wrapper_interface), pointer :: op

    char_len = len(a)
    op => char_min_wrapper
#if defined(__GFORTRAN__) && 0
    ! gfortran 13.2 (sometimes?) crashes on the call below
    ! internal compiler error: in make_decl_rtl, at varasm.cc:1442
    call unimplemented("prif_co_min_character")
#else
    call prif_co_reduce(a, op, c_loc(char_len), result_image, stat, errmsg, errmsg_alloc)
#endif
  end procedure

end submodule co_min_s

! Copyright (c), The Regents of the University of California
! Terms of use are as specified in LICENSE.txt

#include "assert_macros.h"

submodule(prif:prif_private_s) image_queries_s
  ! DO NOT ADD USE STATEMENTS HERE
  ! All use statements belong in prif_private_s.F90
  implicit none

contains

  module procedure prif_num_images
    num_images = current_team%info%num_images
  end procedure

  module procedure prif_num_images_with_team
    num_images = team%info%num_images
  end procedure

  module procedure prif_num_images_with_team_number
    if (team_number == -1) then
      num_images = initial_team%num_images 
    else if (team_number == current_team%info%team_number) then
      num_images = current_team%info%num_images
    else
      call unimplemented("prif_num_images_with_team_number: no support for sibling teams")
    end if
  end procedure

  module procedure prif_this_image_no_coarray
    if (present(team)) then
      this_image = team%info%this_image
    else
      this_image = current_team%info%this_image
    endif
  end procedure

  module procedure prif_this_image_with_coarray
    integer(c_int) :: offset, doff, dsz
    integer :: dim

    call_assert(coarray_handle_check(coarray_handle))
    call_assert(size(cosubscripts) == coarray_handle%info%corank)

    if (present(team)) then
      offset = team%info%this_image - 1
    else
      offset = current_team%info%this_image - 1
    endif

    associate (info => coarray_handle%info)
      call_assert(size(cosubscripts) == info%corank)
      do dim = 1, info%corank-1
        dsz = INT(info%ucobounds(dim) - info%lcobounds(dim) + 1, c_int)
        doff = mod(offset, dsz)
        cosubscripts(dim) = doff + info%lcobounds(dim)
        call_assert(cosubscripts(dim) <= info%ucobounds(dim))
        offset = offset / dsz
      end do
      cosubscripts(info%corank) = offset + info%lcobounds(info%corank)
    end associate

#   if ASSERTIONS
      block ! sanity check
        integer(c_int) :: image_index
        if (present(team)) then
          call prif_image_index_with_team(coarray_handle, cosubscripts, team, image_index)
          call_assert(image_index == team%info%this_image)
        else
          call prif_image_index(coarray_handle, cosubscripts, image_index)
          call_assert(image_index == current_team%info%this_image)
        end if
      end block
#   endif
  end procedure

  module procedure prif_this_image_with_dim
    call_assert(coarray_handle_check(coarray_handle))

    block
      integer(c_int64_t) :: cosubscripts(coarray_handle%info%corank)

      call_assert(dim >= 1 .and. dim <= coarray_handle%info%corank)

      call prif_this_image_with_coarray(coarray_handle, team, cosubscripts)

      cosubscript = cosubscripts(dim)
    end block
  end procedure

  module procedure prif_failed_images
    ! no current support for detecting image failure
    allocate(failed_images(0))
  end procedure

  module procedure prif_stopped_images
    ! no current support for detecting image stops
    allocate(stopped_images(0))
  end procedure

  module procedure prif_image_status
    ! no current support for detecting image failure/stops
    image_status = 0
  end procedure

end submodule image_queries_s

! Copyright (c), The Regents of the University of California
! Terms of use are as specified in LICENSE.txt

#include "assert_macros.h"

submodule(prif:prif_private_s) co_reduce_s
  ! DO NOT ADD USE STATEMENTS HERE
  ! All use statements belong in prif_private_s.F90
  implicit none
contains

  module subroutine prif_co_reduce(a, operation_wrapper, cdata, result_image, stat, errmsg, errmsg_alloc)
    type(*), intent(inout), target :: a(..)
    procedure(prif_operation_wrapper_interface), pointer, intent(in) :: operation_wrapper
    type(c_ptr), intent(in), value :: cdata
    integer(c_int), intent(in), optional :: result_image
    integer(c_int), intent(out), optional :: stat
    character(len=*), intent(inout), optional :: errmsg
    character(len=:), intent(inout), allocatable, optional :: errmsg_alloc
    if (present(result_image)) then
      call_assert(result_image >= 1 .and. result_image <= current_team%info%num_images)
    endif
    call_assert_describe(associated(operation_wrapper), "prif_co_reduce: associated(operation_wrapper)")
    call contiguous_co_reduce(a, operation_wrapper, cdata, result_image, stat, errmsg, errmsg_alloc)
  end subroutine

  subroutine contiguous_co_reduce(a, operation_wrapper, cdata, result_image, stat, errmsg, errmsg_alloc)
    type(*), intent(inout), target, contiguous :: a(..)
    procedure(prif_operation_wrapper_interface), pointer, intent(in) :: operation_wrapper
    type(c_ptr), intent(in), value :: cdata
    integer(c_int), intent(in), optional :: result_image
    integer(c_int), intent(out), optional :: stat
    character(len=*), intent(inout), optional :: errmsg
    character(len=:), intent(inout), allocatable, optional :: errmsg_alloc
    type(c_funptr) :: funptr 

    if (present(stat)) stat=0

    funptr = c_funloc(operation_wrapper)
    call_assert(c_associated(funptr))

    call caf_co_reduce( &
        a, &
        optional_value(result_image), &
        int(product(shape(a)), c_size_t), &
        funptr, &
        cdata, &
        current_team%info%gex_team)
  end subroutine

end submodule co_reduce_s

! Copyright (c), The Regents of the University of California
! Terms of use are as specified in LICENSE.txt
submodule(prif:prif_private_s) locks_s
  ! DO NOT ADD USE STATEMENTS HERE
  ! All use statements belong in prif_private_s.F90
  implicit none

contains

  module procedure prif_lock
    call unimplemented("prif_lock")

    if (present(stat)) stat = 0
  end procedure

  module procedure prif_lock_indirect
    call unimplemented("prif_lock_indirect")

    if (present(stat)) stat = 0
  end procedure

  module procedure prif_unlock
    call unimplemented("prif_unlock")

    if (present(stat)) stat = 0
  end procedure

  module procedure prif_unlock_indirect
    call unimplemented("prif_unlock_indirect")

    if (present(stat)) stat = 0
  end procedure

end submodule locks_s

! Copyright (c), The Regents of the University of California
! Terms of use are as specified in LICENSE.txt

#include "assert_macros.h"

submodule(prif:prif_private_s) coarray_queries_s
  ! DO NOT ADD USE STATEMENTS HERE
  ! All use statements belong in prif_private_s.F90
  implicit none

contains

  module procedure prif_lcobound_with_dim
    call_assert(coarray_handle_check(coarray_handle))
    call_assert(dim >= 1 .and. dim <= coarray_handle%info%corank)

    lcobound = coarray_handle%info%lcobounds(dim)
  end procedure

  module procedure prif_lcobound_no_dim
    call_assert(coarray_handle_check(coarray_handle))
    call_assert(size(lcobounds) == coarray_handle%info%corank)

    lcobounds = coarray_handle%info%lcobounds(1:coarray_handle%info%corank)
  end procedure

  module procedure prif_ucobound_with_dim
    call_assert(coarray_handle_check(coarray_handle))

    associate (info => coarray_handle%info, corank => coarray_handle%info%corank) 
      call_assert(dim >= 1 .and. dim <= corank)

      if (corank == 1) then ! common-case optimization
        ucobound = info%lcobounds(1) + current_team%info%num_images - 1
      elseif (dim < corank) then
        ucobound = info%ucobounds(dim)
      else ! compute trailing ucobound, based on current team size
        call_assert(dim == corank)
        associate (epp => info%coshape_epp(corank), num_imgs => current_team%info%num_images)
          if (epp >= num_imgs) then ! optimization to skip a divide
            ucobound = info%lcobounds(corank)
          else
            ucobound = info%lcobounds(corank) + (num_imgs + epp - 1) / epp - 1
          end if
        end associate
      end if
    end associate
  end procedure

  module procedure prif_ucobound_no_dim
    call_assert(coarray_handle_check(coarray_handle))
    call_assert(size(ucobounds) == coarray_handle%info%corank)

    associate (corank => coarray_handle%info%corank) 
      ucobounds(1:corank-1) = coarray_handle%info%ucobounds(1:corank-1)
      call prif_ucobound_with_dim(coarray_handle, corank, ucobounds(corank))
    end associate
  end procedure

  module procedure prif_coshape
    integer(c_int64_t) :: trailing_ucobound

    call_assert(coarray_handle_check(coarray_handle))
    call_assert(size(sizes) == coarray_handle%info%corank)

    associate(info => coarray_handle%info, corank => coarray_handle%info%corank)
      if (corank == 1) then ! common-case optimization
        sizes(1) = current_team%info%num_images
      else
        sizes(1:corank-1) = info%ucobounds(1:corank-1) - info%lcobounds(1:corank-1) + 1
        associate (epp => info%coshape_epp(corank), num_imgs => current_team%info%num_images)
          if (epp >= num_imgs) then ! optimization to skip a divide
            sizes(corank) = 1
          else
            sizes(corank) = (num_imgs + epp - 1) / epp
          end if
        end associate
      end if
    end associate
  end procedure

  subroutine image_index_helper(coarray_handle, sub, num_images, image_index)
    implicit none
    type(prif_coarray_handle), intent(in) :: coarray_handle
    integer(c_int64_t), intent(in) :: sub(:)
    integer(c_int), intent(in) :: num_images
    integer(c_int), intent(out) :: image_index

    integer :: dim

    call_assert(coarray_handle_check(coarray_handle))

    associate (info => coarray_handle%info, corank => coarray_handle%info%corank) 
      call_assert(size(sub) == corank)
      if (sub(1) .lt. info%lcobounds(1) .or. &
          (corank > 1 .and. sub(1) .gt. info%ucobounds(1))) then
        image_index = 0
        return
      end if
      image_index = 1 + INT(sub(1) - info%lcobounds(1), c_int)
      do dim = 2, size(sub)
        if (sub(dim) .lt. info%lcobounds(dim) .or. &
            (dim < corank .and. sub(dim) .gt. info%ucobounds(dim))) then
          image_index = 0
          return
        end if
        image_index = image_index + INT(sub(dim) - info%lcobounds(dim), c_int) * info%coshape_epp(dim)
       end do
    end associate

    if (image_index .gt. num_images) then
       image_index = 0
    end if
  end subroutine

  module procedure prif_image_index
    call image_index_helper(coarray_handle, sub, current_team%info%num_images, image_index)
  end procedure

  module procedure prif_image_index_with_team
    call image_index_helper(coarray_handle, sub, team%info%num_images, image_index)
  end procedure

  module procedure prif_image_index_with_team_number
    if (team_number == -1) then
      call image_index_helper(coarray_handle, sub, initial_team%num_images, image_index)
    else if (team_number == current_team%info%team_number) then
      call image_index_helper(coarray_handle, sub, current_team%info%num_images, image_index)
    else
      call unimplemented("prif_image_index_with_team_number: no support for sibling teams")
    end if 
  end procedure

  !---------------------------------------------------------------------

  subroutine initial_index_helper(coarray_handle, sub, team, initial_team_index)
    implicit none
    type(prif_coarray_handle), intent(in) :: coarray_handle
    integer(c_int64_t), intent(in) :: sub(:)
    type(prif_team_type), intent(in) :: team
    integer(c_int), intent(out) :: initial_team_index

    integer :: dim
    integer(c_int) :: image_index

    call_assert(coarray_handle_check(coarray_handle))

    associate (info => coarray_handle%info, corank => coarray_handle%info%corank)
      call_assert(size(sub) == corank)
      call_assert(sub(1) .ge. info%lcobounds(1) .and. (corank == 1 .or. sub(1) .le. info%ucobounds(1)))
      image_index = 1 + INT(sub(1) - info%lcobounds(1), c_int)
      do dim = 2, size(sub)
        call_assert(sub(dim) .ge. info%lcobounds(dim) .and. (dim == corank .or. sub(dim) .le. info%ucobounds(dim)))
        image_index = image_index + INT(sub(dim) - info%lcobounds(dim), c_int) * info%coshape_epp(dim)
       end do
    end associate

    call_assert(image_index .le. team%info%num_images)
    initial_team_index = caf_image_to_initial(team%info%gex_team, image_index)
    call_assert(initial_team_index .ge. 1 .and. initial_team_index .le. initial_team%num_images)
  end subroutine

  module procedure prif_initial_team_index
    call initial_index_helper(coarray_handle, sub, current_team, initial_team_index)

    if (present(stat)) stat = 0
  end procedure

  module procedure prif_initial_team_index_with_team
    call initial_index_helper(coarray_handle, sub, team, initial_team_index)

    if (present(stat)) stat = 0
  end procedure

  module procedure prif_initial_team_index_with_team_number
    if (team_number == -1) then
      call initial_index_helper(coarray_handle, sub, prif_team_type(initial_team), initial_team_index)
    else if (team_number == current_team%info%team_number) then
      call initial_index_helper(coarray_handle, sub, current_team, initial_team_index)
    else
      call unimplemented("prif_initial_team_index_with_team_number: no support for sibling teams")
    end if

    if (present(stat)) stat = 0
  end procedure

  !---------------------------------------------------------------------

  module procedure prif_local_data_pointer
    call_assert(coarray_handle_check(coarray_handle))

    local_data = coarray_handle%info%coarray_data
  end procedure

  module procedure prif_set_context_data
    type(c_ptr), pointer :: array_context_data
    call_assert(coarray_handle_check(coarray_handle))

    call c_f_pointer(coarray_handle%info%p_context_data, array_context_data)
    array_context_data = context_data
  end procedure

  module procedure prif_get_context_data
    type(c_ptr), pointer :: array_context_data
    call_assert(coarray_handle_check(coarray_handle))

    call c_f_pointer(coarray_handle%info%p_context_data, array_context_data)
    context_data = array_context_data
  end procedure

  module procedure prif_size_bytes
    call_assert(coarray_handle_check(coarray_handle))

    data_size = coarray_handle%info%coarray_size
  end procedure

end submodule coarray_queries_s

! Copyright (c), The Regents of the University of California
! Terms of use are as specified in LICENSE.txt

#include "assert_macros.h"

submodule(prif:prif_private_s)  co_broadcast_s
  ! DO NOT ADD USE STATEMENTS HERE
  ! All use statements belong in prif_private_s.F90
  implicit none

contains

  module procedure prif_co_broadcast
    call_assert(source_image >= 1 .and. source_image <= current_team%info%num_images)
    call contiguous_co_broadcast(a, source_image, stat, errmsg, errmsg_alloc)
  end procedure

  subroutine contiguous_co_broadcast(a, source_image, stat, errmsg, errmsg_alloc)
    type(*), intent(inout), target, contiguous :: a(..)
    integer(c_int), intent(in) :: source_image
    integer(c_int), intent(out), optional :: stat
    character(len=*), intent(inout), optional :: errmsg
    character(len=:), intent(inout), allocatable, optional :: errmsg_alloc

    if (present(stat)) stat=0
    call caf_co_broadcast(a, source_image, product(shape(a)), current_team%info%gex_team)
      ! With a compliant Fortran 2018 compiler, pass in c_sizeof(a) as the `Nelem` argument
      ! and eliminate the calculation of num_elements*sizeof(a) in caffeine.c.
  end subroutine

end submodule co_broadcast_s

module prif_co_broadcast_test_m
  use prif, only : prif_co_broadcast, prif_num_images, prif_this_image_no_coarray
  use julienne_m, only : &
     usher &
    ,test_description_t &
    ,test_diagnosis_t &
    ,test_result_t &
    ,test_t &
    ,operator(//) &
    ,operator(.expect.) &
    ,operator(.equalsExpected.)

  implicit none
  private
  public :: prif_co_broadcast_test_t

  type, extends(test_t) :: prif_co_broadcast_test_t
  contains
    procedure, nopass, non_overridable  :: subject
    procedure, nopass, non_overridable  :: results
  end type

  type object_t
    integer i
    logical fallacy
    character(len=len("fooey")) actor
    complex issues
  end type

  interface operator(==)
    module procedure equals
  end interface

contains

  pure function subject() result(test_subject)
    character(len=:), allocatable :: test_subject
    test_subject = "prif_co_broadcast"
  end function

  function results() result(test_results)
    type(test_result_t), allocatable :: test_results(:)
    type(prif_co_broadcast_test_t) prif_co_broadcast_test

    allocate(test_results, source = prif_co_broadcast_test%run([ &
       test_description_t("broadcasting a default integer scalar with no optional arguments present", usher(broadcast_default_integer_scalar)) &
      ,test_description_t("broadcasting a derived type scalar with no allocatable components", usher(broadcast_derived_type)) &
    ]))
  end function

  logical pure function equals(lhs, rhs) 
    type(object_t), intent(in) :: lhs, rhs 
    equals = all([ &
      lhs%i == rhs%i &
     ,lhs%fallacy .eqv. rhs%fallacy &
     ,lhs%actor == rhs%actor &
     ,lhs%issues == rhs%issues &
    ])
  end function

  function broadcast_default_integer_scalar() result(diag)
    type(test_diagnosis_t) :: diag
    integer iPhone, me
    integer, parameter :: source_value = 7779311, junk = -99

    call prif_this_image_no_coarray(this_image=me)
    iPhone = merge(source_value, junk, me==1)
    call prif_co_broadcast(iPhone, source_image=1)
    diag = iPhone .equalsExpected. source_value 
  end function

  function broadcast_derived_type() result(diag)
    type(test_diagnosis_t) :: diag
    type(object_t) object
    integer me, ni

    call prif_this_image_no_coarray(this_image=me)
    call prif_num_images(num_images=ni)
    object = object_t(me, .false., "gooey", me*(1.,0.))
    call prif_co_broadcast(object, source_image=ni)
    associate(expected_object => object_t(ni, .false., "gooey", ni*(1.,0.)))
      diag = .expect. (object == expected_object) // "co_broadcast derived type"
    end associate
  end function

end module prif_co_broadcast_test_m

module prif_stop_test_m
    use prif, only: prif_this_image_no_coarray, prif_sync_all
    use julienne_m, only: test_description_t, test_diagnosis_t, test_result_t, test_t, usher &
      ,operator(.equalsExpected.), operator(//)
    use unit_test_parameters_m, only : expected_stop_code, &
        image_one => subjob_setup, cmd_prefix => subjob_prefix, fpm_driver

    implicit none
    private
    public :: prif_stop_test_t

    type, extends(test_t) :: prif_stop_test_t
    contains
      procedure, nopass, non_overridable :: subject
      procedure, nopass, non_overridable :: results
    end type

   integer, parameter :: max_message_len = 128

contains
    pure function subject()
      character(len=:), allocatable :: subject
      subject = "prif_stop"
    end function

    function results() result(test_results)
      type(test_result_t), allocatable :: test_results(:)
      type(prif_stop_test_t) prif_stop_test

      allocate(test_results, source = prif_stop_test%run([ &
         test_description_t("delivering a zero exitstat when the stop code is omitted", usher(exit_with_no_stop_code)) &
        ,test_description_t("printing an integer stop code and delivering the non-zero exitstat", usher(exit_with_integer_stop_code)) &
        ,test_description_t("printing a character stop code and delivering a zero exitstat", usher(exit_with_character_stop_code)) &
        ,test_description_t("invoking a registered callback", usher(check_callback_invocation)) &
      ]))
    end function

    function exit_with_no_stop_code() result(diag)
        type(test_diagnosis_t) :: diag
        integer exit_status, cmd_stat
        character(len=max_message_len) command_message

      if (image_one()) then
        command_message = "exit_with_no_stop_code"

        call execute_command_line( &
          command = cmd_prefix//fpm_driver//" run --example stop_with_no_code > /dev/null 2>&1", &
          wait = .true., &
          exitstat = exit_status, &
          cmdstat = cmd_stat, &
          cmdmsg = command_message &
        )
        diag = (exit_status .equalsExpected. 0) // command_message
      else
        diag = .true.
      end if

    end function

    function exit_with_integer_stop_code() result(diag)
        type(test_diagnosis_t) :: diag
        integer exit_status, cmd_stat
        character(len=max_message_len) command_message

      if (image_one()) then
        command_message = "exit_with_integer_stop_code"

        call execute_command_line( &
          command = cmd_prefix//fpm_driver//" run --example stop_with_integer_code > /dev/null 2>&1", &
          wait = .true., &
          exitstat = exit_status, &
          cmdstat = cmd_stat, &
          cmdmsg = command_message &
        )
        diag = (exit_status .equalsExpected. expected_stop_code) // command_message
      else
        diag = .true.
      end if

    end function

    function exit_with_character_stop_code() result(diag)
        type(test_diagnosis_t) :: diag
        integer exit_status, cmd_stat
        character(len=max_message_len) command_message

      if (image_one()) then
        command_message = "exit_with_character_stop_code"

        call execute_command_line( &
          command = cmd_prefix//fpm_driver//" run --example stop_with_character_code > /dev/null 2>&1", &
          wait = .true., &
          exitstat = exit_status, &
          cmdstat = cmd_stat, &
          cmdmsg = command_message &
        )   
        ! the standard recommends zero exit status for character stop codes
        diag = (exit_status .equalsExpected. 0) // command_message
      else
        diag = .true.
      end if

    end function

    function check_callback_invocation() result(diag)
        type(test_diagnosis_t) :: diag
        integer exit_status, cmd_stat
        character(len=max_message_len) command_message

      if (image_one()) then
        call execute_command_line( &
          command = cmd_prefix//fpm_driver//" run --example register_stop_callback > /dev/null 2>&1", &
          wait = .true., &
          exitstat = exit_status, &
          cmdstat = cmd_stat, &
          cmdmsg = command_message &
        )
        diag = (exit_status .equalsExpected. 0) // command_message
      else
        diag = .true.
      end if
    end function

end module prif_stop_test_m

! Copyright (c) 2024-2025, The Regents of the University of California
! Terms of use are as specified in LICENSE.txt

program test_suite_driver
  use julienne_m
  use prif, only: prif_this_image_no_coarray, prif_num_images, prif_sync_all, prif_co_sum, prif_error_stop
  use iso_c_binding, only: c_int, c_bool
  use prif_init_test_m, only : prif_init_test_t, check_caffeination
  use prif_num_images_test_m, only : prif_num_images_test_t
  use prif_this_image_no_coarray_test_m, only : prif_this_image_no_coarray_test_t
  use prif_image_queries_test_m, only : prif_image_queries_test_t
  use prif_types_test_m, only : prif_types_test_t
  use prif_co_broadcast_test_m, only : prif_co_broadcast_test_t
  use prif_co_sum_test_m, only : prif_co_sum_test_t
  use prif_co_max_test_m, only : prif_co_max_test_t
  use prif_co_min_test_m, only : prif_co_min_test_t
  use prif_co_reduce_test_m, only :prif_co_reduce_test_t 
  use prif_sync_images_test_m, only : prif_sync_images_test_t
  use prif_image_index_test_m, only : prif_image_index_test_t
  use prif_allocate_test_m, only : prif_allocate_test_t
  use prif_coarray_inquiry_test_m, only :  prif_coarray_inquiry_test_t
  use prif_teams_test_m, only : prif_teams_test_t 
  use prif_rma_test_m, only : prif_rma_test_t   
  use prif_strided_test_m, only : prif_strided_test_t
  use prif_event_test_m, only : prif_event_test_t 
  use prif_image_queries_test_m, only : prif_image_queries_test_t
  use prif_atomic_test_m, only : prif_atomic_test_t
  use prif_error_stop_test_m, only : prif_error_stop_test_t
  use prif_stop_test_m, only : prif_stop_test_t  
  implicit none

  type(test_diagnosis_t) :: dummy
  dummy = check_caffeination() ! ensure an early call to prif_init

# if JULIENNE_PARALLEL_CALLBACKS
    julienne_this_image => julienne_callback_this_image
    julienne_num_images => julienne_callback_num_images
    julienne_sync_all => julienne_callback_sync_all
    julienne_co_sum_integer => julienne_callback_co_sum_integer
    julienne_error_stop => julienne_callback_error_stop
# endif

  associate(test_harness => test_harness_t([ &
    ! tests for basic functionality that are mostly self-contained
     test_fixture_t( prif_init_test_t() ) &
    ,test_fixture_t( prif_num_images_test_t() ) &
    ,test_fixture_t( prif_this_image_no_coarray_test_t() ) &
    ,test_fixture_t( prif_image_queries_test_t() ) &
    ,test_fixture_t( prif_types_test_t() ) &

    ! collectives tests
    ,test_fixture_t( prif_co_broadcast_test_t() ) &
    ,test_fixture_t( prif_co_sum_test_t() ) &
    ,test_fixture_t( prif_co_max_test_t() ) &
    ,test_fixture_t( prif_co_min_test_t() ) &
    ,test_fixture_t( prif_co_reduce_test_t() ) &

    ! tests that rely primarily upon coarrays
    ,test_fixture_t( prif_allocate_test_t() ) & ! should be first coarray test
    ,test_fixture_t( prif_coarray_inquiry_test_t() ) &
    ,test_fixture_t( prif_image_index_test_t() ) &
    ,test_fixture_t( prif_rma_test_t() ) &
    ,test_fixture_t( prif_strided_test_t() ) &

    ! synchronization and data race tests
    ,test_fixture_t( prif_event_test_t() ) &
    ,test_fixture_t( prif_atomic_test_t() ) &
    ,test_fixture_t( prif_sync_images_test_t() ) & ! internally uses coarrays and events

    ! complicated multi-feature tests
    ,test_fixture_t( prif_teams_test_t() ) &

    ! exit tests
    ,test_fixture_t( prif_error_stop_test_t() ) &
    ,test_fixture_t( prif_stop_test_t() ) &
  ]))
    call test_harness%report_results
  end associate

contains

  function julienne_callback_this_image() result(this_image_id)
    implicit none
    integer :: this_image_id
    integer(c_int) :: me

    call prif_this_image_no_coarray(this_image=me)

    this_image_id = int(me)
  end function

  function julienne_callback_num_images() result(image_count)
    implicit none
    integer :: image_count
    integer(c_int) :: ni

    call prif_num_images(ni)

    image_count = int(ni)
  end function

  subroutine julienne_callback_sync_all()
    implicit none
    
    call prif_sync_all()
  end subroutine

  subroutine julienne_callback_co_sum_integer(a, result_image)
    implicit none
    integer, intent(inout), target :: a(:)
    integer, intent(in), optional :: result_image
    
    call prif_co_sum(a, result_image)
  end subroutine

  subroutine julienne_callback_error_stop(stop_code_char)
    implicit none
    character(len=*), intent(in) :: stop_code_char
    
    call prif_error_stop(quiet=.false._c_bool, stop_code_char=stop_code_char)    
  end subroutine

end program test_suite_driver

! Copyright (c), The Regents of the University of California
! Terms of use are as specified in LICENSE.txt
submodule(prif:prif_private_s) program_termination_s
  ! DO NOT ADD USE STATEMENTS HERE
  ! All use statements belong in prif_private_s.F90
  implicit none

  type :: callback_entry
    procedure(prif_stop_callback_interface), pointer, nopass :: callback
    type(callback_entry), pointer :: next => null()
  end type

  type(callback_entry), pointer :: callback_list => null()

contains

  ! Do our best to portably flush anything that might be buffered in the Fortran I/O library
  subroutine flush_all()
    flush output_unit
    flush error_unit
  end subroutine

  module procedure prif_register_stop_callback
    type(callback_entry), pointer :: new_entry
    allocate(new_entry)
    new_entry%callback => callback
    if (associated(callback_list)) then
      new_entry%next => callback_list
    end if
    callback_list => new_entry
  end procedure

  module procedure prif_stop

    call flush_all()

    call prif_sync_all
    call run_callbacks(.false._c_bool, quiet, stop_code_int, stop_code_char)

    if (present(stop_code_char)) then
       call prif_stop_character(quiet, stop_code_char)
    else
       call prif_stop_integer(quiet, stop_code_int)
    end if

  contains
    subroutine prif_stop_integer(quiet, stop_code)
      !! synchronize, stop the executing image, and provide the stop_code, or 0 if not present, as the process exit status
      logical(c_bool), intent(in) :: quiet
      integer(c_int), intent(in), optional :: stop_code
      integer(c_int) :: exit_code

      if (present(stop_code)) then
        if (.not. quiet) then
          write(output_unit, '(A, I0)') "STOP ", stop_code
        end if
        exit_code = stop_code
      else
        if (.not. quiet) then
          write(output_unit, '(A)') "STOP"
        end if
        exit_code = 0_c_int
      end if

      call flush_all()

      call caf_decaffeinate(exit_code)

    end subroutine prif_stop_integer

    subroutine prif_stop_character(quiet, stop_code)
      !! synchronize, stop the executing image, and provide the stop_code as the process exit status
      logical(c_bool), intent(in) :: quiet
      character(len=*), intent(in) :: stop_code

      if (.not. quiet) then
        write(output_unit, '(A)') "STOP '" // stop_code // "'"
      end if

      call flush_all()

      call caf_decaffeinate(exit_code=0_c_int) ! does not return

    end subroutine prif_stop_character

  end procedure prif_stop

  module procedure prif_error_stop
      
    call flush_all()

    call run_callbacks(.true._c_bool, quiet, stop_code_int, stop_code_char)
    if (present(stop_code_char)) then
       call prif_error_stop_character(quiet, stop_code_char)
    else
       call prif_error_stop_integer(quiet, stop_code_int)
    end if
  end procedure prif_error_stop

  subroutine prif_error_stop_character(quiet, stop_code)
    !! stop all images and provide the stop_code as the process exit status
    logical(c_bool), intent(in) :: quiet
    character(len=*), intent(in) :: stop_code

    if (.not. quiet) then
      write(error_unit, '(A)') "ERROR STOP '" // stop_code // "'"
    end if

    call flush_all()

    call caf_decaffeinate(1_c_int) ! does not return
  end subroutine

  subroutine prif_error_stop_integer(quiet, stop_code)
    !! stop all images and provide the stop_code, or 1 if not present, as the process exit status
    logical(c_bool), intent(in) :: quiet
    integer(c_int), intent(in), optional :: stop_code
    integer(c_int) :: exit_code

    if (present(stop_code)) then
      if (.not.quiet) then
        write(error_unit,'(A, I0)') "ERROR STOP ", stop_code
      end if
      exit_code = stop_code
    else
      if (.not.quiet) then
        write(error_unit,'(A)') "ERROR STOP"
      end if
      exit_code = 1_c_int
    end if

    call flush_all()

    call caf_decaffeinate(exit_code) ! does not return
  end subroutine

  module procedure prif_fail_image
#   ifndef CAF_FAIL_IMAGE_SUPPRESS_FLUSH
      call flush_all()
#   endif

    call caf_fail_image()
  end procedure

  subroutine run_callbacks(is_error_stop, quiet, stop_code_int, stop_code_char)
    logical(c_bool), intent(in) :: is_error_stop, quiet
    integer(c_int), intent(in), optional :: stop_code_int
    character(len=*), intent(in), optional :: stop_code_char

    type(callback_entry), pointer :: next_entry

    next_entry => callback_list
    do while (associated(next_entry))
      call next_entry%callback(is_error_stop, quiet, stop_code_int, stop_code_char)
      next_entry => next_entry%next
    end do
  end subroutine

end submodule program_termination_s

! This multi-image Fortran program just exercises basic calls into each of the
! native multi-image features from the Fortran level.
! This test requires a compiler with multi-image features (possibly via Caffeine).
! This program is NOT designed to evaluate runtime correctness, just to exercise
! some basic calls to the features.

program native_multi_image

#if HAVE_MULTI_IMAGE
! feature control:
#ifndef HAVE_SYNC
#define HAVE_SYNC 1
#endif
#ifndef HAVE_SYNC_ALL
#define HAVE_SYNC_ALL HAVE_SYNC
#endif
#ifndef HAVE_SYNC_MEMORY
#define HAVE_SYNC_MEMORY HAVE_SYNC
#endif
#ifndef HAVE_SYNC_IMAGES
#define HAVE_SYNC_IMAGES HAVE_SYNC
#endif

#ifndef HAVE_COLLECTIVES
#define HAVE_COLLECTIVES 1
#endif
#ifndef HAVE_CO_SUM
#define HAVE_CO_SUM HAVE_COLLECTIVES
#endif
#ifndef HAVE_CO_MIN
#define HAVE_CO_MIN HAVE_COLLECTIVES
#endif
#ifndef HAVE_CO_MAX
#define HAVE_CO_MAX HAVE_COLLECTIVES
#endif
#ifndef HAVE_CO_BROADCAST
#define HAVE_CO_BROADCAST HAVE_COLLECTIVES
#endif

#ifndef HAVE_TEAM
#define HAVE_TEAM 1
#endif
#ifndef HAVE_TEAM_TYPE
#define HAVE_TEAM_TYPE HAVE_TEAM
#endif
#ifndef HAVE_EVENT_TYPE
#define HAVE_EVENT_TYPE 1
#endif
#ifndef HAVE_LOCK_TYPE
#define HAVE_LOCK_TYPE 1
#endif
#ifndef HAVE_NOTIFY_TYPE
#define HAVE_NOTIFY_TYPE 1
#endif
! TYPES_IMPORT_PRIF: compiler imports the real PRIF definition of ISO_FORTRAN_ENV types
#ifndef TYPES_IMPORT_PRIF
#define TYPES_IMPORT_PRIF 0
#endif

#ifndef HAVE_COARRAY
#define HAVE_COARRAY 0
#endif
#ifndef HAVE_MAIN_COARRAY
#define HAVE_MAIN_COARRAY HAVE_COARRAY
#endif
#ifndef HAVE_ALLOC_COARRAY
#define HAVE_ALLOC_COARRAY HAVE_COARRAY
#endif

! Helper macros
#define CHECK_TYPE_COMPLIANCE(subject_type, subject, is_team, min_size) \
  BLOCK ; \
    integer(c_int8_t), allocatable, target :: bytes(:) ; \
    bytes = transfer(subject, bytes) ; \
    call check_type(#subject_type, is_team, min_size, \
                    storage_size(subject)/8, bytes); \
  END BLOCK

! Main program
  USE, INTRINSIC :: ISO_FORTRAN_ENV
  USE, INTRINSIC :: ISO_C_BINDING, only: c_int8_t

  type :: dummy_team_descriptor
  end type
  type :: dummy_team_type
    type(dummy_team_descriptor), pointer :: info => null()
  end type

  integer :: me, ni, peer, tmp, fail_count = 0
  character(len=5) :: c
# if HAVE_TEAM
  integer :: team_id
  type(TEAM_TYPE) :: subteam, res
  type(TEAM_TYPE) :: default_team
# endif
# if HAVE_MAIN_COARRAY
  integer :: sca_int_1[*]
  integer :: sca_int_2[2,*]
  integer :: sca_int_3[2,3,*]
# endif
# if HAVE_EVENT_TYPE
      type(event_type), target :: default_event[*]
# endif
# if HAVE_NOTIFY_TYPE
      type(notify_type), target :: default_notify[*]
# endif
# if HAVE_LOCK_TYPE
      type(lock_type), target :: default_lock[*]
# endif

  me = THIS_IMAGE()
  ni = NUM_IMAGES()
  peer = MIN(IEOR(me-1,1)+1, ni)

  write(*,'(A,I1,A,I1,A)') "Hello, world! From image ", me, " of ", ni, " images"

# if SET_EXCEPTIONS
    block 
       ! deliberately trigger IEEE arithmetic exceptions: INEXACT and UNDERFLOW
       real :: r
       r = 1e-30
       r = r + r * r
      write (*,*) r
    end block
# endif

# if HAVE_SYNC_ALL
    call status("Testing SYNC ALL...")
    call sync_all
# endif

# if HAVE_SYNC_MEMORY
    call status("Testing SYNC MEMORY...")
    SYNC MEMORY
# endif

# if HAVE_SYNC_IMAGES
    call status("Testing SYNC IMAGES...")
    SYNC IMAGES(*)
    SYNC IMAGES(peer)
    SYNC IMAGES([peer])
    if (me /= peer) SYNC IMAGES([me, peer])
#endif

  tmp = me
  c = "hello"
# if HAVE_CO_SUM
    call status("Testing CO_SUM...")
    call CO_SUM(tmp)
    call CO_SUM(tmp,1)
# endif
# if HAVE_CO_MIN
    call status("Testing CO_MIN...")
    call CO_MIN(tmp)
    call CO_MIN(tmp,1)
    call CO_MIN(c)
    call CO_MIN(c,1)
# endif
# if HAVE_CO_MAX
    call status("Testing CO_MAX...")
    call CO_MAX(tmp)
    call CO_MAX(tmp,1)
    call CO_MAX(c)
    call CO_MAX(c,1)
# endif
# if HAVE_CO_BROADCAST
    call status("Testing CO_BROADCAST...")
    call CO_BROADCAST(tmp,1)
    call CO_BROADCAST(c,1)
# endif

# if HAVE_TEAM
#   if HAVE_TEAM_TYPE
      CHECK_TYPE_COMPLIANCE(TEAM_TYPE, default_team, .true., 0)
#   endif
  call status("Testing TEAMS...")
  res = GET_TEAM(CURRENT_TEAM)
  res = GET_TEAM(INITIAL_TEAM)
  res = GET_TEAM()
  write(*,'(A,I3)') "Initial team number is ", TEAM_NUMBER()

    team_id = merge(1, 2, me <= (ni+1)/2)

  FORM TEAM(team_id, subteam)
  SYNC TEAM(subteam)
  CHANGE TEAM(subteam)
    write(*,'(A,I3,A,I3,A,I3)') 'Inside CHANGE TEAM construct: ', THIS_IMAGE(), ' of ', NUM_IMAGES(), ' in team number ', TEAM_NUMBER()
  END TEAM
  call sync_all
  write(*,'(A,I3)') "After END TEAM statement, TEAM_NUMBER() is ", TEAM_NUMBER()
# endif

# if HAVE_EVENT_TYPE
  CHECK_TYPE_COMPLIANCE(EVENT_TYPE, default_event, .false., 64)
# endif

# if HAVE_LOCK_TYPE
  CHECK_TYPE_COMPLIANCE(LOCK_TYPE, default_lock, .false., 64)
# endif

# if HAVE_NOTIFY_TYPE
  CHECK_TYPE_COMPLIANCE(NOTIFY_TYPE, default_notify, .false., 64)
# endif

  call sync_all
  call test_allocatable_coarray
  call test_allocatable_coarray

  call sync_all
  write(*,'(A,I1,A,I1,A)') "Goodbye from image ", me, " of ", ni, " images"

  ! explicit flush for now until we have multi-image stop support
  call flush_all
  call sync_all
  if (fail_count > 0) then
    call status("ERROR: "//tostring(fail_count)//" tests FAILED.")
  else
    call status("All tests passed.")
  end if
#if IGNORE_FAILURES
  call status("WARNING: Ignoring "//tostring(IGNORE_FAILURES)//" failures.")
  fail_count = MAX(0, fail_count - IGNORE_FAILURES)
#endif
  stop fail_count

  contains
    subroutine sync_all
#   if HAVE_SYNC_ALL
      SYNC ALL
#   endif
    end subroutine
    subroutine flush_all
      flush output_unit
      flush error_unit
    end subroutine
    subroutine status(str)
      character(len=*) :: str
      call flush_all
      call sync_all
      if (THIS_IMAGE() == 1) write(*,'(A)') str
      call flush_all
      call sync_all
    end subroutine

    subroutine test_allocatable_coarray()
#   if HAVE_ALLOC_COARRAY
#   define CHECK_ALLOC(coarray, expect) \
      if (ALLOCATED(coarray) .neqv. expect) then ; \
        if (THIS_IMAGE() == 1) write(*,'(A)') __FILE__//":"//tostring(__LINE__)//": ERROR: " // \
           " ALLOCATED(" // #coarray // ") = " // MERGE("true ","false",ALLOCATED(coarray)) ; \
        fail_count = fail_count + 1 ; \
      end if

      logical, save :: once = .true.
      integer, allocatable :: aca_int_1[:]
      integer, allocatable :: aca_int_2[:,:]
      integer, save, allocatable :: aca_int_3[:,:,:]
      CHECK_ALLOC(aca_int_1, .false.)
      CHECK_ALLOC(aca_int_2, .false.)
      CHECK_ALLOC(aca_int_3, .false.)
      if (once) then
        once = .false.
        call status("Testing ALLOCATABLE coarrays...")
        ALLOCATE(aca_int_1[*])
        ALLOCATE(aca_int_2[2,*])
        ALLOCATE(aca_int_3[2,3,*])
        CHECK_ALLOC(aca_int_1, .true.)
        CHECK_ALLOC(aca_int_2, .true.)
        CHECK_ALLOC(aca_int_3, .true.)
      end if
#   endif
    end subroutine

    function tostring(int) result(res)
      integer :: int
      character(len=128) :: str
      character(len=:), allocatable :: res
      write(str, *) int
      res = trim(adjustl(str))
    end function

    function hexdump(arr) result(res)
      integer(c_int8_t), intent(in) :: arr(:)
      character(len=:), allocatable :: res
      character(len=4096) :: buf
      write(buf, '(*(Z2, 1X))') arr
      res = trim(buf)
    end function

    subroutine check_type(type_name, is_team, min_size, subject_size, default_bytes)
      character(len=*), intent(in) :: type_name
      logical, intent(in) :: is_team
      integer, intent(in) :: min_size, subject_size
      integer(c_int8_t), target, intent(in) :: default_bytes(:)
      character(len=:), allocatable :: diag
#   if HAVE_TEAM
      type(TEAM_TYPE) :: team_var
      type(dummy_team_type) :: dummy_team_type_var
      integer, parameter :: reference_size = storage_size(dummy_team_type_var)/8
#   endif

      call status("Testing " // type_name // "...")

      if (subject_size /= size(default_bytes)) ERROR STOP "INTERNAL ERROR: representation size mismatch"

      if (is_team) then
#     if HAVE_TEAM
        ! check size, should be an exact match
        if (subject_size == reference_size) then
          diag = "pass"
        else
          diag = "FAIL (should be exactly " // tostring(reference_size) // " bytes)"
          fail_count = fail_count + 1
        end if
        call status("  Size of " // type_name // ": " // tostring(subject_size) // " bytes ==> " // diag)

        ! check default initialization
        dummy_team_type_var = transfer(team_var, dummy_team_type_var)
        if (.not. associated(dummy_team_type_var%info)) then
          diag = "pass"
        else
          diag = "FAIL (not default-initialized to null(): " // hexdump(default_bytes)// ")"
          fail_count = fail_count + 1
        end if
        call status("  Default init of " // type_name // " ==> " // diag)
#     endif
      else
#     if TYPES_IMPORT_PRIF
        diag = "(validation skipped)"
#     else
        ! check size, should not be less than min_size
        if (subject_size >= min_size) then
          diag = "pass"
        else
          diag = "FAIL (should be >= " // tostring(min_size) // " bytes)"
          fail_count = fail_count + 1
        end if
#     endif
        call status("  Size of " // type_name // ": " // tostring(subject_size) // " bytes ==> " // diag)

        ! check default initialization
        if (all(default_bytes == 0)) then
          diag = "pass"
        else
          diag = "FAIL (non-zero value at byte " // tostring((findloc(default_bytes /= 0, .true., dim=1))) // ": " // &
                 hexdump(default_bytes) // ")"
          fail_count = fail_count + 1
        end if
        call status("  Default init of " // type_name // " ==> " // diag)
      end if
    end subroutine

#else
  stop "Native multi-image test disabled"
#endif
end program

! This header provides use declarations needed for tests using prif_(de)allocate(_coarray),
! and hides the interface differences between PRIF spec revisions.
! It must be #included within a use block.

#ifndef CAF_INCLUDED_TEST_USES_ALLOC
#define CAF_INCLUDED_TEST_USES_ALLOC

#include "language-support.F90"

use prif, only : &
    prif_allocate_coarray, &
    prif_allocate, prif_deallocate, &
    prif_coarray_handle

#if !defined(CAF_PRIF_VERSION) || CAF_PRIF_VERSION >= 7
  ! PRIF 0.7+ deallocate
  use prif, only : prif_deallocate_coarray, prif_deallocate_coarrays
# define prif_deallocate_coarray3  prif_deallocate_coarray
# define prif_deallocate_coarrays3 prif_deallocate_coarrays
#else
  ! emulate PRIF 0.7 deallocate with older interfaces
  use prif, only : prif_deallocate_coarray_ => prif_deallocate_coarray
# define prif_deallocate_coarray(h)           prif_deallocate_coarray_([h])
# define prif_deallocate_coarrays(arr)        prif_deallocate_coarray_(arr)
# define prif_deallocate_coarray3(h,a2,a3)    prif_deallocate_coarray_([h],a2,a3)
# define prif_deallocate_coarrays3(arr,a2,a3) prif_deallocate_coarray_(arr,a2,a3)
#endif

  use iso_c_binding, only: &
      c_ptr, c_int, c_int64_t, c_size_t, c_intptr_t, &
      c_null_funptr, c_null_ptr, &
      c_associated, c_f_pointer, c_funloc, c_loc, c_sizeof

#endif

! Copyright (c), The Regents of the University of California
! Terms of use are as specified in LICENSE.txt
submodule(prif:prif_private_s) critical_s
  ! DO NOT ADD USE STATEMENTS HERE
  ! All use statements belong in prif_private_s.F90
  implicit none

contains

  module procedure prif_critical
    call unimplemented("prif_critical")
    
    if (present(stat)) stat = 0
  end procedure

  module procedure prif_end_critical
    call unimplemented("prif_end_critical")
  end procedure

end submodule critical_s

#include "test-utils.F90"
#include "language-support.F90"

module prif_allocate_test_m
# include "test-uses-alloc.F90"
  use prif, only : &
      prif_num_images, prif_size_bytes, &
      prif_set_context_data, prif_get_context_data, prif_local_data_pointer, &
      prif_alias_create, prif_alias_destroy, prif_this_image_no_coarray, &
      PRIF_STAT_OUT_OF_MEMORY

  use julienne_m, only: test_description_t, test_diagnosis_t, test_result_t, test_t, string_t, usher &
    ,operator(.all.), operator(.also.), operator(.equalsExpected.), operator(.isAtLeast.), operator(//)

  implicit none
  private
  public :: prif_allocate_test_t

  type, extends(test_t) :: prif_allocate_test_t
  contains
    procedure, nopass, non_overridable :: subject
    procedure, nopass, non_overridable :: results
  end type

#if HAVE_FINAL_FUNC_SUPPORT
  ! Global state used to coordinate with finalizers
  integer :: ff_count
  type(prif_coarray_handle) :: ff_handle
  type(test_diagnosis_t) :: ff_diag
  logical :: ff_force_fail = .false.
  character(len=*), parameter :: ff_err = "test error message"
#endif

contains

  pure function subject()
    character(len=:), allocatable :: subject
    subject = "PRIF Allocation"
  end function

  function results() result(test_results)
    type(test_result_t), allocatable :: test_results(:)
    type(prif_allocate_test_t) prif_allocate_test

    allocate(test_results, source = prif_allocate_test%run([ &
       test_description_t("allocating, using and deallocating an integer scalar coarray with a corank of 1", &
         usher(check_allocate_integer_scalar_coarray_with_corank1)) &
      ,test_description_t("allocating, using and deallocating an integer array coarray with a corank of 2", &
         usher(check_allocate_integer_array_coarray_with_corank2)) &
      ,test_description_t("allocating, using and deallocating memory non-symmetrically", &
         usher(check_allocate_non_symmetric)) &
      ,test_description_t("allocating and deallocating coarrays with finalizers" &
#      if HAVE_FINAL_FUNC_SUPPORT
         , usher(check_final_func) &
#      endif
       ) &
      ,test_description_t("reporting out-of-memory errors", &
         usher(check_allocation_oom)) &
    ]))
  end function

  function check_allocate_integer_scalar_coarray_with_corank1() result(diag)
    type(test_diagnosis_t) diag

    ! Allocate memory for an integer scalar single corank coarray, such as the following decl
    ! integer :: coarr[*]

    integer :: dummy_element
    type(prif_coarray_handle) :: coarray_handle
    type(c_ptr) :: allocated_memory
    integer, pointer :: local_slice
    integer(c_size_t) :: data_size, query_size

    diag = .true.

    allocated_memory = c_null_ptr
    local_slice => null()
    ALSO(.not. associated(local_slice))

    data_size = storage_size(dummy_element)/8
    call prif_allocate_coarray( &
      [integer(c_int64_t) :: 1], [integer(c_int64_t) :: ], data_size, c_null_funptr, &
      coarray_handle, allocated_memory)

    call c_f_pointer(allocated_memory, local_slice)
    ALSO(associated(local_slice))

    local_slice = 42
    ALSO(local_slice .equalsExpected. 42)

    call prif_size_bytes(coarray_handle, data_size=query_size)
    ALSO2(query_size .equalsExpected. data_size, "invalid prif_size_bytes")

    block ! Check prif_{set,get}_context_data
      integer, target :: dummy(10), i
      type(c_ptr) :: expect, actual
      do i = 1,10 
        expect = c_loc(dummy(i))
        actual = c_null_ptr
        call prif_set_context_data(coarray_handle, expect)
        call prif_get_context_data(coarray_handle, actual)
        ALSO2(actual .equalsExpected. expect, "prif_{set,get}_context_data are not working")
      end do
    end block

    call prif_deallocate_coarray(coarray_handle)

  end function

#if HAVE_FINAL_FUNC_SUPPORT
  function check_final_func() result(retdiag)
    type(test_diagnosis_t) retdiag

    ! this function shares several global vars with finalizers, see ff_* above
    ! globalize diag for ALSO:
#   define diag ff_diag

    integer :: num_imgs, me, dummy_element
    type(c_ptr) :: allocated_memory
    integer, pointer :: local_slice
    integer(c_size_t) :: data_size, query_size
    integer(c_int) :: stat
    character(len=len(ff_err)) :: errmsg
    character(len=:), allocatable :: errmsg_alloc

    diag = .true.

    call prif_num_images(num_images=num_imgs)
    call prif_this_image_no_coarray(this_image=me)
    data_size = storage_size(dummy_element)/8

    ! simple final_func case
    ff_count = 0
    call prif_allocate_coarray( &
      [integer(c_int64_t) :: 1], [integer(c_int64_t) :: ], &
      data_size, c_funloc(coarray_cleanup_simple), &
      ff_handle, allocated_memory)
    ALSO(ff_count .equalsExpected. 0)

    call prif_deallocate_coarray(ff_handle)
    ALSO(ff_count .equalsExpected. 1)
    
    ! final_func that errors on first three deallocations
    ff_count = 0
    call prif_allocate_coarray( &
      [integer(c_int64_t) :: 1], [integer(c_int64_t) :: ], &
      data_size, c_funloc(coarray_cleanup_first_error), &
      ff_handle, allocated_memory)
    ALSO(ff_count .equalsExpected. 0)

    call prif_deallocate_coarray3(ff_handle, stat, errmsg=errmsg)
    ALSO(ff_count .equalsExpected. 1)
    ALSO(stat .equalsExpected. 10)
    ALSO(errmsg .equalsExpected. ff_err)
    
    call prif_deallocate_coarrays3([ff_handle], stat, errmsg_alloc=errmsg_alloc)
    ALSO(ff_count .equalsExpected. 2)
    ALSO(stat .equalsExpected. 20)
    ALSO(errmsg_alloc .equalsExpected. ff_err)
    deallocate(errmsg_alloc)
   
    if (me == num_imgs) then ! test non-single-valued failure
      ff_force_fail = .true.
    end if 
    call prif_deallocate_coarray3(ff_handle, stat, errmsg_alloc=errmsg_alloc)
    ALSO(ff_count .equalsExpected. 3)
    ALSO(stat .equalsExpected. 30)
    ALSO(errmsg_alloc .equalsExpected. ff_err)
    deallocate(errmsg_alloc)
    ff_force_fail = .false.
    
    call prif_deallocate_coarray3(ff_handle, stat, errmsg_alloc=errmsg_alloc)
    ALSO(ff_count .equalsExpected. 4)
    ALSO(stat .equalsExpected. 0)
    ALSO(.not. allocated(errmsg_alloc))

    retdiag = diag
  end function

  subroutine coarray_cleanup_simple(handle , stat, errmsg) bind(C)
    type(prif_coarray_handle), pointer , intent(in) :: handle
    integer(c_int), intent(out) :: stat
    character(len=:), intent(out), allocatable :: errmsg

    ALSO(assert_aliased(handle, ff_handle, 0))

    ff_count = ff_count + 1
    stat = 0
  end subroutine

  subroutine coarray_cleanup_first_error(handle , stat, errmsg) bind(C)
    type(prif_coarray_handle), pointer , intent(in) :: handle
    integer(c_int), intent(out) :: stat
    character(len=:), intent(out), allocatable :: errmsg

    ALSO(assert_aliased(handle, ff_handle, 0))

    ff_count = ff_count + 1
    errmsg = ff_err
    if (ff_count <= 2 .or. ff_force_fail) then
      stat = 10 * ff_count
    else
      stat = 0
    end if
  end subroutine
# undef diag
#endif

  function check_allocate_non_symmetric() result(diag)
    type(test_diagnosis_t) diag 

    type(c_ptr) :: allocated_memory
    integer(c_int), pointer :: local_slice

    call prif_allocate(sizeof(local_slice), allocated_memory)
    call c_f_pointer(allocated_memory, local_slice)

    local_slice = 42
    diag = local_slice .equalsExpected. 42

    call prif_deallocate(c_loc(local_slice))
  end function

  ! returns (p + off)
  pure function c_ptr_add(p, off)
    type(c_ptr), intent(in) :: p
    integer(c_size_t), intent(in) :: off
    type(c_ptr) :: c_ptr_add
    integer(c_intptr_t) :: tmp
      
    tmp = transfer(p, tmp)
    tmp = tmp + off
    c_ptr_add = transfer(tmp, c_ptr_add)
  end function

  function assert_aliased(h1, h2, offset) result(diag)
    type(test_diagnosis_t) :: diag
    type(prif_coarray_handle) :: h1, h2
    integer(c_size_t), optional :: offset
    integer(c_size_t) :: offset_
    type(c_ptr) :: p1, p2
    integer(c_size_t) :: s1, s2
    type(c_ptr) :: c1, c2, cx
    integer, save, target :: dummy(10)
    integer, save :: di = 1

    diag = .true.

    if (present(offset)) then
      offset_ = offset
    else
      offset_ = 0
    endif

    call prif_local_data_pointer(h1, p1)
    call prif_local_data_pointer(h2, p2)
    ALSO(p2 .equalsExpected. c_ptr_add(p1, offset_))

    ! As of PRIF 0.6. prif_size_bytes is unspecified for aliases, 
    ! so this particular check is specific to the current Caffeine implementation
    call prif_size_bytes(h1, s1)
    call prif_size_bytes(h2, s2)
    ALSO(s2 .equalsExpected. s1)
      
    cx = c_loc(dummy(di))
    di = mod(di,size(dummy)) + 1

    call prif_set_context_data(h1, cx)
    call prif_get_context_data(h1, c1)
    ALSO(c1 .equalsExpected. cx)

    call prif_get_context_data(h2, c2)
    ALSO(c2 .equalsExpected. cx)
      
    call prif_set_context_data(h2, c_null_ptr)
    call prif_get_context_data(h1, c1)
    ALSO(.not. c_associated(c1))

  end function

  function check_allocate_integer_array_coarray_with_corank2() result(diag)
    type(test_diagnosis_t) :: diag

    ! Allocate memory for an integer scalar single corank coarray, such as the following decl
    ! integer :: coarr(10)[4,*]

    integer :: dummy_element, num_imgs, i
    type(prif_coarray_handle) :: coarray_handle
    type(c_ptr) :: allocated_memory
    integer, pointer :: local_slice(:)
    integer(c_size_t) :: data_size, query_size

    diag = .true.

    call prif_num_images(num_images=num_imgs)

    allocated_memory = c_null_ptr
    local_slice => null()
    ALSO(.not.associated(local_slice))

    data_size = 10*storage_size(dummy_element)/8
    call prif_allocate_coarray( &
      [integer(c_int64_t) :: 1,1], [integer(c_int64_t) :: 4], data_size, c_null_funptr, &
      coarray_handle, allocated_memory)

    call prif_size_bytes(coarray_handle, data_size=query_size)
    ALSO2(query_size .equalsExpected. data_size, "invalid prif_size_bytes")

    call c_f_pointer(allocated_memory, local_slice, [10])
    ALSO(associated(local_slice))

    local_slice = [(i*i, i = 1, 10)]
    ALSO(.all. (local_slice .equalsExpected. [(i*i, i = 1, 10)]))


    block ! Check prif_{set,get}_context_data
      integer, target :: dummy(10), i
      type(c_ptr) :: expect, actual
      do i = 1,10 
        expect = c_loc(dummy(i))
        actual = c_null_ptr
        call prif_set_context_data(coarray_handle, expect)
        call prif_get_context_data(coarray_handle, actual)
        ALSO2(actual .equalsExpected. expect, "prif_{set,get}_context_data not working")
      end do
    end block

    block ! check aliasing creation
#   if CAF_PRIF_VERSION <= 5
#     define data_pointer_offset
#   else
#     define data_pointer_offset 0_c_size_t,
#   endif
      integer i, j
      integer, parameter :: lim = 10
      type(prif_coarray_handle) :: a(lim)
      a(1) = coarray_handle
      do i=2, lim
        call prif_alias_create(a(i-1), [integer(c_int64_t) :: i-5], [integer(c_int64_t) :: i-5 + num_imgs], &
                               data_pointer_offset a(i))
        ALSO(assert_aliased(a(i-1), a(i)))
        do j = i+1,lim
          call prif_alias_create(a(i), [integer(c_int64_t) :: i, j-5], [integer(c_int64_t) :: j], &
                                 data_pointer_offset a(j))
          ALSO(assert_aliased(a(i), a(j)))
          ALSO(assert_aliased(a(j), coarray_handle))
        end do
#       if CAF_PRIF_VERSION >= 6
          ! test PRIF 0.6 data_pointer_offset
          block
            type(prif_coarray_handle) :: b
            integer(c_size_t) :: off
            off = i
            call prif_alias_create(a(i), [integer(c_int64_t) :: i], [integer(c_int64_t) :: ], &
                                   off, b)
            ALSO(assert_aliased(a(i), b, off))
            call prif_alias_destroy(b)
          end block
#       endif
        do j = i+1,lim
          call prif_alias_destroy(a(j))
        end do
      end do
      do i=2, lim
        call prif_alias_destroy(a(i))
      end do
    end block

    call prif_deallocate_coarray(coarray_handle)

  end function

  function check_allocation_oom() result(diag)
    type(test_diagnosis_t) diag 

    integer(c_size_t) :: size_in_bytes
    type(c_ptr) :: allocated_memory
    integer(c_int) :: stat
    character(len=:), allocatable :: errmsg
    type(prif_coarray_handle) :: coarray_handle

    diag = .true.

    size_in_bytes = ishft(500_c_size_t, 40) ! 500TB

    call prif_allocate(size_in_bytes, allocated_memory, stat, errmsg_alloc=errmsg)
    ALSO(stat .equalsExpected. PRIF_STAT_OUT_OF_MEMORY)
    ALSO(allocated(errmsg))
    if (allocated(errmsg)) then
      ALSO(len(errmsg) > 1)
      ALSO(index(errmsg, 'out of memory') .isAtLeast. 1)
    end if
    deallocate(errmsg)

    call prif_allocate_coarray( &
      [integer(c_int64_t) :: 1], [integer(c_int64_t) :: ], size_in_bytes, c_null_funptr, &
      coarray_handle, allocated_memory, stat, errmsg_alloc=errmsg)
    ALSO(stat .equalsExpected. PRIF_STAT_OUT_OF_MEMORY)
    ALSO(allocated(errmsg))
    if (allocated(errmsg)) then
      ALSO(len(errmsg) > 1)
      ALSO(index(errmsg, 'out of memory') .isAtLeast. 1)
    end if
    deallocate(errmsg)

  end function

end module prif_allocate_test_m

! Copyright (c), The Regents of the University of California
! Terms of use are as specified in LICENSE.txt

#include "assert_macros.h"
#include "version.h"

submodule(prif:prif_private_s) alias_s
  ! DO NOT ADD USE STATEMENTS HERE
  ! All use statements belong in prif_private_s.F90
  implicit none

contains

  module procedure prif_alias_create
    integer(c_int) :: corank
    type(prif_coarray_descriptor), pointer :: cdp
    type(prif_coarray_descriptor), pointer :: alias_cdp

    ! validate inputs
    call_assert(coarray_handle_check(source_handle))
    corank = size(alias_lcobounds)
    call_assert(corank > 0)
    call_assert(corank <= 15)
    if (size(alias_ucobounds) == corank) then
      call_assert(all(alias_lcobounds <= alias_ucobounds))
      call_assert(product(alias_ucobounds - alias_lcobounds + 1) >= current_team%info%num_images)
    else
      call_assert(size(alias_ucobounds) == corank - 1)
      call_assert(all(alias_lcobounds(1:corank-1) <= alias_ucobounds))
    end if

    cdp => handle_to_cdp(source_handle)
    ! start with a copy of the source descriptor
    allocate(alias_cdp, source=cdp)

#   if CAF_PRIF_VERSION >= 6
       alias_cdp%coarray_data = &
         as_c_ptr(as_int(alias_cdp%coarray_data) + data_pointer_offset)
#   endif

    ! apply provided cobounds
    alias_cdp%corank = corank
    alias_cdp%lcobounds(1:corank) = alias_lcobounds
    alias_cdp%ucobounds(1:corank-1) = alias_ucobounds(1:corank-1)
    call compute_coshape_epp(alias_lcobounds, alias_ucobounds, &
                             alias_cdp%coshape_epp(1:corank))
#   if ASSERTIONS
      ! The following entries are dead, but initialize them to help detect defects
      alias_cdp%lcobounds(corank+1:15) = huge(0_c_int64_t)
      alias_cdp%ucobounds(corank:14) = -huge(0_c_int64_t)
      alias_cdp%coshape_epp(corank+1:15) = 0
#   endif

    ! reset some fields that are unused in aliases
    alias_cdp%reserved = c_null_ptr 
    alias_cdp%previous_handle = c_null_ptr
    alias_cdp%next_handle = c_null_ptr
    alias_cdp%final_proc = c_null_funptr

    alias_handle = cdp_to_handle(alias_cdp)
    call_assert(coarray_handle_check(alias_handle))
  end procedure

  module procedure prif_alias_destroy
    type(prif_coarray_descriptor), pointer :: cdp 

    call_assert(coarray_handle_check(alias_handle))

    cdp => handle_to_cdp(alias_handle)
    call_assert(.not. c_associated(cdp%reserved))
    call_assert(.not. c_associated(cdp%previous_handle))
    call_assert(.not. c_associated(cdp%next_handle))
    call_assert(.not. c_associated(cdp%final_proc))

    deallocate(cdp)
  end procedure

end submodule alias_s

program fail_image
  use iso_c_binding, only: c_bool, c_int
  use prif, only : &
     prif_init &
    ,prif_num_images &
    ,prif_error_stop &
    ,prif_fail_image
  implicit none

  integer init_exit_code
  integer(c_int) :: ni
  logical(kind=c_bool), parameter :: false = .false._c_bool

  call prif_init(init_exit_code)
  call prif_num_images(ni)
  if (ni > 1) PRINT *, "WARNING: This support test is only intended to be run with a single image"
  call prif_fail_image()
  call prif_error_stop(quiet=false) ! test fails if this line runs
end program 

! Copyright (c), The Regents of the University of California
! Terms of use are as specified in LICENSE.txt

#include "assert_macros.h"

submodule(prif) prif_private_s
  use assert_m

  use iso_fortran_env, only : &
        output_unit, &
        error_unit

  use iso_c_binding, only: &
        c_associated, &
        c_f_pointer, &
        c_f_procpointer, &
        c_funloc, &
        c_int32_t, &
        c_loc, &
        c_null_funptr, &
        c_sizeof, &
        ! DOB: The following is a gfortran-14 bug workaround. No idea why this works...
        c_funptr_ => c_funptr

  implicit none

  type(prif_team_descriptor), target :: initial_team
  type(prif_team_type) :: current_team
  integer(c_intptr_t) :: total_heap_size, non_symmetric_heap_size

  interface

    ! ________ Program initiation and finalization ___________

    subroutine caf_caffeinate( &
        total_heap_size, &
        symmetric_heap, &
        symmetric_heap_start, &
        symmetric_heap_size, &
        initial_team) &
        bind(C)
      import c_ptr, c_intptr_t
      implicit none
      integer(c_intptr_t), intent(out) :: total_heap_size, symmetric_heap_start, symmetric_heap_size
      type(c_ptr), intent(out) :: symmetric_heap
      type(c_ptr), intent(out) :: initial_team
    end subroutine

    subroutine caf_acquire_exit_lock() bind(C)
      !! void caf_acquire_exit_lock()
    end subroutine

    subroutine caf_decaffeinate(exit_code) bind(C)
      !! void caf_decaffeinate(int exit_code)
      import c_int
      implicit none
      integer(c_int), value :: exit_code
    end subroutine

    subroutine caf_fail_image() bind(C)
      !! void caf_fail_image();
      implicit none
    end subroutine

    pure subroutine caf_fatal_error(str) bind(C)
      !! void caf_fatal_error( const CFI_cdesc_t* Fstr )
      import c_char
      implicit none
      character(kind=c_char,len=:), pointer, intent(in) :: str
    end subroutine
    ! _________________ Image enumeration ____________________

    function caf_this_image(gex_team) bind(C)
      !! int caf_this_image(gex_TM_t gex_team);
      import c_ptr, c_int
      implicit none
      type(c_ptr), value :: gex_team
      integer(c_int) caf_this_image
    end function

    pure function caf_num_images(gex_team) bind(C)
      !! int caf_num_images(gex_TM_t gex_team);
      import c_ptr, c_int
      implicit none
      type(c_ptr), value :: gex_team
      integer(c_int) caf_num_images
    end function

    function caf_image_to_initial(gex_team, image_num) bind(C)
      !! int caf_image_to_initial(gex_TM_t tm, int image_num)
      import c_ptr, c_int
      implicit none
      type(c_ptr), value :: gex_team
      integer(c_int), value :: image_num
      integer(c_int) caf_image_to_initial
    end function

    function caf_image_from_initial(gex_team, image_num) bind(C)
      !! int caf_image_from_initial(gex_TM_t tm, int image_num)
      import c_ptr, c_int
      implicit none
      type(c_ptr), value :: gex_team
      integer(c_int), value :: image_num
      integer(c_int) caf_image_from_initial
    end function

    ! _________________ Memory allocation ____________________

    function caf_allocate(mspace, bytes) result(ptr) bind(c)
       import c_size_t, c_ptr
       implicit none
       type(c_ptr), intent(in), value :: mspace
       integer(c_size_t), intent(in), value :: bytes
       type(c_ptr) :: ptr
    end function

    function caf_allocate_non_symmetric(bytes) result(ptr) bind(c)
       import c_size_t, c_ptr
       implicit none
       integer(c_size_t), intent(in), value :: bytes
       type(c_ptr) :: ptr
    end function

    subroutine caf_allocate_remaining(mspace, allocated_space, allocated_size) bind(c)
      import c_size_t, c_ptr
      implicit none
      type(c_ptr), intent(in), value :: mspace
      type(c_ptr), intent(out) :: allocated_space
      integer(c_size_t), intent(out) :: allocated_size
    end subroutine

    subroutine caf_deallocate(mspace, mem) bind(c)
      import c_ptr
      implicit none
      type(c_ptr), intent(in), value :: mspace
      type(c_ptr), intent(in), value :: mem
    end subroutine

    subroutine caf_deallocate_non_symmetric(mem) bind(c)
      import c_ptr
      implicit none
      type(c_ptr), intent(in), value :: mem
    end subroutine

    subroutine caf_establish_mspace(mspace, mem, mem_size) bind(c)
      import c_size_t, c_ptr
      implicit none
      type(c_ptr), intent(out) :: mspace
      type(c_ptr), intent(in), value :: mem
      integer(c_size_t), intent(in), value :: mem_size
    end subroutine

    ! ___________________ PRIF Queries ______________________

    module function caf_convert_base_addr(addr, image) result(ptr) bind(c)
      implicit none
      type(c_ptr), intent(in), value :: addr
      integer(c_int), intent(in), value :: image
      integer(c_intptr_t) :: ptr
    end function


    ! _______________________ Contiguous RMA ____________________________
    subroutine caf_put(image, dest, src, size) bind(c)
      !! void caf_put(int image, intptr_t dest, void* src, size_t size)
      import c_ptr, c_int, c_intptr_t, c_size_t
      implicit none
      integer(c_int), intent(in), value :: image
      integer(c_intptr_t), intent(in), value :: dest
      type(c_ptr), intent(in), value :: src
      integer(c_size_t), intent(in), value :: size
    end subroutine

    subroutine caf_get(image, dest, src, size) bind(c)
      !! void caf_get(int image, void* dest, intptr_t src, size_t size)
      import c_ptr, c_int, c_intptr_t, c_size_t
      implicit none
      integer(c_int), intent(in), value :: image
      type(c_ptr), intent(in), value :: dest
      integer(c_intptr_t), intent(in), value :: src
      integer(c_size_t), intent(in), value :: size
    end subroutine

    ! _______________________ Strided RMA ____________________________
    subroutine caf_put_strided(dims, image_num, remote_ptr, remote_stride, &
                               current_image_buffer, current_image_stride, &
                               element_size, extent) bind(c)
      !! void caf_put_strided(int dims, int image_num, 
      !!                      intptr_t remote_ptr, void* remote_stride, 
      !!                      void *current_image_buffer, void * current_image_stride, 
      !!                      size_t element_size, void *extent)
      import c_ptr, c_int, c_intptr_t, c_size_t
      implicit none
      integer(c_int), intent(in), value :: dims
      integer(c_int), intent(in), value :: image_num
      integer(c_intptr_t), intent(in), value :: remote_ptr
      type(c_ptr), intent(in), value :: remote_stride
      type(c_ptr), intent(in), value :: current_image_buffer
      type(c_ptr), intent(in), value :: current_image_stride
      integer(c_size_t), intent(in), value :: element_size
      type(c_ptr), intent(in), value :: extent
    end subroutine

    subroutine caf_get_strided(dims, image_num, remote_ptr, remote_stride, &
                               current_image_buffer, current_image_stride, &
                               element_size, extent) bind(c)
      !! void caf_get_strided(int dims, int image_num, 
      !!                      intptr_t remote_ptr, void* remote_stride, 
      !!                      void *current_image_buffer, void * current_image_stride, 
      !!                      size_t element_size, void *extent)
      import c_ptr, c_int, c_intptr_t, c_size_t
      implicit none
      integer(c_int), intent(in), value :: dims
      integer(c_int), intent(in), value :: image_num
      integer(c_intptr_t), intent(in), value :: remote_ptr
      type(c_ptr), intent(in), value :: remote_stride
      type(c_ptr), intent(in), value :: current_image_buffer
      type(c_ptr), intent(in), value :: current_image_stride
      integer(c_size_t), intent(in), value :: element_size
      type(c_ptr), intent(in), value :: extent
    end subroutine

    ! __________________ SYNC Statements _____________________

    module subroutine sync_init()
    end subroutine

    subroutine caf_sync_memory() bind(C)
      !! void caf_sync_memory();
    end subroutine

    subroutine caf_sync_team(team) bind(C)
      !! void caf_sync_team(gex_TM_t team);
       import c_ptr
       implicit none
       type(c_ptr), value :: team
    end subroutine

    ! _______________________ Events  ____________________________
    subroutine caf_event_post(image, event_var_ptr, segment_boundary, release_fence) bind(c)
      !! void caf_event_post(int image, intptr_t event_var_ptr, int segment_boundary, int release_fence)
      import c_int, c_intptr_t
      implicit none
      integer(c_int), intent(in), value :: image
      integer(c_intptr_t), intent(in), value :: event_var_ptr
      integer(c_int), intent(in), value :: segment_boundary
      integer(c_int), intent(in), value :: release_fence
    end subroutine

    subroutine caf_event_wait(event_var_ptr, threshold, segment_boundary, acquire_fence, maybe_concurrent) bind(c)
      !! void caf_event_wait(void *event_var_ptr, int64_t threshold, int segment_boundary, int acquire_fence, int maybe_concurrent)
      import c_int64_t, c_ptr, c_int
      implicit none
      type(c_ptr), intent(in), value :: event_var_ptr
      integer(c_int64_t), intent(in), value :: threshold
      integer(c_int), intent(in), value :: segment_boundary, acquire_fence, maybe_concurrent
    end subroutine

    subroutine caf_event_query(event_var_ptr, count) bind(c)
      !! void caf_event_query(void *event_var_ptr, int64_t *count)
      import c_int64_t, c_ptr
      implicit none
      type(c_ptr), intent(in), value :: event_var_ptr
      integer(c_int64_t), intent(out) :: count
    end subroutine

    ! _______________________ Atomics  ____________________________

    subroutine caf_atomic_int(opcode, image, addr, result, operand1, operand2) bind(c)
      !! void caf_atomic_int(int opcode, int image, void* addr, int64_t *result, int64_t op1, int64_t op2)
      import c_int, c_intptr_t, PRIF_ATOMIC_INT_KIND
      implicit none
      integer(c_int), intent(in), value :: opcode
      integer(c_int), intent(in), value :: image
      integer(c_intptr_t), intent(in), value :: addr
      integer(PRIF_ATOMIC_INT_KIND), intent(out) :: result
      integer(PRIF_ATOMIC_INT_KIND), intent(in), value :: operand1
      integer(PRIF_ATOMIC_INT_KIND), intent(in), value :: operand2
    end subroutine

    subroutine caf_atomic_logical(opcode, image, addr, result, operand1, operand2) bind(c)
      !! void caf_atomic_logical(int opcode, int image, void* addr, int64_t *result, int64_t op1, int64_t op2)
      import c_int, c_intptr_t, PRIF_ATOMIC_LOGICAL_KIND
      implicit none
      integer(c_int), intent(in), value :: opcode
      integer(c_int), intent(in), value :: image
      integer(c_intptr_t), intent(in), value :: addr
      logical(PRIF_ATOMIC_LOGICAL_KIND), intent(out) :: result
      logical(PRIF_ATOMIC_LOGICAL_KIND), intent(in), value :: operand1
      logical(PRIF_ATOMIC_LOGICAL_KIND), intent(in), value :: operand2
    end subroutine

    ! ______________ Collective Subroutines __________________

     subroutine caf_co_broadcast(a, source_image, Nelem, team) bind(C)
       !! void c_co_broadcast(CFI_cdesc_t * a_desc, int source_image, int num_elements, gex_TM_t team);
       import c_int, c_ptr
       implicit none
       type(*) a(..)
       integer(c_int), value :: source_image, Nelem
       type(c_ptr), value :: team
     end subroutine

     subroutine caf_co_broadcast_cptr(a_ptr, source_image, nbytes, team) bind(C)
       !! void caf_co_broadcast_cptr(void *a_ptr, int source_image, size_t nbytes, gex_TM_t team)
       import c_int, c_ptr, c_size_t
       implicit none
       type(c_ptr), value :: a_ptr
       integer(c_int), value :: source_image
       integer(c_size_t), value :: nbytes
       type(c_ptr), value :: team
     end subroutine

     subroutine caf_co_reduce(a, result_image, num_elements, op_wrapper, client_data, team) bind(C)
       !! void caf_co_reduce(CFI_cdesc_t* a_desc, int result_image, size_t num_elements, gex_Coll_ReduceFn_t op_wrapper, void* client_data, gex_TM_t team)
       import c_int, c_ptr, c_size_t, c_funptr
       implicit none
       type(*) a(..)
       integer(c_int), value :: result_image
       integer(c_size_t), value :: num_elements
       type(c_funptr), value :: op_wrapper
       type(c_ptr), value :: client_data
       type(c_ptr), value :: team
     end subroutine

     subroutine caf_co_reduce_cptr(a_ptr, result_image, num_elements, element_size, op_wrapper, client_data, team) bind(C)
       !! void caf_co_reduce_cptr(void *a_ptr, int result_image, size_t num_elements, size_t element_size, gex_Coll_ReduceFn_t op_wrapper, void* client_data, gex_TM_t team)
       import c_int, c_ptr, c_size_t, c_funptr
       implicit none
       type(c_ptr), value :: a_ptr
       integer(c_int), value :: result_image
       integer(c_size_t), value :: num_elements
       integer(c_size_t), value :: element_size
       type(c_funptr), value :: op_wrapper
       type(c_ptr), value :: client_data
       type(c_ptr), value :: team
     end subroutine

     subroutine caf_co_sum(a, result_image, num_elements, team) bind(C)
       !! void c_co_sum(CFI_cdesc_t* a_desc, int result_image, size_t num_elements, gex_TM_t team);
       import c_int, c_ptr, c_size_t
       implicit none
       type(*) a(..)
       integer(c_int), value :: result_image
       integer(c_size_t), value :: num_elements
       type(c_ptr), value :: team
     end subroutine

     subroutine caf_co_min(a, result_image, num_elements, team) bind(C)
       !! void c_co_min(CFI_cdesc_t* a_desc, int result_image, size_t num_elements, gex_TM_t team);
       import c_int, c_ptr, c_size_t
       implicit none
       type(*) a(..)
       integer(c_int), value :: result_image
       integer(c_size_t), value :: num_elements
       type(c_ptr), value :: team
     end subroutine

     subroutine caf_co_max(a, result_image, num_elements, team) bind(C)
       !! void c_co_max(CFI_cdesc_t* a_desc, int result_image, size_t num_elements, gex_TM_t team);
       import c_int, c_ptr, c_size_t
       implicit none
       type(*) a(..)
       integer(c_int), value :: result_image
       integer(c_size_t), value :: num_elements
       type(c_ptr), value :: team
     end subroutine

     subroutine caf_form_team(current_team, new_team, team_number, new_index) bind(C)
      !! void caf_form_team(gex_TM_t* current_team, gex_TM_t* new_team, int64_t team_number, int new_index);
      import c_ptr, c_int, c_int64_t
      type(c_ptr), intent(in), value :: current_team
      type(c_ptr), intent(out) :: new_team
      integer(c_int64_t), intent(in), value :: team_number
      integer(c_int), intent(in), value :: new_index
     end subroutine

    ! ______________ Misc helpers  __________________
     function caf_c_funloc_deref(funloc) result(res) bind(C)
       !! funloc_t caf_c_funloc_deref(funloc_t funloc)
       import c_funptr
       implicit none
       type(c_funptr), value :: funloc
       type(c_funptr) :: res
     end function

  end interface

  interface num_to_str
    module procedure num_to_str32
    module procedure num_to_str64
  end interface

contains

  pure function num_to_str32(num, is_mem_size) result(str)
    integer(c_int32_t), value :: num
    logical, intent(in), optional :: is_mem_size
    character(len=:), allocatable :: str
    
    str = num_to_str64(int(num, c_int64_t), is_mem_size)
  end function

  pure function num_to_str64(num, is_mem_size) result(str)
    integer(c_int64_t), value :: num
    logical, intent(in), optional :: is_mem_size
    character(len=:), allocatable :: str, unit
    character(len=40) num_str
    integer(c_int64_t) :: divisor

    if (present(is_mem_size)) then
    if (is_mem_size) then
      divisor = 1 
      ! Try to strike a compromise between digits and round off
#     define CAF_USE_DIV(div, unit_str)  \
        if ((num .ge. 10*div) .or. (num .ge. div .and. mod(num, div) == 0)) then ; \
          divisor = div; unit = unit_str; exit; \
        end if
      do
        CAF_USE_DIV(ishft(1_c_int64_t,40), " TiB")
        CAF_USE_DIV(ishft(1_c_int64_t,30), " GiB")
        CAF_USE_DIV(ishft(1_c_int64_t,20), " MiB")
        CAF_USE_DIV(ishft(1_c_int64_t,10), " KiB")
        CAF_USE_DIV(1_c_int64_t, " B");
        exit
      end do 
      num = num / divisor
#     undef CAF_USE_DIV
    end if
    end if

    write(num_str, '(i0)') num
    str = trim(adjustl(num_str))
    if (allocated(unit)) then
      str = str // unit
    end if
  end function

  pure function as_int(ptr)
    type(c_ptr), intent(in) :: ptr
    integer(c_intptr_t) :: as_int

    call_assert(storage_size(ptr) == storage_size(as_int))

    as_int = transfer(ptr, as_int)
  end function

  pure function as_c_ptr(i)
    integer(c_intptr_t), intent(in) :: i
    type(c_ptr) :: as_c_ptr

    as_c_ptr = transfer(i, as_c_ptr)
  end function

  ! cdp = "coarray descriptor pointer"
  function handle_to_cdp(coarray_handle) result(cdp)
    type(prif_coarray_handle), intent(in) :: coarray_handle
    type(prif_coarray_descriptor), pointer :: cdp
    call_assert(c_associated(coarray_handle%info))
    call c_f_pointer(coarray_handle%info, cdp)
  end function

  pure function cdp_to_handle(cdp) result(coarray_handle)
    type(prif_coarray_descriptor), pointer, intent(in) :: cdp
    type(prif_coarray_handle) :: coarray_handle
    call_assert(associated(cdp))
    coarray_handle%info = c_loc(cdp)
  end function

  subroutine base_pointer(coarray_handle, image_num, ptr)
    type(prif_coarray_handle), intent(in) :: coarray_handle
    integer(c_int), intent(in) :: image_num
    integer(c_intptr_t), intent(out) :: ptr
    type(prif_coarray_descriptor), pointer :: cdp

    call_assert(coarray_handle_check(coarray_handle))
    call_assert_describe(image_num > 0 .and. image_num <= initial_team%num_images, "base_pointer: image_num not within valid range")
    cdp => handle_to_cdp(coarray_handle)
    ptr = caf_convert_base_addr(cdp%coarray_data, image_num)
  end subroutine

  subroutine unimplemented(proc_name)
    character(len=*), intent(in) ::  proc_name
    call prif_error_stop(quiet=.false._c_bool, stop_code_char=proc_name // " is not yet implemented")
  end subroutine

  pure function optional_value(var) result(c_val)
    integer, intent(in), optional :: var
    integer(c_int) c_val
    if (present(var)) then
      c_val = var
    else
      c_val = 0_c_int
    end if
  end function

  pure subroutine compute_coshape_epp(lcobounds, ucobounds, coshape_epp)
    !! Compute the exclusive prefix product of the coshape for the given cobounds
    integer(c_int64_t), intent(in) :: lcobounds(:), ucobounds(:)
    integer(c_int), intent(out) :: coshape_epp(:)
    integer(c_int64_t) :: product
    integer :: d

    associate (corank => size(lcobounds))
      call_assert(corank > 0)
      call_assert(size(coshape_epp) == corank)
      call_assert(size(ucobounds) == corank .or. size(ucobounds) == corank-1)

      coshape_epp(1) = 1
      product = 1
      do d = 2, corank
        product = product * (ucobounds(d-1) - lcobounds(d-1) + 1)
        call_assert_describe(product < huge(0_c_int), "Overflow in cobounds. product(coshape(a)) must be < 2 billion")
        coshape_epp(d) = int(product, c_int)
      end do
    end associate
  end subroutine

  ! Report the provided error stat/msg using the provided optional stat/errmsg args
  subroutine report_error(report_stat, report_msg, stat, errmsg, errmsg_alloc)
    integer(c_int), intent(in) :: report_stat
    character(len=*), intent(in) :: report_msg
    integer(c_int), intent(out), optional :: stat
    character(len=*), intent(inout), optional :: errmsg
    character(len=:), intent(inout), allocatable , optional :: errmsg_alloc

    call_assert(report_stat /= 0)
    if (.not. present(stat)) then
      call prif_error_stop(.false._c_bool, stop_code_char=report_msg)
    else
      stat = report_stat
      if (present(errmsg)) then
        errmsg = report_msg
      else if (present(errmsg_alloc)) then
        errmsg_alloc = report_msg
      end if
    end if
  end subroutine

  ! verify state invariants for a coarray_handle
  ! Note this function validates invariants with deliberately UNconditional assertions
  ! Suggested caller usage for conditional validation is: 
  !   call_assert(coarray_handle_check(coarray_handle))
  elemental impure function coarray_handle_check(coarray_handle) result(result_)
    implicit none
    type(prif_coarray_handle), intent(in) :: coarray_handle
    logical :: result_
    integer(c_int) :: i, epp(15)
    type(prif_coarray_descriptor), pointer :: cdp

    call assert_always(c_associated(coarray_handle%info), "unassociated info pointer in prif_coarray_handle")
    cdp => handle_to_cdp(coarray_handle)
    associate(corank => cdp%corank)
      call assert_always(corank >= 1, "invalid corank in prif_coarray_handle")
      call assert_always(corank <= size(cdp%lcobounds), "invalid corank in prif_coarray_handle")
      call assert_always(all([(cdp%lcobounds(i) <= cdp%ucobounds(i), i = 1, corank-1)]), &
                         "invalid cobounds in prif_coarray_handle")
      call assert_always(cdp%coarray_size > 0, "invalid data size in prif_coarray_handle")
      call assert_always(c_associated(cdp%coarray_data), "invalid data pointer in prif_coarray_handle")
      call compute_coshape_epp(cdp%lcobounds(1:corank),cdp%ucobounds(1:corank-1),epp(1:corank))
      call assert_always(all(cdp%coshape_epp(1:corank) == epp(1:corank)), &
                         "invalid coshape_epp in prif_coarray_handle")
    end associate

    result_ = .true.
  end function

  ! verify state invariants for a team
  ! Note this function validates invariants with deliberately UNconditional assertions
  ! Suggested caller usage for conditional validation is: 
  !   call_assert(team_check(current_team))
  recursive function team_check(team, known_active, cycle_check) result(result_)
    implicit none
    type(prif_team_type), intent(in) :: team
    logical, optional, intent(in) :: known_active ! is this known to be the current team or an ancestor team?
    type(prif_team_type), optional, intent(in) :: cycle_check(:)
    type(prif_team_type), allocatable :: cycle_check_(:)
    logical :: result_, known_active_
    integer :: i

    call assert_always(associated(team%info), "unassociated info pointer in prif_team_type")

    ! check for invalid cycles in the team hierarchy
    if (.not. present(cycle_check)) then ! initial call
      cycle_check_ = [ team ]
    else ! recursive call should never encounter a matching team as an ancestor
      call assert_always(.not. any( [(associated(team%info, cycle_check(i)%info), i = 1, size(cycle_check))] ), &
           "Invalid cycle detected in team ancestor hierarchy")
      cycle_check_ = [ cycle_check, team ]
    end if

    associate(info => team%info, ch_info => team%info%child_heap_info)
      call assert_always(c_associated(info%gex_team), "invalid gex_team in team descriptor")

      if (associated(team%info, initial_team)) then ! initial team
        call assert_always(info%team_number == -1, "invalid team_number in initial team descriptor")
        call assert_always(.not. associated(info%parent_team), "invalid parent_team in initial team descriptor")
      else ! non-initial team, have parent team
        call assert_always(info%team_number > 0, "invalid team_number in non-initial team descriptor")
        call assert_always(associated(info%parent_team), "invalid parent_team in team descriptor")
      end if

      call assert_always(info%this_image == caf_this_image(info%gex_team), "invalid this_image in team descriptor")
      call assert_always(info%num_images == caf_num_images(info%gex_team), "invalid num_images in team descriptor")

      ! determine activity of this team (is it the current team or an ancestor of current)
      if (present(known_active)) then 
        known_active_ = known_active
      else
        known_active_ = .false.
      end if
      if (.not. known_active_) then
        if (associated(team%info, initial_team)) then
          known_active_ = .true.
        else if (associated(current_team%info)) then
          if (associated(team%info, current_team%info) .or. &
              associated(team%info, current_team%info%parent_team)) then
            known_active_ = .true.
          end if
        end if
      end if 

      if (known_active_) then
        call assert_always(info%heap_start /= 0, "invalid heap_start in an active team descriptor")
        call assert_always(info%heap_size > 0, "invalid heap_size in an active team descriptor")
        if (info%this_image == 1) then
          call assert_always(c_associated(info%heap_mspace), "invalid heap_mspace in an active team descriptor")
        end if
      end if

      if (associated(info%child_heap_info)) then ! have child teams
        if (info%this_image == 1) then
          call assert_always(c_associated(ch_info%allocated_memory), &
                            "invalid child_heap_info%allocated_memory in team descriptor")
          call assert_always(ch_info%offset == as_int(ch_info%allocated_memory) - info%heap_start, &
                            "invalid child_heap_info%offset in team descriptor")
        end if
        call assert_always(ch_info%size > 0, "invalid child_heap_info%size in team descriptor")
        call assert_always(ch_info%offset + ch_info%size <= info%heap_size, &
                          "invalid child_heap_info bounds in team descriptor")
      end if

      if (associated(info%coarrays)) then ! have coarrays
      block
        type(prif_coarray_descriptor), pointer :: cdp, cdp_next

        cdp => info%coarrays
        call assert_always(.not.c_associated(cdp%previous_handle), &
                           "invalid coarray head-of-list in team descriptor")
        do while (c_associated(cdp%next_handle))
          call c_f_pointer(cdp%next_handle, cdp_next)
          call assert_always(c_associated(cdp_next%previous_handle), &
                           "null coarray list linkage in team descriptor")
          call assert_always(c_associated(cdp_next%previous_handle, c_loc(cdp)), &
                           "invalid coarray list linkage in team descriptor")
          cdp => cdp_next
        end do
      end block
      end if

      if (associated(info%parent_team)) then ! recurse up the team tree
        result_ = team_check(prif_team_type(info%parent_team), known_active_, cycle_check_)
      end if
    end associate

    result_ = .true.
  end function

  subroutine caf_establish_child_heap
    if (current_team%info%this_image == 1) then
      call caf_allocate_remaining( &
          current_team%info%heap_mspace, &
          current_team%info%child_heap_info%allocated_memory, &
          current_team%info%child_heap_info%size)
      current_team%info%child_heap_info%offset = &
          as_int(current_team%info%child_heap_info%allocated_memory) - current_team%info%heap_start
    end if
    call prif_co_broadcast(current_team%info%child_heap_info, 1)
  end subroutine

  logical function caf_have_child_teams()
    caf_have_child_teams = associated(current_team%info%child_heap_info)
  end function

end submodule prif_private_s

program out_of_memory
  use iso_c_binding, only: c_bool, c_size_t, c_ptr, c_null_funptr, c_int64_t
  use prif
  implicit none

  integer :: init_exit_code, me, i
  integer(c_size_t) :: size_in_bytes = ishft(500_c_size_t, 40)
  type(c_ptr) :: allocated_memory
  logical :: coarray = .false.
  character(len=256) :: arg

  call prif_init(init_exit_code)
  if (init_exit_code /= 0 .and. init_exit_code /= PRIF_STAT_ALREADY_INIT) then
    call prif_error_stop(quiet=.false._c_bool, stop_code_char="program startup failed")
  end if
  call prif_this_image_no_coarray(this_image=me)

  do i = 1, command_argument_count()
    call get_command_argument(i, arg)
        
    if (trim(arg) == "--coarray" .or. trim(arg) == "-c") then
      coarray = .true.
    else
      read(arg, *) size_in_bytes
    end if
  end do  

  if (coarray) then
    if (me == 1) print *, "prif_allocate_coarray: ", size_in_bytes, " bytes"
    block
      integer(c_int64_t), dimension(1) :: lcobounds, ucobounds
      integer :: num_imgs
      type(prif_coarray_handle) :: coarray_handle
      
      call prif_num_images(num_images=num_imgs)
      lcobounds(1) = 1
      ucobounds(1) = num_imgs

      call prif_allocate_coarray( &
        lcobounds, ucobounds, size_in_bytes, c_null_funptr, &
        coarray_handle, allocated_memory)
    end block
  else
    if (me == 1) print *, "prif_allocate: ", size_in_bytes, " bytes"
    call prif_sync_all()
    call prif_allocate(size_in_bytes, allocated_memory)
  end if


  call prif_sync_all()
  call prif_error_stop(quiet=.false._c_bool, stop_code_char="test failed")

end program

module prif_co_max_test_m
  use iso_c_binding, only: c_int8_t, c_int16_t, c_int32_t, c_int64_t, c_float, c_double
  use prif, only : prif_co_max, prif_co_max_character, prif_this_image_no_coarray, prif_num_images
  use julienne_m, only: &
    operator(.all.) &
   ,operator(.approximates.) &
   ,operator(.within.) &
   ,operator(.equalsExpected.) &
   ,usher &
   ,test_description_t &
   ,test_diagnosis_t &
   ,test_result_t &
   ,test_t
    implicit none


    private
    public :: prif_co_max_test_t

    type, extends(test_t) :: prif_co_max_test_t
    contains
      procedure, nopass, non_overridable :: subject
      procedure, nopass, non_overridable :: results
    end type

contains

    pure function subject() result(test_subject)
      character(len=:), allocatable :: test_subject
      test_subject = "prif_co_max"
    end function

    function results() result(test_results)
      type(test_result_t), allocatable :: test_results(:)
      type(prif_co_max_test_t) prif_co_max_test

      allocate(test_results, source = prif_co_max_test%run([ &
         test_description_t("computing element-wise maxima for integer(c_int32_t) scalars", usher(check_32_bit_integer)) &
        ,test_description_t("computing element-wise maxima for a 1D default integer array", usher(check_default_integer)) &
        ,test_description_t("computing element-wise maxima for a 1D integer(c_int8_t) array", usher(check_8_bit_integer)) &
        ,test_description_t("computing element-wise maxima for a 1D integer(c_int16_t) array", usher(check_16_bit_integer)) &
        ,test_description_t("computing element-wise maxima for a 1D integer(c_int64_t) array", usher(check_64_bit_integer)) &
        ,test_description_t("computing element-wise maxima for a 2D real(c_float) array", usher(check_32_bit_real)) &
        ,test_description_t("computing element-wise maxima for a 1D real(c_double) array", usher(check_64_bit_real)) &
        ,test_description_t("computing element-wise maxima for character scalars", usher(check_character)) &
      ]))
    end function

    function check_default_integer() result(diag)
        type(test_diagnosis_t) :: diag

        integer, parameter :: values(*,*) = reshape([1, -19, 5, 13, 11, 7, 17, 3], [2, 4])
        integer :: me, ni, i
        integer, dimension(size(values,1)) :: my_val, expected

        call prif_this_image_no_coarray(this_image=me)
        call prif_num_images(ni)

        my_val = values(:, mod(me-1, size(values,2))+1)
        call prif_co_max(my_val)

        expected = maxval(reshape([(values(:, mod(i-1,size(values,2))+1), i = 1, ni)], [size(values,1),ni]), dim=2)
        diag = .all. (my_val .equalsExpected. expected)
    end function

    function check_8_bit_integer() result(diag)
        type(test_diagnosis_t) :: diag

        integer(c_int8_t), parameter :: values(*,*) = reshape(int([1, -19, 5, 13, 11, 7, 17, 3],c_int8_t), [2, 4])
        integer :: me, ni, i
        integer(c_int8_t), dimension(size(values,1)) :: my_val, expected

        call prif_this_image_no_coarray(this_image=me)
        call prif_num_images(ni)

        my_val = values(:, mod(me-1, size(values,2))+1)
        call prif_co_max(my_val)

        expected = maxval(reshape([(values(:, mod(i-1,size(values,2))+1), i = 1, ni)], [size(values,1),ni]), dim=2)
        diag = .all. (int(my_val) .equalsExpected. int(expected))
    end function

    function check_16_bit_integer() result(diag)
        type(test_diagnosis_t) :: diag

        integer(c_int16_t), parameter :: values(*,*) = reshape(int([1, -19, 5, 13, 11, 7, 17, 3],c_int16_t), [2, 4])
        integer :: me, ni, i
        integer(c_int16_t), dimension(size(values,1)) :: my_val, expected

        call prif_this_image_no_coarray(this_image=me)
        call prif_num_images(ni)

        my_val = values(:, mod(me-1, size(values,2))+1)
        call prif_co_max(my_val)

        expected = maxval(reshape([(values(:, mod(i-1,size(values,2))+1), i = 1, ni)], [size(values,1),ni]), dim=2)
        diag = .all. (int(my_val) .equalsExpected. int(expected))
    end function

    function check_32_bit_integer() result(diag)
        type(test_diagnosis_t) :: diag

        integer(c_int32_t), parameter :: values(*) = [1, -19, 5, 13, 11, 7, 17, 3]
        integer :: me, ni, i
        integer(c_int32_t) :: my_val, expected

        call prif_this_image_no_coarray(this_image=me)
        call prif_num_images(ni)

        my_val = values(mod(me-1, size(values))+1)
        call prif_co_max(my_val)

        expected = maxval([(values(mod(i-1,size(values))+1), i = 1, ni)])
        diag = my_val .equalsExpected. expected
    end function

    function check_64_bit_integer() result(diag)
        type(test_diagnosis_t) :: diag

        integer(c_int64_t), parameter :: values(*,*) = reshape([1, -19, 5, 13, 11, 7, 17, 3], [2, 4])
        integer :: me, ni, i
        integer(c_int64_t), dimension(size(values,1)) :: my_val, expected

        call prif_this_image_no_coarray(this_image=me)
        call prif_num_images(ni)

        my_val = values(:, mod(me-1, size(values,2))+1)
        call prif_co_max(my_val)

        expected = maxval(reshape([(values(:, mod(i-1,size(values,2))+1), i = 1, ni)], [size(values,1),ni]), dim=2)
        diag = .all. (my_val .equalsExpected. expected)
    end function

    function check_32_bit_real() result(diag)
        type(test_diagnosis_t) :: diag

        real(c_float), parameter :: values(*,*,*) = reshape([1, 19, 5, 13, 11, 7, 17, 3], [2,2,2])
        real(c_float), parameter :: tolerance = 0_c_float
        integer :: me, ni, i
        real(c_float), dimension(size(values,1), size(values,2)) :: my_val, expected

        call prif_this_image_no_coarray(this_image=me)
        call prif_num_images(ni)

        my_val = values(:, :, mod(me-1, size(values,3))+1)
        call prif_co_max(my_val)

        expected = maxval(reshape([(values(:,:,mod(i-1,size(values,3))+1), i = 1, ni)], [size(values,1), size(values,2), ni]), dim=3)
        diag = .all. (my_val .approximates. expected .within. tolerance)
    end function

    function check_64_bit_real() result(diag)
        type(test_diagnosis_t) :: diag

        real(c_double), parameter :: values(*,*) = reshape([1, 19, 5, 13, 11, 7, 17, 3], [2, 4])
        real(c_double), parameter :: tolerance = 0_c_double
        integer :: me, ni, i
        real(c_double), dimension(size(values,1)) :: my_val, expected

        call prif_this_image_no_coarray(this_image=me)
        call prif_num_images(ni)

        my_val = values(:, mod(me-1, size(values,2))+1)
        call prif_co_max(my_val)

        expected = maxval(reshape([(values(:, mod(i-1,size(values,2))+1), i = 1, ni)], [size(values,1),ni]), dim=2)
        diag = .all. (my_val .approximates. expected .within. tolerance)
    end function

    function check_character() result(diag)
        type(test_diagnosis_t) :: diag
        character(len=*), parameter :: values(*) = &
            [ "To be   ","or not  " &
            , "to      ","be.     " &
            , "that    ","is      " &
            , "the     ","question"]
        integer :: me, ni, i
        character(len=len(values)) :: my_val

        call prif_this_image_no_coarray(this_image=me)
        call prif_num_images(ni)

        my_val = values(mod(me-1, size(values))+1)
        call prif_co_max_character(my_val)

        ! issue #205: workaround flang optimizer bug with a temp
        associate(tmp => [(values(mod(i-1,size(values))+1), i = 1, ni)])
          diag = my_val .equalsExpected. maxval(tmp)
        end associate
    end function

end module prif_co_max_test_m

! Copyright (c), The Regents of the University of California
! Terms of use are as specified in LICENSE.txt

#include "assert_macros.h"
#include "caffeine-internal.h"

submodule(prif:prif_private_s) atomic_s
  ! DO NOT ADD USE STATEMENTS HERE
  ! All use statements belong in prif_private_s.F90
  implicit none

  ! placeholder variables that simplify the macro logic below
  integer(PRIF_ATOMIC_INT_KIND) :: out_placeholder_int
  logical(PRIF_ATOMIC_LOGICAL_KIND) :: out_placeholder_logical
  integer(PRIF_ATOMIC_INT_KIND), parameter :: in_placeholder_int = 0
  logical(PRIF_ATOMIC_LOGICAL_KIND), parameter :: in_placeholder_logical = .false.
contains

#define ATOMIC_OP(OPNAME, OPCODE, caf_op) \
  module procedure CAF_CONCAT2(prif_atomic_,OPNAME) ; \
    integer(c_intptr_t) :: remote_base; \
    call_assert(offset >= 0); \
    call base_pointer(coarray_handle, image_num, remote_base); \
    call CAF_CONCAT3(prif_atomic_,OPNAME,_indirect) \
      ( image_num, remote_base + offset, OPPASSF, stat ); \
  end procedure ; \
  module procedure CAF_CONCAT3(prif_atomic_,OPNAME,_indirect) ; \
    call_assert(c_sizeof(out_placeholder_int) == 8); call_assert(c_sizeof(out_placeholder_logical) == 8); \
    call_assert_describe(image_num > 0 .and. image_num <= initial_team%num_images, "image_num not within valid range"); \
    call caf_op(CAF_CONCAT2(CAF_OP_,OPCODE), image_num, atom_remote_ptr, OPPASSC); \
    if (present(stat)) stat = 0; \
  end procedure

! Extra arg below is another workaround gfortran's sub-standard preprocessor
#define ATOMIC_INT_OP(OPNAME,_,OPCODE) ATOMIC_OP(OPNAME,OPCODE,caf_atomic_int)
#define ATOMIC_LOG_OP(OPNAME,_,OPCODE) ATOMIC_OP(OPNAME,OPCODE,caf_atomic_logical)

! OPPASSF defines the dummy argument pass-thru in Fortran,
! from the direct module procedure to the indirect variant
#undef  OPPASSF
#define OPPASSF value
! OPPASSC defines the dummy argument pass-thru to C,
! from the indirect module procedure to the BIND(C) call
#undef  OPPASSC
#define OPPASSC value, in_placeholder_int, in_placeholder_int
  ATOMIC_INT_OP(ref_int,        ,GET)
#undef  OPPASSC
#define OPPASSC value, in_placeholder_logical, in_placeholder_logical
  ATOMIC_LOG_OP(ref_logical,    ,GET)
#undef  OPPASSC
#define OPPASSC out_placeholder_logical, value, in_placeholder_logical
  ATOMIC_LOG_OP(define_logical, ,SET)
#undef  OPPASSC
#define OPPASSC out_placeholder_int, value, in_placeholder_int
  ATOMIC_INT_OP(define_int,     ,SET)

  ATOMIC_INT_OP(add,            ,ADD)
  ATOMIC_INT_OP(and,            ,AND)
  ATOMIC_INT_OP(or,             ,OR)
  ATOMIC_INT_OP(xor,            ,XOR)

#undef  OPPASSF
#define OPPASSF value, old
#undef  OPPASSC
#define OPPASSC old, value, in_placeholder_int
  ATOMIC_INT_OP(fetch_add,      ,FADD)
  ATOMIC_INT_OP(fetch_and,      ,FAND)
  ATOMIC_INT_OP(fetch_or,       ,FOR)
  ATOMIC_INT_OP(fetch_xor,      ,FXOR)

#undef  OPPASSF
#define OPPASSF old, compare, new
#undef  OPPASSC
#define OPPASSC old, compare, new
  ATOMIC_INT_OP(cas_int,        ,FCAS)
  ATOMIC_LOG_OP(cas_logical,    ,FCAS)

end submodule atomic_s

program hello_world
  use iso_c_binding, only: c_bool
  use prif, only : &
     prif_init &
    ,prif_this_image_no_coarray &
    ,prif_num_images &
    ,prif_stop &
    ,prif_error_stop &
    ,PRIF_STAT_ALREADY_INIT
  implicit none

  integer :: init_exit_code, me, num_imgs
  logical(kind=c_bool), parameter :: false = .false._c_bool

  call prif_init(init_exit_code)
  if (init_exit_code /= 0 .and. init_exit_code /= PRIF_STAT_ALREADY_INIT) then
    call prif_error_stop(quiet=false, stop_code_char="program startup failed")
  end if

  call prif_this_image_no_coarray(this_image=me)
  call prif_num_images(num_images=num_imgs)
  print *, "Hello from image", me, "of", num_imgs

  call prif_stop(quiet=false)

end program

module prif_this_image_no_coarray_test_m
  use prif, only : prif_this_image_no_coarray, prif_num_images, prif_co_sum
  use julienne_m, only: &
     operator(//) &
    ,operator(.all.) &
    ,operator(.equalsExpected.) &
    ,usher &
    ,test_description_t &
    ,test_diagnosis_t &
    ,test_result_t &
    ,test_t
  implicit none

  private
  public :: prif_this_image_no_coarray_test_t

  type, extends(test_t) :: prif_this_image_no_coarray_test_t
  contains
    procedure, nopass, non_overridable :: subject
    procedure, nopass, non_overridable :: results
  end type

contains
  pure function subject() result(test_subject)
    character(len=:), allocatable :: test_subject
    test_subject = "prif_this_image_no_coarray"
  end function

  function results() result(test_results)
    type(test_result_t), allocatable :: test_results(:)
    type(prif_this_image_no_coarray_test_t) prif_this_image_no_coarray_test

    allocate(test_results, source = prif_this_image_no_coarray_test%run([ &
       test_description_t("returning a unique member of {1,...,num_images()} when called without arguments", usher(check_this_image_set)) &
    ]))
  end function

  function check_this_image_set() result(diag)
    type(test_diagnosis_t) :: diag
    integer, allocatable :: image_numbers(:)
    integer i, me, ni

    call prif_this_image_no_coarray(this_image=me)
    call prif_num_images(num_images=ni)
    allocate(image_numbers, source = [(merge(0, me, me/=i), i = 1, ni)])
    call prif_co_sum(image_numbers)
    diag = .all. (image_numbers .equalsExpected. [(i, i = 1, ni)]) // "correct image set"
  end function

end module prif_this_image_no_coarray_test_m

program register_stop_callback
    use iso_c_binding, only: c_bool, c_int
    use prif, only : &
       prif_init, &
       prif_register_stop_callback, &
       prif_stop, &
       prif_stop_callback_interface
    implicit none
  
    integer init_exit_code
    logical(kind=c_bool), parameter :: false = .false._c_bool
    ! use of the pointer is unnecessary according to the standard,
    ! but gfortran complains without it
    procedure(prif_stop_callback_interface), pointer :: callback_ptr
    callback_ptr => callback
  
    call prif_init(init_exit_code)
    call prif_register_stop_callback(callback_ptr)
    call prif_stop(false)
contains
    subroutine callback(is_error_stop, quiet, stop_code_int, stop_code_char)
        logical(c_bool), intent(in) :: is_error_stop, quiet
        integer(c_int), intent(in), optional :: stop_code_int
        character(len=*), intent(in), optional :: stop_code_char

        print *, "callback invoked"
    end subroutine
end program

program error_stop_with_integer_code
  use iso_c_binding, only: c_bool
  use prif, only : &
     prif_init &
    ,prif_stop &
    ,prif_error_stop
  use unit_test_parameters_m, only : expected_error_stop_code 
  implicit none

  integer init_exit_code
  logical(kind=c_bool), parameter :: true = .true._c_bool

  call prif_init(init_exit_code)
  call prif_error_stop(quiet=true, stop_code_int=expected_error_stop_code) ! a prif_error_stop unit test passes if this line executes error termination
  call prif_stop(quiet=true) ! a prif_error_stop unit tests fails if this line runs
end program

#!/bin/bash

set -e # exit on error

print_usage_info()
{
    cat <<'EOF'
Caffeine Installation Script

USAGE:
./install.sh [--help | [--prefix=PREFIX]

 --help             Display this help text
 --prefix=PREFIX    Install library into 'PREFIX' directory
 --network=<NET>    Build Caffeine to target given GASNet network conduit. 
                    <NET> should be one of:
                      smp: single-node shared-memory conduit (default)
                      udp: portable UDP/IP (for Ethernet networks)
                      ibv: InfiniBand IB Verbs
                      ofi: OpenFabrics Interfaces
                      ucx: Unified Communication X
 --prereqs          Display a list of prerequisite software.
                    Default prefix='\$HOME/.local/bin'
 --verbose          Show verbose build commands
 --yes              Assume (yes) to all prompts for non-interactive build

All unrecognized arguments will be passed to GASNet's configure.

Some influential environment variables:
  FC          Fortran compiler command
  FFLAGS      Fortran compiler flags
  CC          C compiler command
  CFLAGS      C compiler flags
  CPP         C preprocessor
  CPPFLAGS    C preprocessor flags, e.g. -I<include dir> if you have
              headers in a nonstandard directory <include dir>
  LDFLAGS     linker flags, e.g. -L<lib dir> if you have libraries in a
              nonstandard directory <lib dir>
  LIBS        libraries to pass to the linker, e.g. -l<library>
Use these variables to override the choices made by the installer or to help
it to find libraries and programs with nonstandard names/locations.

Report bugs to fortran@lbl.gov or at https://go.lbl.gov/caffeine

EOF
}

GASNET_VERSION="2025.8.0"
VERBOSE=""
GASNET_CONDUIT="${GASNET_CONDUIT:-smp}"
YES=false
APPEND_CFLAGS=""

list_prerequisites()
{
    cat << EOF
Caffeine and this installer were developed with the following prerequisites.
If any are missing and if permission is granted, the installer will install
the latest versions using Homebrew:

  LLVM flang
  GASNet-EX $GASNET_VERSION
  fpm
  git (used by fpm to clone dependencies)
  curl
  pkg-config
  realpath (Homebrew coreutils)
  GNU Make (Homebrew coreutils)

EOF
}

# GASNET_CONFIGURE_ARGS is deliberately inherited from the caller environment
GASNET_CONFIGURE_ARGS=${GASNET_CONFIGURE_ARGS:=}

while [ "$1" != "" ]; do
    orig_arg="$1"
    PARAM=$(echo "$1" | awk -F= '{print $1}')
    VALUE=$(echo "$1" | awk -F= '{print $2}')
    case $PARAM in
        -h | --help)
            print_usage_info
            exit
            ;;
        --prereqs)
            list_prerequisites
            exit
            ;;
        --prefix)
            PREFIX=$VALUE
            ;;
        --network)
            GASNET_CONDUIT=$(tr '[:upper:]' '[:lower:]' <<< $VALUE)
            case $GASNET_CONDUIT in
              smp|udp|mpi|ibv|ofi|ucx) ;;
              *) 
                 echo "ERROR: Unrecognized --network=$GASNET_CONDUIT"
                 print_usage_info
                 exit 1
            esac
            ;;
        --verbose)
            VERBOSE="--verbose"
            set -x
            ;;
        -y | --yes)
            YES="true"
            ;;
        *)
            # We pass the unmodified argument to GASNet configure
            # Quoting is believed sufficient for embedded whitespace but not quotes
            GASNET_CONFIGURE_ARGS+="${GASNET_CONFIGURE_ARGS+ }\"${orig_arg//\"/\\\"}\""
            ;;
    esac
    shift
done

# Early check for pre-installed Homebrew
BREW="${BREW:-brew}"
if command -v "$BREW" > /dev/null 2>&1; then
  BREW_PREFIX=`$BREW --prefix || exit 0`
  if [ -z ${BREW_PREFIX:+x} ] || [ ! -d "$BREW_PREFIX" ] ; then
    echo Warning: Failed to detect Homebrew prefix
    BREW_PREFIX=
  fi
fi

if [ -z ${FC:+x} ] || [ -z ${CC:+x} ]; then
  if command -v flang > /dev/null 2>&1; then
    FC=`which flang`
    echo "Setting FC=$FC"
    if [ -n "$BREW_PREFIX" ] && [[ $FC =~ $BREW_PREFIX ]] ; then
      # We are using Homebrew flang, so prefer Homebrew clang/clang++
      export PATH="$BREW_PREFIX/opt/llvm/bin:$PATH"
    fi
  fi
  if command -v clang > /dev/null 2>&1; then
    CC=`which clang`
    echo "Setting CC=$CC"
  fi
fi
if [ -n "$CC" ] && ! command -v "$CC" > /dev/null 2>&1; then
  echo "CC=$CC not found. If you don't yet have a C compiler, please leave environment variable CC unset."
  exit 1
fi
if [ -n "$FC" ] && ! command -v "$FC" > /dev/null 2>&1; then
  echo "FC=$FC not found. If you don't yet have a Fortran compiler, please leave environment variable FC unset."
  exit 1
fi
if [ -z ${CXX:+x} ] && [ -n "$CC" ] ; then 
  # C++ is an optional dependency
  # try to auto-detect from CC
  if [[ $(basename $CC) =~ clang ]] ; then 
    CXX_guess=clang++
  else
    CXX_guess=g++
  fi
  if [[ $CC =~ (-[0-9]+)$ ]] ; then 
    CXX_guess=${CXX_guess}${BASH_REMATCH[0]} 
  fi
  if command -v $CXX_guess > /dev/null 2>&1; then
    CXX=`which $CXX_guess`
    echo "Setting CXX=$CXX"
  fi
fi

set -u # error on use of undefined variable

if command -v pkg-config > /dev/null 2>&1; then
  PKG_CONFIG=`which pkg-config`
fi
  
if command -v realpath > /dev/null 2>&1; then
  REALPATH=`which realpath`
fi

if command -v make > /dev/null 2>&1; then
  MAKE=`which make`
fi

if command -v fpm > /dev/null 2>&1; then
  FPM=`which fpm`
fi

if ! command -v git > /dev/null 2>&1; then
  echo "git not found. Building Caffeine requires fpm, which uses git to download dependencies."
  echo "Please install git, ensure it is in your PATH, and rerun ./install.sh"
  exit 1
fi

if ! command -v curl > /dev/null 2>&1; then
  echo "curl not found. Please install curl, ensure it is in your PATH, and rerun ./install.sh"
  exit 1
fi

ask_permission_to_use_homebrew()
{
  cat << EOF

Either one or more of the environment variables FC and CC are unset or
one or more of the following packages are not in the PATH: pkg-config, realpath, make, fpm.
If you grant permission to install prerequisites, you will be prompted before each installation.

Press 'Enter' to choose the square-bracketed default answer:
EOF
  printf "Is it ok to use Homebrew to install prerequisite packages? [yes] "
}

ask_permission_to_install_homebrew()
{
  cat << EOF

Homebrew not found. Installing Homebrew requires sudo privileges.
If you grant permission to install Homebrew, you may be prompted to enter your password.

Press 'Enter' to choose the square-bracketed default answer:
EOF
  printf "Is it ok to download and install Homebrew? [yes] "
}

ask_permission_to_install_homebrew_package()
{
  echo ""
  if [ ! -z ${2+x} ]; then
    echo "Homebrew installs $1 collectively in one package named '$2'."
    echo ""
  fi
  printf "Is it ok to use Homebrew to install $1? [yes] "
}

CI=${CI:-"false"} # GitHub Actions workflows set CI=true

exit_if_user_declines()
{
  if [ $YES = true ]; then 
    echo " 'yes' assumed (--yes option)"
    return
  fi
  if [ $CI = true ]; then 
    echo " 'yes' assumed (GitHub Actions workflow detected)"
    return
  fi
  read answer
  if [ -n "$answer" -a "$answer" != "y" -a "$answer" != "Y" -a "$answer" != "Yes" -a "$answer" != "YES" -a "$answer" != "yes" ]; then
    echo "Installation declined."
    case ${1:-} in  
      *GASNet*) 
        echo "Please ensure the $pkg.pc file is in $PKG_CONFIG_PATH and then rerun './install.sh'." ;;
      *FC*) 
        echo "To use compilers other than Homebrew-installed LLVM flang and clang,"
        echo "please set the FC and CC environment variables and rerun './install.sh'." ;;
      *) 
        echo "Please ensure that $1 is installed and in your PATH and then rerun './install.sh'." ;;
    esac
    echo "Caffeine was not installed." 
    exit 1
  fi
}

DEPENDENCIES_DIR="build/dependencies"
if [ ! -d $DEPENDENCIES_DIR ]; then
  mkdir -p $DEPENDENCIES_DIR
fi

if [ -z ${FC:+x} ] || [ -z ${CC:+x} ] || [ -z ${PKG_CONFIG:+x} ] || [ -z ${REALPATH:+x} ] || [ -z ${MAKE:+x} ] || [ -z ${FPM:+x} ] ; then

  ask_permission_to_use_homebrew 
  exit_if_user_declines "brew"

  if ! command -v $BREW > /dev/null 2>&1; then

    ask_permission_to_install_homebrew
    exit_if_user_declines "brew"

    curl -L https://raw.githubusercontent.com/Homebrew/install/HEAD/install.sh -o $DEPENDENCIES_DIR/install-homebrew.sh --create-dirs
    chmod u+x $DEPENDENCIES_DIR/install-homebrew.sh

    if [ -p /dev/stdin ] && [ $CI = false ]; then
	   cat << EOF

Pipe detected.  Installing Homebrew requires sudo privileges, which most likely will
not work if you are installing non-interactively, e.g., via 'yes | ./install.sh'.
To install Caffeine non-interactiely, please rerun the Caffeine installer after
executing the following command to install Homebrew:
"./$DEPENDENCIES_DIR/install-homebrew.sh"
EOF
       exit 1
    else
      ./$DEPENDENCIES_DIR/install-homebrew.sh
      rm $DEPENDENCIES_DIR/install-homebrew.sh
    fi

    if [ $(uname) = "Linux" ]; then
      BREW=/home/linuxbrew/.linuxbrew/bin/brew
      eval "$($BREW shellenv)"
    fi
  fi

  BREW_PREFIX=`$BREW --prefix || exit 0`
  if [ -z ${BREW_PREFIX:+x} ] || [ ! -d "$BREW_PREFIX" ] ; then
    echo Failed to detect Homebrew prefix
    echo 1
  fi

  # fetch the latest package definitions:
  $BREW update

  if [ -z ${FC:+x} ] || [ -z ${CC:+x} ] ; then
    ask_permission_to_install_homebrew_package "'llvm' and 'flang'"
    exit_if_user_declines "FC"
    $BREW install llvm flang

    # Homebrew does not inject clang/clang++ into PATH on macOS
    export PATH="$BREW_PREFIX/opt/llvm/bin:$PATH"
    CC=`which clang`
    CXX=`which clang++`
    FC=`which flang-new`
    for tool in $CC $CXX $FC ; do
      if ! command -v $tool > /dev/null 2>&1 ; then
        echo Failed to detect Homebrew compiler install at $tool
        exit 1
      fi
    done
  fi

  if [ -z ${REALPATH:+x} ] || [ -z ${MAKE:+x} ] ; then
    ask_permission_to_install_homebrew_package "'realpath' and 'make'" "coreutils"
    exit_if_user_declines "realpath and make"
    $BREW install coreutils
    REALPATH=`which realpath`
    MAKE=`which make`
  fi

  if [ -z ${PKG_CONFIG:+x} ]; then
    ask_permission_to_install_homebrew_package "'pkg-config'"
    exit_if_user_declines "pkg-config"
    $BREW install pkg-config
    PKG_CONFIG=`which pkg-config`
  fi

  if [ -z ${FPM:+x} ] ; then
    ask_permission_to_install_homebrew_package "'fpm'"
    exit_if_user_declines "fpm"
    $BREW install fpm
    FPM=`which fpm`
  fi
fi

PREFIX=${PREFIX:-"${HOME}/.local"}
mkdir -p "$PREFIX"
PREFIX=`$REALPATH "$PREFIX"`
echo "PREFIX=$PREFIX"

if [ -z ${PKG_CONFIG_PATH:+x} ]; then
  PKG_CONFIG_PATH="$PREFIX/lib/pkgconfig"
else
  PKG_CONFIG_PATH="$PREFIX/lib/pkgconfig:$PKG_CONFIG_PATH"
fi
echo "PKG_CONFIG_PATH=$PKG_CONFIG_PATH"

FPM_FC="$($REALPATH $(command -v $FC))"
if [[ $FPM_FC == *flang* ]]; then
  FPM_FC=${FPM_FC/flang-[1-9][0-9]*/flang-new}
fi
FPM_CC="$($REALPATH $(command -v $CC))"

# workaround issue #228: clang cannot find Homebrew flang's C header
if [ "${BREW_PREFIX:-unset}" != unset ] ; then
  if [[ $FPM_FC =~ flang ]] && [[ $FPM_FC =~ $BREW_PREFIX ]] ; then
    APPEND_CFLAGS="-I$(dirname $(find "$BREW_PREFIX/Cellar/flang" -name ISO_Fortran_binding.h | head -1))"
  fi
fi

ask_package_permission()
{
  cat << EOF

$1 not found in $2

Press 'Enter' for the square-bracketed default answer:
EOF
  printf "Is it ok to download and install $1? [yes] "
}

pkg="gasnet-$GASNET_CONDUIT-seq"
export PKG_CONFIG_PATH

if ! $PKG_CONFIG $pkg ; then
  ask_package_permission "GASNet-EX" "PKG_CONFIG_PATH"
  exit_if_user_declines "GASNet-EX"

  GASNET_TAR_FILE="GASNet-$GASNET_VERSION.tar.gz"
  GASNET_SOURCE_URL="https://bitbucket.org/berkeleylab/gasnet/downloads/GASNet-$GASNET_VERSION.tar.gz"
  if [ ! -d $DEPENDENCIES_DIR ]; then
    mkdir -pv $DEPENDENCIES_DIR
  fi
  GASNET_DIR=$DEPENDENCIES_DIR/GASNet-$GASNET_VERSION
  if [ -d $GASNET_DIR ]; then
    # clean any existing GASNet build dir we are overwriting
    rm -Rf $GASNET_DIR
  fi
  
  curl -L $GASNET_SOURCE_URL | tar xvzf - -C $DEPENDENCIES_DIR
  
  ( 
      cd $GASNET_DIR
      cmd="set -x ; ./configure --prefix=\"$PREFIX\""
      # user-provided overrides:
      cmd="$cmd $GASNET_CONFIGURE_ARGS"
      # pass-thru compiler settings:
      cmd="$cmd --with-cc=\"$CC\" --with-cxx=\"$CXX\""
      # select the GASNet config settings Caffeine requires, and disable unused features:
      cmd="$cmd --enable-$GASNET_CONDUIT"
      cmd="$cmd --enable-seq --disable-par --disable-parsync"
      cmd="$cmd --disable-segment-everything"
      # TEMPORARY: disable MPI compatibility until we figure out how to support in fpm
      cmd="$cmd --disable-mpi-compat"
      eval $cmd
      $MAKE -j 8 all
      $MAKE -j 8 install
  )
fi # if ! $PKG_CONFIG $pkg ; then

exit_if_pkg_config_pc_file_missing()
{
  if ! $PKG_CONFIG $1 ; then
    echo "$1.pc pkg-config file not found"
    exit 1
  fi
}

exit_if_pkg_config_pc_file_missing "$pkg"

GASNET_LDFLAGS="`$PKG_CONFIG $pkg --variable=GASNET_LDFLAGS`"
GASNET_LIBS="`$PKG_CONFIG $pkg --variable=GASNET_LIBS`"
GASNET_CC="`$PKG_CONFIG $pkg --variable=GASNET_CC`"
GASNET_CFLAGS="`$PKG_CONFIG $pkg --variable=GASNET_CFLAGS`"
GASNET_CPPFLAGS="`$PKG_CONFIG $pkg --variable=GASNET_CPPFLAGS`"

# Check whether GASNet was installed using Spack. If yes, bail out.
# Note: relies on the fact that most Spack installations have "opt/spack"
#       in the directory path, and assumes that the first directory returned
#       by pkg-config contains the GASNet lib directory
GASNET_LIBDIR="$(echo $GASNET_LIBS | awk '{print $1};')"
GASNET_LIBDIR=${GASNET_LIBDIR#-L}
case "$GASNET_LIBDIR" in
  *spack* )
	cat << EOF
***NOTICE***: The GASNet library built by Spack is ONLY intended for
unit-testing purposes, and is generally UNSUITABLE FOR PRODUCTION USE.
The RECOMMENDED way to build GASNet is as an embedded library as configured
by the higher-level client runtime package (i.e. Caffeine), including
system-specific configuration. Exiting install.sh
EOF
    exit 1
    ;;
  * )
    GASNET_PREFIX=$(dirname $GASNET_LIBDIR)
    if [ ! -r "$GASNET_PREFIX/include/gasnetex.h" ] ; then
      echo "ERROR: Failed to detect GASNet install prefix from $GASNET_LIBS"
      exit 1
    fi
    ;; 
esac

# Strip compiler flags
# Warning: This assumes the full path doesn't contain any spaces!
GASNET_CC_STRIPPED="$(echo $GASNET_CC | awk '{print $1};')"
GASNET_CC_REAL="$($REALPATH $GASNET_CC_STRIPPED)"

if [ "$GASNET_CC_REAL" != "$FPM_CC" ]; then 
  echo "GASNET_CC=$GASNET_CC_REAL" and  "FPM_CC=$FPM_CC don't match"
  exit 1;
fi

FPM_TOML="fpm.toml"
rm -f $FPM_TOML
echo "# DO NOT EDIT OR COMMIT -- Created by caffeine/install.sh" > $FPM_TOML
cat manifest/fpm.toml.template >> $FPM_TOML
GASNET_LIB_LOCATIONS=`echo $GASNET_LIBS | awk '{locs=""; for(i = 1; i <= NF; i++) if ($i ~ /^-L/) {locs=(locs " " $i);}; print locs; }'`
GASNET_LIB_NAMES=`echo $GASNET_LIBS | awk '{names=""; for(i = 1; i <= NF; i++) if ($i ~ /^-l/) {names=(names " " $i);}; print names; }' | sed 's/-l//g'`
if [[ $GASNET_CONDUIT == "udp" ]] ; then
  GASNET_LIB_NAMES+=" stdc++" # udp-conduit requires C++ libraries
fi
FPM_TOML_LINK_ENTRY="link = [\"$(echo ${GASNET_LIB_NAMES} | sed 's/ /", "/g')\"]"
echo "${FPM_TOML_LINK_ENTRY}" >> $FPM_TOML

CAFFEINE_PC="$PREFIX/lib/pkgconfig/caffeine.pc"
cat << EOF > $CAFFEINE_PC
CAFFEINE_FPM_LDFLAGS=$GASNET_LDFLAGS $GASNET_LIB_LOCATIONS
CAFFEINE_FPM_FC=$FPM_FC
CAFFEINE_FPM_CC=$GASNET_CC
CAFFEINE_FPM_CFLAGS=$GASNET_CFLAGS $GASNET_CPPFLAGS $APPEND_CFLAGS
Name: caffeine
Description: The CoArray Fortran Framework of Efficient Interfaces to Network Environments (Caffeine) implements the Parallel Runtime Interface for Fortran (PRIF), providing runtime support for multi-image features in modern Fortran compilers.
URL: https://go.lbl.gov/caffeine
Version: 0.7.2
EOF

exit_if_pkg_config_pc_file_missing "caffeine"

user_compiler_flags="${CPPFLAGS:-} ${FFLAGS:-}"

compiler_version=$($FPM_FC --version)
if [[ $compiler_version =~ 'flang' ]]; then
  compiler_flag="-g -O3"
elif [[ $compiler_version =~ 'GNU Fortran' ]]; then
  compiler_flag="-g -O3 -ffree-line-length-0 -Wno-unused-dummy-argument"
elif [[ $compiler_version =~ 'LFortran' ]]; then
  compiler_flag="-g -O3 --cpp"
else # unknown compiler
  compiler_flag="-g -O2"
  echo "WARNING: Failed to detect a recognized Fortran compiler"
fi
# enable Assert's multi-image support with PRIF callbacks provided by libcaffeine
compiler_flag+=" -DASSERT_MULTI_IMAGE -DASSERT_PARALLEL_CALLBACKS"
# enable Julienne's multi-image support with PRIF callbacks provided by julienne-driver
compiler_flag+=" -DHAVE_MULTI_IMAGE_SUPPORT -DJULIENNE_PARALLEL_CALLBACKS"

if ! [[ "$user_compiler_flags " =~ -[DU]ASSERTIONS[=\ ] ]] ; then 
  # default to enabling assertions, unless the command line sets a relevant flag
  compiler_flag+=" -DASSERTIONS"
fi

GASNET_CONDUIT_UPPER=$(tr '[:lower:]' '[:upper:]' <<<$GASNET_CONDUIT)
compiler_flag+=" -DCAF_NETWORK_$GASNET_CONDUIT_UPPER"

# Should come last to allow command-line overrides
compiler_flag+=" $user_compiler_flags"

case $GASNET_CONDUIT in
  ibv|ofi|ucx) 
    GASNET_RUNNER_ARG="${GASNET_RUNNER_ARG:-$GASNET_PREFIX/bin/gasnetrun_$GASNET_CONDUIT -n \${CAF_IMAGES:-2}}"
  ;;
  udp)
    GASNET_RUNNER_ARG="${GASNET_RUNNER_ARG:-$GASNET_PREFIX/bin/amudprun -n \${CAF_IMAGES:-2}}"
  ;;
  mpi)
    GASNET_RUNNER_ARG="${GASNET_RUNNER_ARG:-mpirun -n \${CAF_IMAGES:-2}}"
  ;;
  smp)
    GASNET_RUNNER_ARG="${GASNET_RUNNER_ARG:-env GASNET_PSHM_NODES=\${CAF_IMAGES:-\${GASNET_PSHM_NODES:-}}}"
  ;;
  *)
    GASNET_RUNNER_ARG="${GASNET_RUNNER_ARG:-}"
  ;;
esac

RUN_FPM_SH="run-fpm.sh"
cat << EOF > $RUN_FPM_SH
#!/bin/sh
#-- DO NOT EDIT -- created by caffeine/install.sh
fpm="${FPM}"
FPM_DRIVER=\${FPM_DRIVER:-\`realpath \$0\`}
export FPM_DRIVER
fpm_sub_cmd=\$1; shift
if echo "--help -help --version -version --list -list new update list clean publish" | grep -w -q -e "\$fpm_sub_cmd" ; then
  set -x
  exec \$fpm "\$fpm_sub_cmd" "\$@"
elif echo "build test run install" | grep -w -q -e "\$fpm_sub_cmd" ; then
  sed -i.bak 's/^link = .*\$/$FPM_TOML_LINK_ENTRY/' $FPM_TOML
  rm -f $FPM_TOML.bak # issue 282: this is the only portable way to use sed -i
  if test -n "$GASNET_RUNNER_ARG" && echo "test run" | grep -w -q -e "\$fpm_sub_cmd" ; then
    set -- "--runner=$GASNET_RUNNER_ARG" "\$@"
  fi
  set -x
  exec \$fpm "\$fpm_sub_cmd" \\
  --profile debug \\
  --flag "$compiler_flag" \\
  --compiler "`$PKG_CONFIG caffeine --variable=CAFFEINE_FPM_FC`"   \\
  --c-compiler "`$PKG_CONFIG caffeine --variable=CAFFEINE_FPM_CC`" \\
  --c-flag "`$PKG_CONFIG caffeine --variable=CAFFEINE_FPM_CFLAGS`" \\
  --link-flag "`$PKG_CONFIG caffeine --variable=CAFFEINE_FPM_LDFLAGS`" \\
  "\$@"
else
  echo "ERROR: Unrecognized fpm subcommand \$fpm_sub_cmd"
  \$fpm list
  exit 1
fi
EOF
chmod u+x $RUN_FPM_SH
# for backwards-compatibility of instructions/scripting:
( cd build && ln -f -s ../$RUN_FPM_SH run-fpm.sh )

./$RUN_FPM_SH build $VERBOSE

LIBCAFFEINE_DST=libcaffeine-$GASNET_CONDUIT.a
LIBCAFFEINE_SRC=$(./$RUN_FPM_SH install --list 2>/dev/null | grep libcaffeine | cut -d' ' -f2)

if [ -z "$LIBCAFFEINE_SRC" ]; then
  echo "ERROR: Failed to detect libcaffeine.a from fpm"
  exit 1
else
  mkdir -p "$PREFIX/lib"
  cp -af "$LIBCAFFEINE_SRC" "$PREFIX/lib/$LIBCAFFEINE_DST"
  ln -sf "$LIBCAFFEINE_DST" "$PREFIX/lib/libcaffeine.a"
fi

cat << EOF

________________ Caffeine has been dispensed! ________________

Caffeine is now installed in $PREFIX

To rebuild or to run tests or examples via the Fortran Package
Manager (fpm) with the required compiler/linker flags, pass a
fpm command to the run-fpm.sh script. For example, run
the program example/hello.f90 as follows:

./$RUN_FPM_SH run --example hello
EOF

# Implementation Status

Caffeine is an implementation of the Parallel Runtime Interface for Fortran (PRIF). This document
outlines the implementation status in Caffeine of the features defined in the
[latest PRIF specification, revision 0.8](https://doi.org/10.25344/S4Z88F). 
Caffeine contains interfaces for all of the PRIF procedures (except when stated
otherwise below) and the symbols are linkable and callable, but a few
procedures may fail at runtime with an unimplemented error. 
For more details about the implementation of the various PRIF features, please see the following sections:

- [Named Constants](#Named-Constants)
- [Program Startup and Shutdown](#Program-Startup-and-Shutdown)
- [Image Queries](#Image-Queries)
- [Storage Management](#Storage-Management)
- [Coarray Queries](#Coarray-Queries)
- [Contiguous Coarray Access](#Contiguous-Coarray-Access)
- [Strided Coarray Access](#Strided-Coarray-Access)
- [SYNC Statements](#SYNC-Statements)
- [Locks and Unlocks](#Locks-and-Unlocks)
- [Critical](#Critical)
- [Events and Notifications](#Events-and-Notifications)
- [Teams](#teams)
- [Collectives](#Collectives)
- [Atomic Memory Operations](#Atomic-Memory-Operations)

The priorites for feature implementation and addressing known defects are communicated by
the labels in the Caffeine [issue tracker](https://github.com/BerkeleyLab/caffeine/issues).

## Named Constants

Caffeine contains definitions for all of the PRIF-relevant constants from `ISO_FORTRAN_ENV` and for
all of the PRIF-specific constants.
Configuration settings (`CAF_IMPORT_*` preprocessor defines) can optionally be used to import
selected constant values from `ISO_FORTRAN_ENV` of the hosting compiler.

## Program Startup and Shutdown

| Procedure | Status | Notes |
|-----------|--------|-------|
| `prif_init` | **YES** |  |
| `prif_stop`, `prif_error_stop` | **YES** |  |
| `prif_fail_image` | **YES** | trivial implementation |
| `prif_register_stop_callback` | **YES** |  |


---

## Image Queries

| Procedure | Status | Notes |
|-----------|--------|-------|
| `prif_num_images`                   | **YES** |  |
| `prif_num_images_with_team`         | **YES** |  |
| `prif_num_images_with_team_number`  | *partial* | no support for sibling teams |
| `prif_this_image_no_coarray`        | **YES** |  |
| `prif_this_image_with_coarray`, `prif_this_image_with_dim`  | **YES** |  |
| `prif_failed_images`                | **YES** |  |
| `prif_stopped_images`               | **YES** |  |
| `prif_image_status`                 | **YES** |  |

---

## Storage Management

| Procedure | Status | Notes |
|-----------|--------|-------|
| `prif_allocate_coarray`    | **YES** | includes ucobound relaxation and `final_func` argument rename in PRIF 0.8 |
| `prif_allocate`            | **YES** |  |
| `prif_deallocate_coarray`  | **YES** |  |
| `prif_deallocate_coarrays` | **YES** |  |
| `prif_deallocate`          | **YES** |  |
| `prif_alias_create`        | **YES** | includes ucobound relaxation added in PRIF 0.8 |
| `prif_alias_destroy`       | **YES** |  |

---

## Coarray Queries

| Procedure | Status | Notes |
|-----------|--------|-------|
| `prif_set_context_data`, `prif_get_context_data` | **YES** |  |
| `prif_size_bytes`                                | **YES** |  |
| `prif_lcobound_no_dim`, `prif_lcobound_with_dim` | **YES** |  |
| `prif_ucobound_no_dim`, `prif_ucobound_with_dim` | **YES** |  |
| `prif_coshape`                                   | **YES** |  |
| `prif_local_data_pointer`                        | **YES** |  |
| `prif_image_index`                               | **YES** |  |
| `prif_image_index_with_team`                     | **YES** |  |
| `prif_image_index_with_team_number`              | *partial* | no support for sibling teams |
| `prif_initial_team_index`                        | **YES** | |
| `prif_initial_team_index_with_team`              | **YES** | |
| `prif_initial_team_index_with_team_number`       | *partial* | no support for sibling teams |

---

## Contiguous Coarray Access

| Procedure | Status | Notes |
|-----------|--------|-------|
| `prif_get`                               | **YES** |  |
| `prif_get_indirect`                      | **YES** |  |
| `prif_put`                               | **YES** |  |
| `prif_put_indirect`                      | **YES** |  |
| `prif_put_with_notify`                   | **YES** |  |
| `prif_put_with_notify_indirect`          | **YES** |  |
| `prif_put_indirect_with_notify`          | **YES** |  |
| `prif_put_indirect_with_notify_indirect` | **YES** |  |

---

## Strided Coarray Access

| Procedure | Status | Notes |
|-----------|--------|-------|
| `prif_get_strided`                               | **YES** |  |
| `prif_get_strided_indirect`                      | **YES** |  |
| `prif_put_strided`                               | **YES** |  |
| `prif_put_strided_indirect`                      | **YES** |  |
| `prif_put_strided_with_notify`                   | **YES** |  |
| `prif_put_strided_with_notify_indirect`          | **YES** |  |
| `prif_put_strided_indirect_with_notify`          | **YES** |  |
| `prif_put_strided_indirect_with_notify_indirect` | **YES** |  |

---

## SYNC Statements

| Procedure | Status | Notes |
|-----------|--------|-------|
| `prif_sync_memory` | **YES** |  |
| `prif_sync_all`    | **YES** |  |
| `prif_sync_images` | **YES** |  |
| `prif_sync_team`   | **YES** |  |

---

## Locks and Unlocks
### Support = no

<!---
| Procedure | Status | Notes |
|-----------|--------|-------|
| `prif_lock`            | no  |  |
| `prif_lock_indirect`   | no  |  |
| `prif_unlock`          | no  |  |
| `prif_unlock_indirect` | no  |  |
-->

---

## Critical
### Support = no

<!---
| Procedure | Status | Notes |
|-----------|--------|-------|
| `prif_critical`     | no  |  |
| `prif_end_critical` | no  |  |
-->

---

## Events and Notifications

| Procedure | Status | Notes |
|-----------|--------|-------|
| `prif_event_post`          | **YES** |  |
| `prif_event_post_indirect` | **YES** |  |
| `prif_event_wait`          | **YES** |  |
| `prif_event_query`         | **YES** |  |
| `prif_notify_wait`         | **YES** |  |

---

## Teams

| Procedure | Status | Notes |
|-----------|--------|-------|
| `prif_form_team`   | **YES**   |  |
| `prif_get_team`    | **YES**   |  |
| `prif_team_number` | **YES**   |  |
| `prif_change_team` | **YES**   |  |
| `prif_end_team`    | **YES**   |  |

---

## Collectives

| Procedure | Status | Notes |
|-----------|--------|-------|
| `prif_co_broadcast`     | **YES** |  |
| `prif_co_broadcast_cptr`| **YES** | New in PRIF 0.8 |
| `prif_co_max`           | **YES** |  |
| `prif_co_max_character` | **YES** |  |
| `prif_co_min`           | **YES** |  |
| `prif_co_min_character` | **YES** |  |
| `prif_co_sum`           | **YES** |  |
| `prif_co_reduce`        | **YES** |  |
| `prif_co_reduce_cptr`   | **YES** | New in PRIF 0.8 |

---

## Atomic Memory Operations

| Procedure | Status | Notes |
|-----------|--------|-------|
| `prif_atomic_add`                     | **YES** |  |
| `prif_atomic_add_indirect`            | **YES** |  |
| `prif_atomic_and`                     | **YES** |  |
| `prif_atomic_and_indirect`            | **YES** |  |
| `prif_atomic_or`                      | **YES** |  |
| `prif_atomic_or_indirect`             | **YES** |  |
| `prif_atomic_xor`                     | **YES** |  |
| `prif_atomic_xor_indirect`            | **YES** |  |
| `prif_atomic_cas_int`                 | **YES** |  |
| `prif_atomic_cas_int_indirect`        | **YES** |  |
| `prif_atomic_cas_logical`             | **YES** |  |
| `prif_atomic_cas_logical_indirect`    | **YES** |  |
| `prif_atomic_fetch_add`               | **YES** |  |
| `prif_atomic_fetch_add_indirect`      | **YES** |  |
| `prif_atomic_fetch_and`               | **YES** |  |
| `prif_atomic_fetch_and_indirect`      | **YES** |  |
| `prif_atomic_fetch_or`                | **YES** |  |
| `prif_atomic_fetch_or_indirect`       | **YES** |  |
| `prif_atomic_fetch_xor`               | **YES** |  |
| `prif_atomic_fetch_xor_indirect`      | **YES** |  |
| `prif_atomic_define_int`              | **YES** |  |
| `prif_atomic_define_int_indirect`     | **YES** |  |
| `prif_atomic_define_logical`          | **YES** |  |
| `prif_atomic_define_logical_indirect` | **YES** |  |
| `prif_atomic_ref_int`                 | **YES** |  |
| `prif_atomic_ref_int_indirect`        | **YES** |  |
| `prif_atomic_ref_logical`             | **YES** |  |
| `prif_atomic_ref_logical_indirect`    | **YES** |  |

---

Contributing to Caffeine
--------------------------

## Reporting Defects or Suggesting Features

If you encounter problems or limitations when installing or using Caffeine, please do the following:

 1. Search the Caffeine [issues](https://github.com/berkeleylab/caffeine/issues), including [closed issues].
    If your search finds a report of the same problem, please post a comment in the issue.
 2. Email the Caffeine [mailing list](mailto:fortran@lbl.gov) for advice.
 3. If steps 1 or 2 do not resolve the problem, please file a [new issue] including
    - [ ] The Fortran compiler and compiler version used with Caffeine,
    - [ ] The complete output of the install and build commands run with `--verbose` argument,
    - [ ] The Caffeine version number or commit hash,
    - [ ] Any conditions required to reproduce the problem such as
      - [ ] The output of `uname -a` showing the operating system (OS), OS version, and processor architecture,
      - [ ] The number of images executed (e.g., the output of `echo $CAF_IMAGES`),
      - [ ] The command used to run your program (e.g., `./run-fpm.sh run`), and
      - [ ] A minimal reproducer: if possible, fewer than 50 lines demonstrating an issue.

## Contributing Code or Documentation

We welcome help with diagnosing, isolating and fixing problems or adding features!
All contributions are governed by the Caffeine [LICENSE.txt](./LICENSE.txt).
To contribute, please follow these steps:

- [ ] First please follow the [above steps](#reporting-defects-or-suggesting-features) and include a description of your proposed contribution.
- [ ] Fork the Caffeine repository into your GitHub account
- [ ] Create a new local branch for your work. 
- [ ] Name your branch according to the issue created.  For example `fix-issue-53` or `issue-53-feature`.
- [ ] Follow the coding conventions in [docs/README-maintainers.md](./docs/README-maintainers.md).
- [ ] Make your commits logically atomic, self-consistent, and cohesive.
- [ ] Add one or more unit tests in the `test` subdirectory to verify your fix or feature.
- [ ] Ensure that your branch passes all tests (via `./run-fpm.sh test` with appropriate flags).
- [ ] Update the [README.md](./README.md) if your branch affects anything described there.
- [ ] Push your branch to your fork.
- [ ] Open a [Pull Request](https://github.com/berkeleylab/caffeine/pulls) (PR) against an existing branch of the Berkeley Lab [Caffeine repository](https://github.com/berkeleylab/caffeine). 
- [ ] Please include the corresponding issue number in the PR title.
- [ ] If your PR is not ready for merging, please click the downward arrow next to the "Create pull request" button and select the "Create draft pull request" option before submitting.
- [ ] Watch for CI results on your PR and address any failures.
- [ ] Please be patient and responsive to comments on your PR.

## Current and Past Contributors

Caffeine is an open-source project and welcomes community participation in the development process.
Notable current and past contributors include:

* [Dan Bonachea](https://go.lbl.gov/dan-bonachea)
  [@bonachea](https://github.com/bonachea)
  [![View ORCID record] 0000-0002-0724-9349](https://orcid.org/0000-0002-0724-9349)

* [Katherine Rasmussen](https://go.lbl.gov/katherine-rasmussen)
  [@ktras](https://github.com/ktras)
  [![View ORCID record] 0000-0001-7974-1853](https://orcid.org/0000-0001-7974-1853)

* [Brad Richardson](https://everythingfunctional.com/)
  [@everythingfunctional](https://github.com/everythingfunctional)
  [![View ORCID record] 0000-0002-3205-2169](https://orcid.org/0000-0002-3205-2169)

* [Damian Rouson](https://go.lbl.gov/damian-rouson) 
  [@rouson](https://github.com/rouson)
  [![View ORCID record] 0000-0002-2344-868X](https://orcid.org/0000-0002-2344-868X)


You can also browse the [full list of repository contributors](https://github.com/BerkeleyLab/caffeine/graphs/contributors).

---

[Long or Frequently Used URLs]: #
[View ORCID record]: https://github.com/BerkeleyLab/caffeine/wiki/img/ORCID-small.png
[closed issues]: https://github.com/berkeleylab/caffeine/issues?q=is%3Aissue+is%3Aclosed
[new issue]: https://github.com/berkeleylab/caffeine/issues/new
